# API Reference <a name="API Reference" id="api-reference"></a>


## Structs <a name="Structs" id="Structs"></a>

### MonorepoUpgradeDepsOptions <a name="MonorepoUpgradeDepsOptions" id="@aws-prototyping-sdk/nx-monorepo.MonorepoUpgradeDepsOptions"></a>

Configuration for Monorepo Upgrade Deps task.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/nx-monorepo.MonorepoUpgradeDepsOptions.Initializer"></a>

```typescript
import { MonorepoUpgradeDepsOptions } from '@aws-prototyping-sdk/nx-monorepo'

const monorepoUpgradeDepsOptions: MonorepoUpgradeDepsOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.MonorepoUpgradeDepsOptions.property.syncpackConfig">syncpackConfig</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig">SyncpackConfig</a></code> | Syncpack configuration. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.MonorepoUpgradeDepsOptions.property.taskName">taskName</a></code> | <code>string</code> | Name of the task to create. |

---

##### `syncpackConfig`<sup>Optional</sup> <a name="syncpackConfig" id="@aws-prototyping-sdk/nx-monorepo.MonorepoUpgradeDepsOptions.property.syncpackConfig"></a>

```typescript
public readonly syncpackConfig: SyncpackConfig;
```

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig">SyncpackConfig</a>
- *Default:* SyncpackConfig.DEFAULT_CONFIG

Syncpack configuration.

No merging is performed and as such a complete syncpackConfig is required if supplied.

---

##### `taskName`<sup>Optional</sup> <a name="taskName" id="@aws-prototyping-sdk/nx-monorepo.MonorepoUpgradeDepsOptions.property.taskName"></a>

```typescript
public readonly taskName: string;
```

- *Type:* string
- *Default:* upgrade-deps

Name of the task to create.

---

### NxConfiguratorOptions <a name="NxConfiguratorOptions" id="@aws-prototyping-sdk/nx-monorepo.NxConfiguratorOptions"></a>

NXConfigurator options.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/nx-monorepo.NxConfiguratorOptions.Initializer"></a>

```typescript
import { NxConfiguratorOptions } from '@aws-prototyping-sdk/nx-monorepo'

const nxConfiguratorOptions: NxConfiguratorOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfiguratorOptions.property.defaultReleaseBranch">defaultReleaseBranch</a></code> | <code>string</code> | Branch that NX affected should run against. |

---

##### `defaultReleaseBranch`<sup>Optional</sup> <a name="defaultReleaseBranch" id="@aws-prototyping-sdk/nx-monorepo.NxConfiguratorOptions.property.defaultReleaseBranch"></a>

```typescript
public readonly defaultReleaseBranch: string;
```

- *Type:* string

Branch that NX affected should run against.

---

### NxJsonConfiguration <a name="NxJsonConfiguration" id="@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration"></a>

> [https://github.com/nrwl/nx/blob/master/packages/nx/src/config/nx-json.ts](https://github.com/nrwl/nx/blob/master/packages/nx/src/config/nx-json.ts)

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.Initializer"></a>

```typescript
import { Nx } from '@aws-prototyping-sdk/nx-monorepo'

const nxJsonConfiguration: Nx.NxJsonConfiguration = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.affected">affected</a></code> | <code>@aws-prototyping-sdk/nx-monorepo.Nx.INxAffectedConfig</code> | Default options for `nx affected`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.defaultProject">defaultProject</a></code> | <code>string</code> | Default project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.extends">extends</a></code> | <code>string</code> | Some presets use the extends property to hide some default options in a separate json file. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.namedInputs">namedInputs</a></code> | <code>{[ key: string ]: string[]}</code> | Named inputs. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.npmScope">npmScope</a></code> | <code>string</code> | Tells Nx what prefix to use when generating library imports. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.plugins">plugins</a></code> | <code>string[]</code> | Plugins for extending the project graph. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.pluginsConfig">pluginsConfig</a></code> | <code>{[ key: string ]: any}</code> | Configuration for Nx Plugins. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.targetDefaults">targetDefaults</a></code> | <code>{[ key: string ]: @aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget}</code> | Dependencies between different target names across all projects. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.tasksRunnerOptions">tasksRunnerOptions</a></code> | <code>{[ key: string ]: any}</code> | Available Task Runners. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.workspaceLayout">workspaceLayout</a></code> | <code>@aws-prototyping-sdk/nx-monorepo.Nx.IWorkspaceLayout</code> | Where new apps + libs should be placed. |

---

##### `affected`<sup>Optional</sup> <a name="affected" id="@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.affected"></a>

```typescript
public readonly affected: INxAffectedConfig;
```

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.INxAffectedConfig

Default options for `nx affected`.

---

##### `defaultProject`<sup>Optional</sup> <a name="defaultProject" id="@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.defaultProject"></a>

```typescript
public readonly defaultProject: string;
```

- *Type:* string

Default project.

When project isn't provided, the default project
will be used. Convenient for small workspaces with one main application.

---

##### `extends`<sup>Optional</sup> <a name="extends" id="@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.extends"></a>

```typescript
public readonly extends: string;
```

- *Type:* string
- *Default:* "nx/presets/npm.json"

Some presets use the extends property to hide some default options in a separate json file.

The json file specified in the extends property is located in your node_modules folder.
The Nx preset files are specified in the nx package.

---

##### `namedInputs`<sup>Optional</sup> <a name="namedInputs" id="@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.namedInputs"></a>

```typescript
public readonly namedInputs: {[ key: string ]: string[]};
```

- *Type:* {[ key: string ]: string[]}

Named inputs.

> [https://nx.dev/reference/nx-json#inputs-&-namedinputs](https://nx.dev/reference/nx-json#inputs-&-namedinputs)

---

##### `npmScope`<sup>Optional</sup> <a name="npmScope" id="@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.npmScope"></a>

```typescript
public readonly npmScope: string;
```

- *Type:* string

Tells Nx what prefix to use when generating library imports.

---

##### `plugins`<sup>Optional</sup> <a name="plugins" id="@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.plugins"></a>

```typescript
public readonly plugins: string[];
```

- *Type:* string[]

Plugins for extending the project graph.

---

##### `pluginsConfig`<sup>Optional</sup> <a name="pluginsConfig" id="@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.pluginsConfig"></a>

```typescript
public readonly pluginsConfig: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

Configuration for Nx Plugins.

---

##### `targetDefaults`<sup>Optional</sup> <a name="targetDefaults" id="@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.targetDefaults"></a>

```typescript
public readonly targetDefaults: {[ key: string ]: IProjectTarget};
```

- *Type:* {[ key: string ]: @aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget}

Dependencies between different target names across all projects.

> [https://nx.dev/reference/nx-json#target-defaults](https://nx.dev/reference/nx-json#target-defaults)

---

##### `tasksRunnerOptions`<sup>Optional</sup> <a name="tasksRunnerOptions" id="@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.tasksRunnerOptions"></a>

```typescript
public readonly tasksRunnerOptions: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

Available Task Runners.

---

##### `workspaceLayout`<sup>Optional</sup> <a name="workspaceLayout" id="@aws-prototyping-sdk/nx-monorepo.Nx.NxJsonConfiguration.property.workspaceLayout"></a>

```typescript
public readonly workspaceLayout: IWorkspaceLayout;
```

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.IWorkspaceLayout

Where new apps + libs should be placed.

---

### NxMonorepoJavaOptions <a name="NxMonorepoJavaOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions"></a>

Configuration options for the NxMonorepoJavaProject.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.Initializer"></a>

```typescript
import { NxMonorepoJavaOptions } from '@aws-prototyping-sdk/nx-monorepo'

const nxMonorepoJavaOptions: NxMonorepoJavaOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.name">name</a></code> | <code>string</code> | This is the name of your project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.commitGenerated">commitGenerated</a></code> | <code>boolean</code> | Whether to commit the managed files by default. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.gitIgnoreOptions">gitIgnoreOptions</a></code> | <code>projen.IgnoreFileOptions</code> | Configuration options for .gitignore file. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.gitOptions">gitOptions</a></code> | <code>projen.GitOptions</code> | Configuration options for git. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.logging">logging</a></code> | <code>projen.LoggerOptions</code> | Configure logging options such as verbosity. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.outdir">outdir</a></code> | <code>string</code> | The root directory of the project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.parent">parent</a></code> | <code>projen.Project</code> | The parent project, if this project is part of a bigger project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenCommand">projenCommand</a></code> | <code>string</code> | The shell command to use in order to run the projen CLI. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenrcJson">projenrcJson</a></code> | <code>boolean</code> | Generate (once) .projenrc.json (in JSON). Set to `false` in order to disable .projenrc.json generation. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenrcJsonOptions">projenrcJsonOptions</a></code> | <code>projen.ProjenrcJsonOptions</code> | Options for .projenrc.json. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.renovatebot">renovatebot</a></code> | <code>boolean</code> | Use renovatebot to handle dependency upgrades. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.renovatebotOptions">renovatebotOptions</a></code> | <code>projen.RenovatebotOptions</code> | Options for renovatebot. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.autoApproveOptions">autoApproveOptions</a></code> | <code>projen.github.AutoApproveOptions</code> | Enable and configure the 'auto approve' workflow. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.autoMerge">autoMerge</a></code> | <code>boolean</code> | Enable automatic merging on GitHub. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.autoMergeOptions">autoMergeOptions</a></code> | <code>projen.github.AutoMergeOptions</code> | Configure options for automatic merging on GitHub. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.clobber">clobber</a></code> | <code>boolean</code> | Add a `clobber` task which resets the repo to origin. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.devContainer">devContainer</a></code> | <code>boolean</code> | Add a VSCode development environment (used for GitHub Codespaces). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.github">github</a></code> | <code>boolean</code> | Enable GitHub integration. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.githubOptions">githubOptions</a></code> | <code>projen.github.GitHubOptions</code> | Options for GitHub integration. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.gitpod">gitpod</a></code> | <code>boolean</code> | Add a Gitpod development environment. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.mergify">mergify</a></code> | <code>boolean</code> | Whether mergify should be enabled on this repository or not. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.mergifyOptions">mergifyOptions</a></code> | <code>projen.github.MergifyOptions</code> | Options for mergify. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projectType">projectType</a></code> | <code>projen.ProjectType</code> | Which type of project this is (library/app). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenCredentials">projenCredentials</a></code> | <code>projen.github.GithubCredentials</code> | Choose a method of providing GitHub API access for projen workflows. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenTokenSecret">projenTokenSecret</a></code> | <code>string</code> | The name of a secret which includes a GitHub Personal Access Token to be used by projen workflows. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.readme">readme</a></code> | <code>projen.SampleReadmeProps</code> | The README setup. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.stale">stale</a></code> | <code>boolean</code> | Auto-close of stale issues and pull request. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.staleOptions">staleOptions</a></code> | <code>projen.github.StaleOptions</code> | Auto-close stale issues and pull requests. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.vscode">vscode</a></code> | <code>boolean</code> | Enable VSCode integration. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.artifactId">artifactId</a></code> | <code>string</code> | The artifactId is generally the name that the project is known by. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.groupId">groupId</a></code> | <code>string</code> | This is generally unique amongst an organization or a project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.version">version</a></code> | <code>string</code> | This is the last piece of the naming puzzle. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.description">description</a></code> | <code>string</code> | Description of a project is always good. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.packaging">packaging</a></code> | <code>string</code> | Project packaging format. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.url">url</a></code> | <code>string</code> | The URL, like the name, is not required. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.compileOptions">compileOptions</a></code> | <code>projen.java.MavenCompileOptions</code> | Compile options. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.deps">deps</a></code> | <code>string[]</code> | List of runtime dependencies for this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.distdir">distdir</a></code> | <code>string</code> | Final artifact output directory. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.junit">junit</a></code> | <code>boolean</code> | Include junit tests. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.junitOptions">junitOptions</a></code> | <code>projen.java.JunitOptions</code> | junit options. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.packagingOptions">packagingOptions</a></code> | <code>projen.java.MavenPackagingOptions</code> | Packaging options. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenrcJava">projenrcJava</a></code> | <code>boolean</code> | Use projenrc in java. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenrcJavaOptions">projenrcJavaOptions</a></code> | <code>projen.java.ProjenrcOptions</code> | Options related to projenrc in java. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.testDeps">testDeps</a></code> | <code>string[]</code> | List of test dependencies for this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.sample">sample</a></code> | <code>boolean</code> | Include sample code and test if the relevant directories don't exist. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.sampleJavaPackage">sampleJavaPackage</a></code> | <code>string</code> | The java package to use for the code sample. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.defaultReleaseBranch">defaultReleaseBranch</a></code> | <code>string</code> | *No description.* |

---

##### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* $BASEDIR

This is the name of your project.

---

##### `commitGenerated`<sup>Optional</sup> <a name="commitGenerated" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.commitGenerated"></a>

```typescript
public readonly commitGenerated: boolean;
```

- *Type:* boolean
- *Default:* true

Whether to commit the managed files by default.

---

##### `gitIgnoreOptions`<sup>Optional</sup> <a name="gitIgnoreOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.gitIgnoreOptions"></a>

```typescript
public readonly gitIgnoreOptions: IgnoreFileOptions;
```

- *Type:* projen.IgnoreFileOptions

Configuration options for .gitignore file.

---

##### `gitOptions`<sup>Optional</sup> <a name="gitOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.gitOptions"></a>

```typescript
public readonly gitOptions: GitOptions;
```

- *Type:* projen.GitOptions

Configuration options for git.

---

##### `logging`<sup>Optional</sup> <a name="logging" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.logging"></a>

```typescript
public readonly logging: LoggerOptions;
```

- *Type:* projen.LoggerOptions
- *Default:* {}

Configure logging options such as verbosity.

---

##### `outdir`<sup>Optional</sup> <a name="outdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.outdir"></a>

```typescript
public readonly outdir: string;
```

- *Type:* string
- *Default:* "."

The root directory of the project.

Relative to this directory, all files are synthesized.

If this project has a parent, this directory is relative to the parent
directory and it cannot be the same as the parent or any of it's other
sub-projects.

---

##### `parent`<sup>Optional</sup> <a name="parent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.parent"></a>

```typescript
public readonly parent: Project;
```

- *Type:* projen.Project

The parent project, if this project is part of a bigger project.

---

##### `projenCommand`<sup>Optional</sup> <a name="projenCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenCommand"></a>

```typescript
public readonly projenCommand: string;
```

- *Type:* string
- *Default:* "npx projen"

The shell command to use in order to run the projen CLI.

Can be used to customize in special environments.

---

##### `projenrcJson`<sup>Optional</sup> <a name="projenrcJson" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenrcJson"></a>

```typescript
public readonly projenrcJson: boolean;
```

- *Type:* boolean
- *Default:* false

Generate (once) .projenrc.json (in JSON). Set to `false` in order to disable .projenrc.json generation.

---

##### `projenrcJsonOptions`<sup>Optional</sup> <a name="projenrcJsonOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenrcJsonOptions"></a>

```typescript
public readonly projenrcJsonOptions: ProjenrcJsonOptions;
```

- *Type:* projen.ProjenrcJsonOptions
- *Default:* default options

Options for .projenrc.json.

---

##### `renovatebot`<sup>Optional</sup> <a name="renovatebot" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.renovatebot"></a>

```typescript
public readonly renovatebot: boolean;
```

- *Type:* boolean
- *Default:* false

Use renovatebot to handle dependency upgrades.

---

##### `renovatebotOptions`<sup>Optional</sup> <a name="renovatebotOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.renovatebotOptions"></a>

```typescript
public readonly renovatebotOptions: RenovatebotOptions;
```

- *Type:* projen.RenovatebotOptions
- *Default:* default options

Options for renovatebot.

---

##### `autoApproveOptions`<sup>Optional</sup> <a name="autoApproveOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.autoApproveOptions"></a>

```typescript
public readonly autoApproveOptions: AutoApproveOptions;
```

- *Type:* projen.github.AutoApproveOptions
- *Default:* auto approve is disabled

Enable and configure the 'auto approve' workflow.

---

##### `autoMerge`<sup>Optional</sup> <a name="autoMerge" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.autoMerge"></a>

```typescript
public readonly autoMerge: boolean;
```

- *Type:* boolean
- *Default:* true

Enable automatic merging on GitHub.

Has no effect if `github.mergify`
is set to false.

---

##### `autoMergeOptions`<sup>Optional</sup> <a name="autoMergeOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.autoMergeOptions"></a>

```typescript
public readonly autoMergeOptions: AutoMergeOptions;
```

- *Type:* projen.github.AutoMergeOptions
- *Default:* see defaults in `AutoMergeOptions`

Configure options for automatic merging on GitHub.

Has no effect if
`github.mergify` or `autoMerge` is set to false.

---

##### `clobber`<sup>Optional</sup> <a name="clobber" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.clobber"></a>

```typescript
public readonly clobber: boolean;
```

- *Type:* boolean
- *Default:* true, but false for subprojects

Add a `clobber` task which resets the repo to origin.

---

##### `devContainer`<sup>Optional</sup> <a name="devContainer" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.devContainer"></a>

```typescript
public readonly devContainer: boolean;
```

- *Type:* boolean
- *Default:* false

Add a VSCode development environment (used for GitHub Codespaces).

---

##### `github`<sup>Optional</sup> <a name="github" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.github"></a>

```typescript
public readonly github: boolean;
```

- *Type:* boolean
- *Default:* true

Enable GitHub integration.

Enabled by default for root projects. Disabled for non-root projects.

---

##### `githubOptions`<sup>Optional</sup> <a name="githubOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.githubOptions"></a>

```typescript
public readonly githubOptions: GitHubOptions;
```

- *Type:* projen.github.GitHubOptions
- *Default:* see GitHubOptions

Options for GitHub integration.

---

##### `gitpod`<sup>Optional</sup> <a name="gitpod" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.gitpod"></a>

```typescript
public readonly gitpod: boolean;
```

- *Type:* boolean
- *Default:* false

Add a Gitpod development environment.

---

##### ~~`mergify`~~<sup>Optional</sup> <a name="mergify" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.mergify"></a>

- *Deprecated:* use `githubOptions.mergify` instead

```typescript
public readonly mergify: boolean;
```

- *Type:* boolean
- *Default:* true

Whether mergify should be enabled on this repository or not.

---

##### ~~`mergifyOptions`~~<sup>Optional</sup> <a name="mergifyOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.mergifyOptions"></a>

- *Deprecated:* use `githubOptions.mergifyOptions` instead

```typescript
public readonly mergifyOptions: MergifyOptions;
```

- *Type:* projen.github.MergifyOptions
- *Default:* default options

Options for mergify.

---

##### ~~`projectType`~~<sup>Optional</sup> <a name="projectType" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projectType"></a>

- *Deprecated:* no longer supported at the base project level

```typescript
public readonly projectType: ProjectType;
```

- *Type:* projen.ProjectType
- *Default:* ProjectType.UNKNOWN

Which type of project this is (library/app).

---

##### `projenCredentials`<sup>Optional</sup> <a name="projenCredentials" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenCredentials"></a>

```typescript
public readonly projenCredentials: GithubCredentials;
```

- *Type:* projen.github.GithubCredentials
- *Default:* use a personal access token named PROJEN_GITHUB_TOKEN

Choose a method of providing GitHub API access for projen workflows.

---

##### ~~`projenTokenSecret`~~<sup>Optional</sup> <a name="projenTokenSecret" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenTokenSecret"></a>

- *Deprecated:* use `projenCredentials`

```typescript
public readonly projenTokenSecret: string;
```

- *Type:* string
- *Default:* "PROJEN_GITHUB_TOKEN"

The name of a secret which includes a GitHub Personal Access Token to be used by projen workflows.

This token needs to have the `repo`, `workflows`
and `packages` scope.

---

##### `readme`<sup>Optional</sup> <a name="readme" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.readme"></a>

```typescript
public readonly readme: SampleReadmeProps;
```

- *Type:* projen.SampleReadmeProps
- *Default:* { filename: 'README.md', contents: '# replace this' }

The README setup.

---

*Example*

```typescript
"{ filename: 'readme.md', contents: '# title' }"
```


##### `stale`<sup>Optional</sup> <a name="stale" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.stale"></a>

```typescript
public readonly stale: boolean;
```

- *Type:* boolean
- *Default:* false

Auto-close of stale issues and pull request.

See `staleOptions` for options.

---

##### `staleOptions`<sup>Optional</sup> <a name="staleOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.staleOptions"></a>

```typescript
public readonly staleOptions: StaleOptions;
```

- *Type:* projen.github.StaleOptions
- *Default:* see defaults in `StaleOptions`

Auto-close stale issues and pull requests.

To disable set `stale` to `false`.

---

##### `vscode`<sup>Optional</sup> <a name="vscode" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.vscode"></a>

```typescript
public readonly vscode: boolean;
```

- *Type:* boolean
- *Default:* true

Enable VSCode integration.

Enabled by default for root projects. Disabled for non-root projects.

---

##### `artifactId`<sup>Required</sup> <a name="artifactId" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.artifactId"></a>

```typescript
public readonly artifactId: string;
```

- *Type:* string
- *Default:* "my-app"

The artifactId is generally the name that the project is known by.

Although
the groupId is important, people within the group will rarely mention the
groupId in discussion (they are often all be the same ID, such as the
MojoHaus project groupId: org.codehaus.mojo). It, along with the groupId,
creates a key that separates this project from every other project in the
world (at least, it should :) ). Along with the groupId, the artifactId
fully defines the artifact's living quarters within the repository. In the
case of the above project, my-project lives in
$M2_REPO/org/codehaus/mojo/my-project.

---

##### `groupId`<sup>Required</sup> <a name="groupId" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.groupId"></a>

```typescript
public readonly groupId: string;
```

- *Type:* string
- *Default:* "org.acme"

This is generally unique amongst an organization or a project.

For example,
all core Maven artifacts do (well, should) live under the groupId
org.apache.maven. Group ID's do not necessarily use the dot notation, for
example, the junit project. Note that the dot-notated groupId does not have
to correspond to the package structure that the project contains. It is,
however, a good practice to follow. When stored within a repository, the
group acts much like the Java packaging structure does in an operating
system. The dots are replaced by OS specific directory separators (such as
'/' in Unix) which becomes a relative directory structure from the base
repository. In the example given, the org.codehaus.mojo group lives within
the directory $M2_REPO/org/codehaus/mojo.

---

##### `version`<sup>Required</sup> <a name="version" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string
- *Default:* "0.1.0"

This is the last piece of the naming puzzle.

groupId:artifactId denotes a
single project but they cannot delineate which incarnation of that project
we are talking about. Do we want the junit:junit of 2018 (version 4.12), or
of 2007 (version 3.8.2)? In short: code changes, those changes should be
versioned, and this element keeps those versions in line. It is also used
within an artifact's repository to separate versions from each other.
my-project version 1.0 files live in the directory structure
$M2_REPO/org/codehaus/mojo/my-project/1.0.

---

##### `description`<sup>Optional</sup> <a name="description" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string
- *Default:* undefined

Description of a project is always good.

Although this should not replace
formal documentation, a quick comment to any readers of the POM is always
helpful.

---

##### `packaging`<sup>Optional</sup> <a name="packaging" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.packaging"></a>

```typescript
public readonly packaging: string;
```

- *Type:* string
- *Default:* "jar"

Project packaging format.

---

##### `url`<sup>Optional</sup> <a name="url" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.url"></a>

```typescript
public readonly url: string;
```

- *Type:* string
- *Default:* undefined

The URL, like the name, is not required.

This is a nice gesture for
projects users, however, so that they know where the project lives.

---

##### `compileOptions`<sup>Optional</sup> <a name="compileOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.compileOptions"></a>

```typescript
public readonly compileOptions: MavenCompileOptions;
```

- *Type:* projen.java.MavenCompileOptions
- *Default:* defaults

Compile options.

---

##### `deps`<sup>Optional</sup> <a name="deps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.deps"></a>

```typescript
public readonly deps: string[];
```

- *Type:* string[]
- *Default:* []

List of runtime dependencies for this project.

Dependencies use the format: `<groupId>/<artifactId>@<semver>`

Additional dependencies can be added via `project.addDependency()`.

---

##### `distdir`<sup>Optional</sup> <a name="distdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.distdir"></a>

```typescript
public readonly distdir: string;
```

- *Type:* string
- *Default:* "dist/java"

Final artifact output directory.

---

##### `junit`<sup>Optional</sup> <a name="junit" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.junit"></a>

```typescript
public readonly junit: boolean;
```

- *Type:* boolean
- *Default:* true

Include junit tests.

---

##### `junitOptions`<sup>Optional</sup> <a name="junitOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.junitOptions"></a>

```typescript
public readonly junitOptions: JunitOptions;
```

- *Type:* projen.java.JunitOptions
- *Default:* defaults

junit options.

---

##### `packagingOptions`<sup>Optional</sup> <a name="packagingOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.packagingOptions"></a>

```typescript
public readonly packagingOptions: MavenPackagingOptions;
```

- *Type:* projen.java.MavenPackagingOptions
- *Default:* defaults

Packaging options.

---

##### `projenrcJava`<sup>Optional</sup> <a name="projenrcJava" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenrcJava"></a>

```typescript
public readonly projenrcJava: boolean;
```

- *Type:* boolean
- *Default:* true

Use projenrc in java.

This will install `projen` as a java dependency and will add a `synth` task which
will compile & execute `main()` from `src/main/java/projenrc.java`.

---

##### `projenrcJavaOptions`<sup>Optional</sup> <a name="projenrcJavaOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.projenrcJavaOptions"></a>

```typescript
public readonly projenrcJavaOptions: ProjenrcOptions;
```

- *Type:* projen.java.ProjenrcOptions
- *Default:* default options

Options related to projenrc in java.

---

##### `testDeps`<sup>Optional</sup> <a name="testDeps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.testDeps"></a>

```typescript
public readonly testDeps: string[];
```

- *Type:* string[]
- *Default:* []

List of test dependencies for this project.

Dependencies use the format: `<groupId>/<artifactId>@<semver>`

Additional dependencies can be added via `project.addTestDependency()`.

---

##### `sample`<sup>Optional</sup> <a name="sample" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.sample"></a>

```typescript
public readonly sample: boolean;
```

- *Type:* boolean
- *Default:* true

Include sample code and test if the relevant directories don't exist.

---

##### `sampleJavaPackage`<sup>Optional</sup> <a name="sampleJavaPackage" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.sampleJavaPackage"></a>

```typescript
public readonly sampleJavaPackage: string;
```

- *Type:* string
- *Default:* "org.acme"

The java package to use for the code sample.

---

##### `defaultReleaseBranch`<sup>Optional</sup> <a name="defaultReleaseBranch" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions.property.defaultReleaseBranch"></a>

```typescript
public readonly defaultReleaseBranch: string;
```

- *Type:* string

---

### NxMonorepoProjectOptions <a name="NxMonorepoProjectOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions"></a>

Configuration options for the NxMonorepoProject.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.Initializer"></a>

```typescript
import { NxMonorepoProjectOptions } from '@aws-prototyping-sdk/nx-monorepo'

const nxMonorepoProjectOptions: NxMonorepoProjectOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.name">name</a></code> | <code>string</code> | This is the name of your project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.commitGenerated">commitGenerated</a></code> | <code>boolean</code> | Whether to commit the managed files by default. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.gitIgnoreOptions">gitIgnoreOptions</a></code> | <code>projen.IgnoreFileOptions</code> | Configuration options for .gitignore file. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.gitOptions">gitOptions</a></code> | <code>projen.GitOptions</code> | Configuration options for git. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.logging">logging</a></code> | <code>projen.LoggerOptions</code> | Configure logging options such as verbosity. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.outdir">outdir</a></code> | <code>string</code> | The root directory of the project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.parent">parent</a></code> | <code>projen.Project</code> | The parent project, if this project is part of a bigger project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenCommand">projenCommand</a></code> | <code>string</code> | The shell command to use in order to run the projen CLI. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenrcJson">projenrcJson</a></code> | <code>boolean</code> | Generate (once) .projenrc.json (in JSON). Set to `false` in order to disable .projenrc.json generation. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenrcJsonOptions">projenrcJsonOptions</a></code> | <code>projen.ProjenrcJsonOptions</code> | Options for .projenrc.json. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.renovatebot">renovatebot</a></code> | <code>boolean</code> | Use renovatebot to handle dependency upgrades. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.renovatebotOptions">renovatebotOptions</a></code> | <code>projen.RenovatebotOptions</code> | Options for renovatebot. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.autoApproveOptions">autoApproveOptions</a></code> | <code>projen.github.AutoApproveOptions</code> | Enable and configure the 'auto approve' workflow. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.autoMerge">autoMerge</a></code> | <code>boolean</code> | Enable automatic merging on GitHub. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.autoMergeOptions">autoMergeOptions</a></code> | <code>projen.github.AutoMergeOptions</code> | Configure options for automatic merging on GitHub. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.clobber">clobber</a></code> | <code>boolean</code> | Add a `clobber` task which resets the repo to origin. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.devContainer">devContainer</a></code> | <code>boolean</code> | Add a VSCode development environment (used for GitHub Codespaces). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.github">github</a></code> | <code>boolean</code> | Enable GitHub integration. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.githubOptions">githubOptions</a></code> | <code>projen.github.GitHubOptions</code> | Options for GitHub integration. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.gitpod">gitpod</a></code> | <code>boolean</code> | Add a Gitpod development environment. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.mergify">mergify</a></code> | <code>boolean</code> | Whether mergify should be enabled on this repository or not. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.mergifyOptions">mergifyOptions</a></code> | <code>projen.github.MergifyOptions</code> | Options for mergify. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projectType">projectType</a></code> | <code>projen.ProjectType</code> | Which type of project this is (library/app). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenCredentials">projenCredentials</a></code> | <code>projen.github.GithubCredentials</code> | Choose a method of providing GitHub API access for projen workflows. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenTokenSecret">projenTokenSecret</a></code> | <code>string</code> | The name of a secret which includes a GitHub Personal Access Token to be used by projen workflows. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.readme">readme</a></code> | <code>projen.SampleReadmeProps</code> | The README setup. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.stale">stale</a></code> | <code>boolean</code> | Auto-close of stale issues and pull request. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.staleOptions">staleOptions</a></code> | <code>projen.github.StaleOptions</code> | Auto-close stale issues and pull requests. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.vscode">vscode</a></code> | <code>boolean</code> | Enable VSCode integration. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.allowLibraryDependencies">allowLibraryDependencies</a></code> | <code>boolean</code> | Allow the project to include `peerDependencies` and `bundledDependencies`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.authorEmail">authorEmail</a></code> | <code>string</code> | Author's e-mail. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.authorName">authorName</a></code> | <code>string</code> | Author's name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.authorOrganization">authorOrganization</a></code> | <code>boolean</code> | Is the author an organization. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.authorUrl">authorUrl</a></code> | <code>string</code> | Author's URL / Website. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.autoDetectBin">autoDetectBin</a></code> | <code>boolean</code> | Automatically add all executables under the `bin` directory to your `package.json` file under the `bin` section. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.bin">bin</a></code> | <code>{[ key: string ]: string}</code> | Binary programs vended with your module. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.bugsEmail">bugsEmail</a></code> | <code>string</code> | The email address to which issues should be reported. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.bugsUrl">bugsUrl</a></code> | <code>string</code> | The url to your project's issue tracker. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.bundledDeps">bundledDeps</a></code> | <code>string[]</code> | List of dependencies to bundle into this module. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.codeArtifactOptions">codeArtifactOptions</a></code> | <code>projen.javascript.CodeArtifactOptions</code> | Options for npm packages using AWS CodeArtifact. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.deps">deps</a></code> | <code>string[]</code> | Runtime dependencies of this module. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.description">description</a></code> | <code>string</code> | The description is just a string that helps people understand the purpose of the package. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.devDeps">devDeps</a></code> | <code>string[]</code> | Build dependencies for this module. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.entrypoint">entrypoint</a></code> | <code>string</code> | Module entrypoint (`main` in `package.json`). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.homepage">homepage</a></code> | <code>string</code> | Package's Homepage / Website. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.keywords">keywords</a></code> | <code>string[]</code> | Keywords to include in `package.json`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.license">license</a></code> | <code>string</code> | License's SPDX identifier. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.licensed">licensed</a></code> | <code>boolean</code> | Indicates if a license should be added. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.maxNodeVersion">maxNodeVersion</a></code> | <code>string</code> | Minimum node.js version to require via `engines` (inclusive). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.minNodeVersion">minNodeVersion</a></code> | <code>string</code> | Minimum Node.js version to require via package.json `engines` (inclusive). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmAccess">npmAccess</a></code> | <code>projen.javascript.NpmAccess</code> | Access level of the npm package. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmRegistry">npmRegistry</a></code> | <code>string</code> | The host name of the npm registry to publish to. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmRegistryUrl">npmRegistryUrl</a></code> | <code>string</code> | The base URL of the npm package registry. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmTokenSecret">npmTokenSecret</a></code> | <code>string</code> | GitHub secret which contains the NPM token to use when publishing packages. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.packageManager">packageManager</a></code> | <code>projen.javascript.NodePackageManager</code> | The Node Package Manager used to execute scripts. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.packageName">packageName</a></code> | <code>string</code> | The "name" in package.json. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.peerDependencyOptions">peerDependencyOptions</a></code> | <code>projen.javascript.PeerDependencyOptions</code> | Options for `peerDeps`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.peerDeps">peerDeps</a></code> | <code>string[]</code> | Peer dependencies for this module. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.pnpmVersion">pnpmVersion</a></code> | <code>string</code> | The version of PNPM to use if using PNPM as a package manager. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.repository">repository</a></code> | <code>string</code> | The repository is the location where the actual code for your package lives. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.repositoryDirectory">repositoryDirectory</a></code> | <code>string</code> | If the package.json for your package is not in the root directory (for example if it is part of a monorepo), you can specify the directory in which it lives. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.scopedPackagesOptions">scopedPackagesOptions</a></code> | <code>projen.javascript.ScopedPackagesOptions[]</code> | Options for privately hosted scoped packages. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.scripts">scripts</a></code> | <code>{[ key: string ]: string}</code> | npm scripts to include. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.stability">stability</a></code> | <code>string</code> | Package's Stability. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.jsiiReleaseVersion">jsiiReleaseVersion</a></code> | <code>string</code> | Version requirement of `publib` which is used to publish modules to npm. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.majorVersion">majorVersion</a></code> | <code>number</code> | Major version to release from the default branch. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.minMajorVersion">minMajorVersion</a></code> | <code>number</code> | Minimal Major version to release. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmDistTag">npmDistTag</a></code> | <code>string</code> | The npmDistTag to use when publishing from the default branch. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.postBuildSteps">postBuildSteps</a></code> | <code>projen.github.workflows.JobStep[]</code> | Steps to execute after build as part of the release workflow. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.prerelease">prerelease</a></code> | <code>string</code> | Bump versions from the default branch as pre-releases (e.g. "beta", "alpha", "pre"). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.publishDryRun">publishDryRun</a></code> | <code>boolean</code> | Instead of actually publishing to package managers, just print the publishing command. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.publishTasks">publishTasks</a></code> | <code>boolean</code> | Define publishing tasks that can be executed manually as well as workflows. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseBranches">releaseBranches</a></code> | <code>{[ key: string ]: projen.release.BranchOptions}</code> | Defines additional release branches. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseEveryCommit">releaseEveryCommit</a></code> | <code>boolean</code> | Automatically release new versions every commit to one of branches in `releaseBranches`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseFailureIssue">releaseFailureIssue</a></code> | <code>boolean</code> | Create a github issue on every failed publishing task. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseFailureIssueLabel">releaseFailureIssueLabel</a></code> | <code>string</code> | The label to apply to issues indicating publish failures. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseSchedule">releaseSchedule</a></code> | <code>string</code> | CRON schedule to trigger new releases. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseTagPrefix">releaseTagPrefix</a></code> | <code>string</code> | Automatically add the given prefix to release tags. Useful if you are releasing on multiple branches with overlapping version numbers. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseTrigger">releaseTrigger</a></code> | <code>projen.release.ReleaseTrigger</code> | The release trigger to use. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseWorkflowName">releaseWorkflowName</a></code> | <code>string</code> | The name of the default release workflow. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseWorkflowSetupSteps">releaseWorkflowSetupSteps</a></code> | <code>projen.github.workflows.JobStep[]</code> | A set of workflow steps to execute in order to setup the workflow container. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.versionrcOptions">versionrcOptions</a></code> | <code>{[ key: string ]: any}</code> | Custom configuration used when creating changelog with standard-version package. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workflowContainerImage">workflowContainerImage</a></code> | <code>string</code> | Container image to use for GitHub workflows. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workflowRunsOn">workflowRunsOn</a></code> | <code>string[]</code> | Github Runner selection labels. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.defaultReleaseBranch">defaultReleaseBranch</a></code> | <code>string</code> | The name of the main release branch. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.artifactsDirectory">artifactsDirectory</a></code> | <code>string</code> | A directory which will contain build artifacts. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.autoApproveUpgrades">autoApproveUpgrades</a></code> | <code>boolean</code> | Automatically approve deps upgrade PRs, allowing them to be merged by mergify (if configued). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.buildWorkflow">buildWorkflow</a></code> | <code>boolean</code> | Define a GitHub workflow for building PRs. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.buildWorkflowTriggers">buildWorkflowTriggers</a></code> | <code>projen.github.workflows.Triggers</code> | Build workflow triggers. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.bundlerOptions">bundlerOptions</a></code> | <code>projen.javascript.BundlerOptions</code> | Options for `Bundler`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.codeCov">codeCov</a></code> | <code>boolean</code> | Define a GitHub workflow step for sending code coverage metrics to https://codecov.io/ Uses codecov/codecov-action@v3 A secret is required for private repos. Configured with `@codeCovTokenSecret`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.codeCovTokenSecret">codeCovTokenSecret</a></code> | <code>string</code> | Define the secret name for a specified https://codecov.io/ token A secret is required to send coverage for private repositories. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.copyrightOwner">copyrightOwner</a></code> | <code>string</code> | License copyright owner. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.copyrightPeriod">copyrightPeriod</a></code> | <code>string</code> | The copyright years to put in the LICENSE file. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.dependabot">dependabot</a></code> | <code>boolean</code> | Use dependabot to handle dependency upgrades. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.dependabotOptions">dependabotOptions</a></code> | <code>projen.github.DependabotOptions</code> | Options for dependabot. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.depsUpgrade">depsUpgrade</a></code> | <code>boolean</code> | Use github workflows to handle dependency upgrades. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.depsUpgradeOptions">depsUpgradeOptions</a></code> | <code>projen.javascript.UpgradeDependenciesOptions</code> | Options for `UpgradeDependencies`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.gitignore">gitignore</a></code> | <code>string[]</code> | Additional entries to .gitignore. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.jest">jest</a></code> | <code>boolean</code> | Setup jest unit tests. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.jestOptions">jestOptions</a></code> | <code>projen.javascript.JestOptions</code> | Jest options. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.mutableBuild">mutableBuild</a></code> | <code>boolean</code> | Automatically update files modified during builds to pull-request branches. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmignore">npmignore</a></code> | <code>string[]</code> | Additional entries to .npmignore. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmignoreEnabled">npmignoreEnabled</a></code> | <code>boolean</code> | Defines an .npmignore file. Normally this is only needed for libraries that are packaged as tarballs. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmIgnoreOptions">npmIgnoreOptions</a></code> | <code>projen.IgnoreFileOptions</code> | Configuration options for .npmignore file. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.package">package</a></code> | <code>boolean</code> | Defines a `package` task that will produce an npm tarball under the artifacts directory (e.g. `dist`). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.prettier">prettier</a></code> | <code>boolean</code> | Setup prettier. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.prettierOptions">prettierOptions</a></code> | <code>projen.javascript.PrettierOptions</code> | Prettier options. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenDevDependency">projenDevDependency</a></code> | <code>boolean</code> | Indicates of "projen" should be installed as a devDependency. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenrcJs">projenrcJs</a></code> | <code>boolean</code> | Generate (once) .projenrc.js (in JavaScript). Set to `false` in order to disable .projenrc.js generation. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenrcJsOptions">projenrcJsOptions</a></code> | <code>projen.javascript.ProjenrcOptions</code> | Options for .projenrc.js. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenVersion">projenVersion</a></code> | <code>string</code> | Version of projen to install. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.pullRequestTemplate">pullRequestTemplate</a></code> | <code>boolean</code> | Include a GitHub pull request template. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.pullRequestTemplateContents">pullRequestTemplateContents</a></code> | <code>string[]</code> | The contents of the pull request template. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.release">release</a></code> | <code>boolean</code> | Add release management to this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseToNpm">releaseToNpm</a></code> | <code>boolean</code> | Automatically release to npm when new versions are introduced. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseWorkflow">releaseWorkflow</a></code> | <code>boolean</code> | DEPRECATED: renamed to `release`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workflowBootstrapSteps">workflowBootstrapSteps</a></code> | <code>projen.github.workflows.JobStep[]</code> | Workflow steps to use in order to bootstrap this repo. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workflowGitIdentity">workflowGitIdentity</a></code> | <code>projen.github.GitIdentity</code> | The git identity to use in workflows. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workflowNodeVersion">workflowNodeVersion</a></code> | <code>string</code> | The node version to use in GitHub workflows. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workflowPackageCache">workflowPackageCache</a></code> | <code>boolean</code> | Enable Node.js package cache in GitHub workflows. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.disableTsconfig">disableTsconfig</a></code> | <code>boolean</code> | Do not generate a `tsconfig.json` file (used by jsii projects since tsconfig.json is generated by the jsii compiler). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.disableTsconfigDev">disableTsconfigDev</a></code> | <code>boolean</code> | Do not generate a `tsconfig.dev.json` file. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.docgen">docgen</a></code> | <code>boolean</code> | Docgen by Typedoc. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.docsDirectory">docsDirectory</a></code> | <code>string</code> | Docs directory. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.entrypointTypes">entrypointTypes</a></code> | <code>string</code> | The .d.ts file that includes the type declarations for this module. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.eslint">eslint</a></code> | <code>boolean</code> | Setup eslint. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.eslintOptions">eslintOptions</a></code> | <code>projen.javascript.EslintOptions</code> | Eslint options. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.libdir">libdir</a></code> | <code>string</code> | Typescript  artifacts output directory. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenrcTs">projenrcTs</a></code> | <code>boolean</code> | Use TypeScript for your projenrc file (`.projenrc.ts`). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenrcTsOptions">projenrcTsOptions</a></code> | <code>projen.typescript.ProjenrcOptions</code> | Options for .projenrc.ts. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.sampleCode">sampleCode</a></code> | <code>boolean</code> | Generate one-time sample in `src/` and `test/` if there are no files there. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.srcdir">srcdir</a></code> | <code>string</code> | Typescript sources directory. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.testdir">testdir</a></code> | <code>string</code> | Jest tests directory. Tests files should be named `xxx.test.ts`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.tsconfig">tsconfig</a></code> | <code>projen.javascript.TypescriptConfigOptions</code> | Custom TSConfig. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.tsconfigDev">tsconfigDev</a></code> | <code>projen.javascript.TypescriptConfigOptions</code> | Custom tsconfig options for the development tsconfig.json file (used for testing). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.tsconfigDevFile">tsconfigDevFile</a></code> | <code>string</code> | The name of the development tsconfig.json file. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.typescriptVersion">typescriptVersion</a></code> | <code>string</code> | TypeScript version to use. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.disableNodeWarnings">disableNodeWarnings</a></code> | <code>boolean</code> | Disable node warnings from being emitted during build tasks. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.monorepoUpgradeDeps">monorepoUpgradeDeps</a></code> | <code>boolean</code> | Whether to include an upgrade-deps task at the root of the monorepo which will upgrade all dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.monorepoUpgradeDepsOptions">monorepoUpgradeDepsOptions</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.MonorepoUpgradeDepsOptions">MonorepoUpgradeDepsOptions</a></code> | Monorepo Upgrade Deps options. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workspaceConfig">workspaceConfig</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.WorkspaceConfig">WorkspaceConfig</a></code> | Configuration for workspace. |

---

##### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* $BASEDIR

This is the name of your project.

---

##### `commitGenerated`<sup>Optional</sup> <a name="commitGenerated" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.commitGenerated"></a>

```typescript
public readonly commitGenerated: boolean;
```

- *Type:* boolean
- *Default:* true

Whether to commit the managed files by default.

---

##### `gitIgnoreOptions`<sup>Optional</sup> <a name="gitIgnoreOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.gitIgnoreOptions"></a>

```typescript
public readonly gitIgnoreOptions: IgnoreFileOptions;
```

- *Type:* projen.IgnoreFileOptions

Configuration options for .gitignore file.

---

##### `gitOptions`<sup>Optional</sup> <a name="gitOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.gitOptions"></a>

```typescript
public readonly gitOptions: GitOptions;
```

- *Type:* projen.GitOptions

Configuration options for git.

---

##### `logging`<sup>Optional</sup> <a name="logging" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.logging"></a>

```typescript
public readonly logging: LoggerOptions;
```

- *Type:* projen.LoggerOptions
- *Default:* {}

Configure logging options such as verbosity.

---

##### `outdir`<sup>Optional</sup> <a name="outdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.outdir"></a>

```typescript
public readonly outdir: string;
```

- *Type:* string
- *Default:* "."

The root directory of the project.

Relative to this directory, all files are synthesized.

If this project has a parent, this directory is relative to the parent
directory and it cannot be the same as the parent or any of it's other
sub-projects.

---

##### `parent`<sup>Optional</sup> <a name="parent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.parent"></a>

```typescript
public readonly parent: Project;
```

- *Type:* projen.Project

The parent project, if this project is part of a bigger project.

---

##### `projenCommand`<sup>Optional</sup> <a name="projenCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenCommand"></a>

```typescript
public readonly projenCommand: string;
```

- *Type:* string
- *Default:* "npx projen"

The shell command to use in order to run the projen CLI.

Can be used to customize in special environments.

---

##### `projenrcJson`<sup>Optional</sup> <a name="projenrcJson" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenrcJson"></a>

```typescript
public readonly projenrcJson: boolean;
```

- *Type:* boolean
- *Default:* false

Generate (once) .projenrc.json (in JSON). Set to `false` in order to disable .projenrc.json generation.

---

##### `projenrcJsonOptions`<sup>Optional</sup> <a name="projenrcJsonOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenrcJsonOptions"></a>

```typescript
public readonly projenrcJsonOptions: ProjenrcJsonOptions;
```

- *Type:* projen.ProjenrcJsonOptions
- *Default:* default options

Options for .projenrc.json.

---

##### `renovatebot`<sup>Optional</sup> <a name="renovatebot" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.renovatebot"></a>

```typescript
public readonly renovatebot: boolean;
```

- *Type:* boolean
- *Default:* false

Use renovatebot to handle dependency upgrades.

---

##### `renovatebotOptions`<sup>Optional</sup> <a name="renovatebotOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.renovatebotOptions"></a>

```typescript
public readonly renovatebotOptions: RenovatebotOptions;
```

- *Type:* projen.RenovatebotOptions
- *Default:* default options

Options for renovatebot.

---

##### `autoApproveOptions`<sup>Optional</sup> <a name="autoApproveOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.autoApproveOptions"></a>

```typescript
public readonly autoApproveOptions: AutoApproveOptions;
```

- *Type:* projen.github.AutoApproveOptions
- *Default:* auto approve is disabled

Enable and configure the 'auto approve' workflow.

---

##### `autoMerge`<sup>Optional</sup> <a name="autoMerge" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.autoMerge"></a>

```typescript
public readonly autoMerge: boolean;
```

- *Type:* boolean
- *Default:* true

Enable automatic merging on GitHub.

Has no effect if `github.mergify`
is set to false.

---

##### `autoMergeOptions`<sup>Optional</sup> <a name="autoMergeOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.autoMergeOptions"></a>

```typescript
public readonly autoMergeOptions: AutoMergeOptions;
```

- *Type:* projen.github.AutoMergeOptions
- *Default:* see defaults in `AutoMergeOptions`

Configure options for automatic merging on GitHub.

Has no effect if
`github.mergify` or `autoMerge` is set to false.

---

##### `clobber`<sup>Optional</sup> <a name="clobber" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.clobber"></a>

```typescript
public readonly clobber: boolean;
```

- *Type:* boolean
- *Default:* true, but false for subprojects

Add a `clobber` task which resets the repo to origin.

---

##### `devContainer`<sup>Optional</sup> <a name="devContainer" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.devContainer"></a>

```typescript
public readonly devContainer: boolean;
```

- *Type:* boolean
- *Default:* false

Add a VSCode development environment (used for GitHub Codespaces).

---

##### `github`<sup>Optional</sup> <a name="github" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.github"></a>

```typescript
public readonly github: boolean;
```

- *Type:* boolean
- *Default:* true

Enable GitHub integration.

Enabled by default for root projects. Disabled for non-root projects.

---

##### `githubOptions`<sup>Optional</sup> <a name="githubOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.githubOptions"></a>

```typescript
public readonly githubOptions: GitHubOptions;
```

- *Type:* projen.github.GitHubOptions
- *Default:* see GitHubOptions

Options for GitHub integration.

---

##### `gitpod`<sup>Optional</sup> <a name="gitpod" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.gitpod"></a>

```typescript
public readonly gitpod: boolean;
```

- *Type:* boolean
- *Default:* false

Add a Gitpod development environment.

---

##### ~~`mergify`~~<sup>Optional</sup> <a name="mergify" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.mergify"></a>

- *Deprecated:* use `githubOptions.mergify` instead

```typescript
public readonly mergify: boolean;
```

- *Type:* boolean
- *Default:* true

Whether mergify should be enabled on this repository or not.

---

##### ~~`mergifyOptions`~~<sup>Optional</sup> <a name="mergifyOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.mergifyOptions"></a>

- *Deprecated:* use `githubOptions.mergifyOptions` instead

```typescript
public readonly mergifyOptions: MergifyOptions;
```

- *Type:* projen.github.MergifyOptions
- *Default:* default options

Options for mergify.

---

##### ~~`projectType`~~<sup>Optional</sup> <a name="projectType" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projectType"></a>

- *Deprecated:* no longer supported at the base project level

```typescript
public readonly projectType: ProjectType;
```

- *Type:* projen.ProjectType
- *Default:* ProjectType.UNKNOWN

Which type of project this is (library/app).

---

##### `projenCredentials`<sup>Optional</sup> <a name="projenCredentials" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenCredentials"></a>

```typescript
public readonly projenCredentials: GithubCredentials;
```

- *Type:* projen.github.GithubCredentials
- *Default:* use a personal access token named PROJEN_GITHUB_TOKEN

Choose a method of providing GitHub API access for projen workflows.

---

##### ~~`projenTokenSecret`~~<sup>Optional</sup> <a name="projenTokenSecret" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenTokenSecret"></a>

- *Deprecated:* use `projenCredentials`

```typescript
public readonly projenTokenSecret: string;
```

- *Type:* string
- *Default:* "PROJEN_GITHUB_TOKEN"

The name of a secret which includes a GitHub Personal Access Token to be used by projen workflows.

This token needs to have the `repo`, `workflows`
and `packages` scope.

---

##### `readme`<sup>Optional</sup> <a name="readme" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.readme"></a>

```typescript
public readonly readme: SampleReadmeProps;
```

- *Type:* projen.SampleReadmeProps
- *Default:* { filename: 'README.md', contents: '# replace this' }

The README setup.

---

*Example*

```typescript
"{ filename: 'readme.md', contents: '# title' }"
```


##### `stale`<sup>Optional</sup> <a name="stale" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.stale"></a>

```typescript
public readonly stale: boolean;
```

- *Type:* boolean
- *Default:* false

Auto-close of stale issues and pull request.

See `staleOptions` for options.

---

##### `staleOptions`<sup>Optional</sup> <a name="staleOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.staleOptions"></a>

```typescript
public readonly staleOptions: StaleOptions;
```

- *Type:* projen.github.StaleOptions
- *Default:* see defaults in `StaleOptions`

Auto-close stale issues and pull requests.

To disable set `stale` to `false`.

---

##### `vscode`<sup>Optional</sup> <a name="vscode" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.vscode"></a>

```typescript
public readonly vscode: boolean;
```

- *Type:* boolean
- *Default:* true

Enable VSCode integration.

Enabled by default for root projects. Disabled for non-root projects.

---

##### `allowLibraryDependencies`<sup>Optional</sup> <a name="allowLibraryDependencies" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.allowLibraryDependencies"></a>

```typescript
public readonly allowLibraryDependencies: boolean;
```

- *Type:* boolean
- *Default:* true

Allow the project to include `peerDependencies` and `bundledDependencies`.

This is normally only allowed for libraries. For apps, there's no meaning
for specifying these.

---

##### `authorEmail`<sup>Optional</sup> <a name="authorEmail" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.authorEmail"></a>

```typescript
public readonly authorEmail: string;
```

- *Type:* string

Author's e-mail.

---

##### `authorName`<sup>Optional</sup> <a name="authorName" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.authorName"></a>

```typescript
public readonly authorName: string;
```

- *Type:* string

Author's name.

---

##### `authorOrganization`<sup>Optional</sup> <a name="authorOrganization" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.authorOrganization"></a>

```typescript
public readonly authorOrganization: boolean;
```

- *Type:* boolean

Is the author an organization.

---

##### `authorUrl`<sup>Optional</sup> <a name="authorUrl" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.authorUrl"></a>

```typescript
public readonly authorUrl: string;
```

- *Type:* string

Author's URL / Website.

---

##### `autoDetectBin`<sup>Optional</sup> <a name="autoDetectBin" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.autoDetectBin"></a>

```typescript
public readonly autoDetectBin: boolean;
```

- *Type:* boolean
- *Default:* true

Automatically add all executables under the `bin` directory to your `package.json` file under the `bin` section.

---

##### `bin`<sup>Optional</sup> <a name="bin" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.bin"></a>

```typescript
public readonly bin: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}

Binary programs vended with your module.

You can use this option to add/customize how binaries are represented in
your `package.json`, but unless `autoDetectBin` is `false`, every
executable file under `bin` will automatically be added to this section.

---

##### `bugsEmail`<sup>Optional</sup> <a name="bugsEmail" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.bugsEmail"></a>

```typescript
public readonly bugsEmail: string;
```

- *Type:* string

The email address to which issues should be reported.

---

##### `bugsUrl`<sup>Optional</sup> <a name="bugsUrl" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.bugsUrl"></a>

```typescript
public readonly bugsUrl: string;
```

- *Type:* string

The url to your project's issue tracker.

---

##### `bundledDeps`<sup>Optional</sup> <a name="bundledDeps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.bundledDeps"></a>

```typescript
public readonly bundledDeps: string[];
```

- *Type:* string[]

List of dependencies to bundle into this module.

These modules will be
added both to the `dependencies` section and `bundledDependencies` section of
your `package.json`.

The recommendation is to only specify the module name here (e.g.
`express`). This will behave similar to `yarn add` or `npm install` in the
sense that it will add the module as a dependency to your `package.json`
file with the latest version (`^`). You can specify semver requirements in
the same syntax passed to `npm i` or `yarn add` (e.g. `express@^2`) and
this will be what you `package.json` will eventually include.

---

##### `codeArtifactOptions`<sup>Optional</sup> <a name="codeArtifactOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.codeArtifactOptions"></a>

```typescript
public readonly codeArtifactOptions: CodeArtifactOptions;
```

- *Type:* projen.javascript.CodeArtifactOptions
- *Default:* undefined

Options for npm packages using AWS CodeArtifact.

This is required if publishing packages to, or installing scoped packages from AWS CodeArtifact

---

##### `deps`<sup>Optional</sup> <a name="deps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.deps"></a>

```typescript
public readonly deps: string[];
```

- *Type:* string[]
- *Default:* []

Runtime dependencies of this module.

The recommendation is to only specify the module name here (e.g.
`express`). This will behave similar to `yarn add` or `npm install` in the
sense that it will add the module as a dependency to your `package.json`
file with the latest version (`^`). You can specify semver requirements in
the same syntax passed to `npm i` or `yarn add` (e.g. `express@^2`) and
this will be what you `package.json` will eventually include.

---

*Example*

```typescript
[ 'express', 'lodash', 'foo@^2' ]
```


##### `description`<sup>Optional</sup> <a name="description" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

The description is just a string that helps people understand the purpose of the package.

It can be used when searching for packages in a package manager as well.
See https://classic.yarnpkg.com/en/docs/package-json/#toc-description

---

##### `devDeps`<sup>Optional</sup> <a name="devDeps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.devDeps"></a>

```typescript
public readonly devDeps: string[];
```

- *Type:* string[]
- *Default:* []

Build dependencies for this module.

These dependencies will only be
available in your build environment but will not be fetched when this
module is consumed.

The recommendation is to only specify the module name here (e.g.
`express`). This will behave similar to `yarn add` or `npm install` in the
sense that it will add the module as a dependency to your `package.json`
file with the latest version (`^`). You can specify semver requirements in
the same syntax passed to `npm i` or `yarn add` (e.g. `express@^2`) and
this will be what you `package.json` will eventually include.

---

*Example*

```typescript
[ 'typescript', '@types/express' ]
```


##### `entrypoint`<sup>Optional</sup> <a name="entrypoint" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.entrypoint"></a>

```typescript
public readonly entrypoint: string;
```

- *Type:* string
- *Default:* "lib/index.js"

Module entrypoint (`main` in `package.json`).

Set to an empty string to not include `main` in your package.json

---

##### `homepage`<sup>Optional</sup> <a name="homepage" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.homepage"></a>

```typescript
public readonly homepage: string;
```

- *Type:* string

Package's Homepage / Website.

---

##### `keywords`<sup>Optional</sup> <a name="keywords" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.keywords"></a>

```typescript
public readonly keywords: string[];
```

- *Type:* string[]

Keywords to include in `package.json`.

---

##### `license`<sup>Optional</sup> <a name="license" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.license"></a>

```typescript
public readonly license: string;
```

- *Type:* string
- *Default:* "Apache-2.0"

License's SPDX identifier.

See https://github.com/projen/projen/tree/main/license-text for a list of supported licenses.
Use the `licensed` option if you want to no license to be specified.

---

##### `licensed`<sup>Optional</sup> <a name="licensed" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.licensed"></a>

```typescript
public readonly licensed: boolean;
```

- *Type:* boolean
- *Default:* true

Indicates if a license should be added.

---

##### `maxNodeVersion`<sup>Optional</sup> <a name="maxNodeVersion" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.maxNodeVersion"></a>

```typescript
public readonly maxNodeVersion: string;
```

- *Type:* string
- *Default:* no max

Minimum node.js version to require via `engines` (inclusive).

---

##### `minNodeVersion`<sup>Optional</sup> <a name="minNodeVersion" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.minNodeVersion"></a>

```typescript
public readonly minNodeVersion: string;
```

- *Type:* string
- *Default:* no "engines" specified

Minimum Node.js version to require via package.json `engines` (inclusive).

---

##### `npmAccess`<sup>Optional</sup> <a name="npmAccess" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmAccess"></a>

```typescript
public readonly npmAccess: NpmAccess;
```

- *Type:* projen.javascript.NpmAccess
- *Default:* for scoped packages (e.g. `foo@bar`), the default is `NpmAccess.RESTRICTED`, for non-scoped packages, the default is `NpmAccess.PUBLIC`.

Access level of the npm package.

---

##### ~~`npmRegistry`~~<sup>Optional</sup> <a name="npmRegistry" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmRegistry"></a>

- *Deprecated:* use `npmRegistryUrl` instead

```typescript
public readonly npmRegistry: string;
```

- *Type:* string

The host name of the npm registry to publish to.

Cannot be set together with `npmRegistryUrl`.

---

##### `npmRegistryUrl`<sup>Optional</sup> <a name="npmRegistryUrl" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmRegistryUrl"></a>

```typescript
public readonly npmRegistryUrl: string;
```

- *Type:* string
- *Default:* "https://registry.npmjs.org"

The base URL of the npm package registry.

Must be a URL (e.g. start with "https://" or "http://")

---

##### `npmTokenSecret`<sup>Optional</sup> <a name="npmTokenSecret" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmTokenSecret"></a>

```typescript
public readonly npmTokenSecret: string;
```

- *Type:* string
- *Default:* "NPM_TOKEN"

GitHub secret which contains the NPM token to use when publishing packages.

---

##### `packageManager`<sup>Optional</sup> <a name="packageManager" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.packageManager"></a>

```typescript
public readonly packageManager: NodePackageManager;
```

- *Type:* projen.javascript.NodePackageManager
- *Default:* NodePackageManager.YARN

The Node Package Manager used to execute scripts.

---

##### `packageName`<sup>Optional</sup> <a name="packageName" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.packageName"></a>

```typescript
public readonly packageName: string;
```

- *Type:* string
- *Default:* defaults to project name

The "name" in package.json.

---

##### `peerDependencyOptions`<sup>Optional</sup> <a name="peerDependencyOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.peerDependencyOptions"></a>

```typescript
public readonly peerDependencyOptions: PeerDependencyOptions;
```

- *Type:* projen.javascript.PeerDependencyOptions

Options for `peerDeps`.

---

##### `peerDeps`<sup>Optional</sup> <a name="peerDeps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.peerDeps"></a>

```typescript
public readonly peerDeps: string[];
```

- *Type:* string[]
- *Default:* []

Peer dependencies for this module.

Dependencies listed here are required to
be installed (and satisfied) by the _consumer_ of this library. Using peer
dependencies allows you to ensure that only a single module of a certain
library exists in the `node_modules` tree of your consumers.

Note that prior to npm@7, peer dependencies are _not_ automatically
installed, which means that adding peer dependencies to a library will be a
breaking change for your customers.

Unless `peerDependencyOptions.pinnedDevDependency` is disabled (it is
enabled by default), projen will automatically add a dev dependency with a
pinned version for each peer dependency. This will ensure that you build &
test your module against the lowest peer version required.

---

##### `pnpmVersion`<sup>Optional</sup> <a name="pnpmVersion" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.pnpmVersion"></a>

```typescript
public readonly pnpmVersion: string;
```

- *Type:* string
- *Default:* "7"

The version of PNPM to use if using PNPM as a package manager.

---

##### `repository`<sup>Optional</sup> <a name="repository" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.repository"></a>

```typescript
public readonly repository: string;
```

- *Type:* string

The repository is the location where the actual code for your package lives.

See https://classic.yarnpkg.com/en/docs/package-json/#toc-repository

---

##### `repositoryDirectory`<sup>Optional</sup> <a name="repositoryDirectory" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.repositoryDirectory"></a>

```typescript
public readonly repositoryDirectory: string;
```

- *Type:* string

If the package.json for your package is not in the root directory (for example if it is part of a monorepo), you can specify the directory in which it lives.

---

##### `scopedPackagesOptions`<sup>Optional</sup> <a name="scopedPackagesOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.scopedPackagesOptions"></a>

```typescript
public readonly scopedPackagesOptions: ScopedPackagesOptions[];
```

- *Type:* projen.javascript.ScopedPackagesOptions[]
- *Default:* fetch all scoped packages from the public npm registry

Options for privately hosted scoped packages.

---

##### ~~`scripts`~~<sup>Optional</sup> <a name="scripts" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.scripts"></a>

- *Deprecated:* use `project.addTask()` or `package.setScript()`

```typescript
public readonly scripts: {[ key: string ]: string};
```

- *Type:* {[ key: string ]: string}
- *Default:* {}

npm scripts to include.

If a script has the same name as a standard script,
the standard script will be overwritten.
Also adds the script as a task.

---

##### `stability`<sup>Optional</sup> <a name="stability" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.stability"></a>

```typescript
public readonly stability: string;
```

- *Type:* string

Package's Stability.

---

##### `jsiiReleaseVersion`<sup>Optional</sup> <a name="jsiiReleaseVersion" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.jsiiReleaseVersion"></a>

```typescript
public readonly jsiiReleaseVersion: string;
```

- *Type:* string
- *Default:* "latest"

Version requirement of `publib` which is used to publish modules to npm.

---

##### `majorVersion`<sup>Optional</sup> <a name="majorVersion" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.majorVersion"></a>

```typescript
public readonly majorVersion: number;
```

- *Type:* number
- *Default:* Major version is not enforced.

Major version to release from the default branch.

If this is specified, we bump the latest version of this major version line.
If not specified, we bump the global latest version.

---

##### `minMajorVersion`<sup>Optional</sup> <a name="minMajorVersion" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.minMajorVersion"></a>

```typescript
public readonly minMajorVersion: number;
```

- *Type:* number
- *Default:* No minimum version is being enforced

Minimal Major version to release.

This can be useful to set to 1, as breaking changes before the 1.x major
release are not incrementing the major version number.

Can not be set together with `majorVersion`.

---

##### `npmDistTag`<sup>Optional</sup> <a name="npmDistTag" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmDistTag"></a>

```typescript
public readonly npmDistTag: string;
```

- *Type:* string
- *Default:* "latest"

The npmDistTag to use when publishing from the default branch.

To set the npm dist-tag for release branches, set the `npmDistTag` property
for each branch.

---

##### `postBuildSteps`<sup>Optional</sup> <a name="postBuildSteps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.postBuildSteps"></a>

```typescript
public readonly postBuildSteps: JobStep[];
```

- *Type:* projen.github.workflows.JobStep[]
- *Default:* []

Steps to execute after build as part of the release workflow.

---

##### `prerelease`<sup>Optional</sup> <a name="prerelease" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.prerelease"></a>

```typescript
public readonly prerelease: string;
```

- *Type:* string
- *Default:* normal semantic versions

Bump versions from the default branch as pre-releases (e.g. "beta", "alpha", "pre").

---

##### `publishDryRun`<sup>Optional</sup> <a name="publishDryRun" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.publishDryRun"></a>

```typescript
public readonly publishDryRun: boolean;
```

- *Type:* boolean
- *Default:* false

Instead of actually publishing to package managers, just print the publishing command.

---

##### `publishTasks`<sup>Optional</sup> <a name="publishTasks" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.publishTasks"></a>

```typescript
public readonly publishTasks: boolean;
```

- *Type:* boolean
- *Default:* false

Define publishing tasks that can be executed manually as well as workflows.

Normally, publishing only happens within automated workflows. Enable this
in order to create a publishing task for each publishing activity.

---

##### `releaseBranches`<sup>Optional</sup> <a name="releaseBranches" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseBranches"></a>

```typescript
public readonly releaseBranches: {[ key: string ]: BranchOptions};
```

- *Type:* {[ key: string ]: projen.release.BranchOptions}
- *Default:* no additional branches are used for release. you can use `addBranch()` to add additional branches.

Defines additional release branches.

A workflow will be created for each
release branch which will publish releases from commits in this branch.
Each release branch _must_ be assigned a major version number which is used
to enforce that versions published from that branch always use that major
version. If multiple branches are used, the `majorVersion` field must also
be provided for the default branch.

---

##### ~~`releaseEveryCommit`~~<sup>Optional</sup> <a name="releaseEveryCommit" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseEveryCommit"></a>

- *Deprecated:* Use `releaseTrigger: ReleaseTrigger.continuous()` instead

```typescript
public readonly releaseEveryCommit: boolean;
```

- *Type:* boolean
- *Default:* true

Automatically release new versions every commit to one of branches in `releaseBranches`.

---

##### `releaseFailureIssue`<sup>Optional</sup> <a name="releaseFailureIssue" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseFailureIssue"></a>

```typescript
public readonly releaseFailureIssue: boolean;
```

- *Type:* boolean
- *Default:* false

Create a github issue on every failed publishing task.

---

##### `releaseFailureIssueLabel`<sup>Optional</sup> <a name="releaseFailureIssueLabel" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseFailureIssueLabel"></a>

```typescript
public readonly releaseFailureIssueLabel: string;
```

- *Type:* string
- *Default:* "failed-release"

The label to apply to issues indicating publish failures.

Only applies if `releaseFailureIssue` is true.

---

##### ~~`releaseSchedule`~~<sup>Optional</sup> <a name="releaseSchedule" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseSchedule"></a>

- *Deprecated:* Use `releaseTrigger: ReleaseTrigger.scheduled()` instead

```typescript
public readonly releaseSchedule: string;
```

- *Type:* string
- *Default:* no scheduled releases

CRON schedule to trigger new releases.

---

##### `releaseTagPrefix`<sup>Optional</sup> <a name="releaseTagPrefix" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseTagPrefix"></a>

```typescript
public readonly releaseTagPrefix: string;
```

- *Type:* string
- *Default:* "v"

Automatically add the given prefix to release tags. Useful if you are releasing on multiple branches with overlapping version numbers.

Note: this prefix is used to detect the latest tagged version
when bumping, so if you change this on a project with an existing version
history, you may need to manually tag your latest release
with the new prefix.

---

##### `releaseTrigger`<sup>Optional</sup> <a name="releaseTrigger" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseTrigger"></a>

```typescript
public readonly releaseTrigger: ReleaseTrigger;
```

- *Type:* projen.release.ReleaseTrigger
- *Default:* Continuous releases (`ReleaseTrigger.continuous()`)

The release trigger to use.

---

##### `releaseWorkflowName`<sup>Optional</sup> <a name="releaseWorkflowName" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseWorkflowName"></a>

```typescript
public readonly releaseWorkflowName: string;
```

- *Type:* string
- *Default:* "Release"

The name of the default release workflow.

---

##### `releaseWorkflowSetupSteps`<sup>Optional</sup> <a name="releaseWorkflowSetupSteps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseWorkflowSetupSteps"></a>

```typescript
public readonly releaseWorkflowSetupSteps: JobStep[];
```

- *Type:* projen.github.workflows.JobStep[]

A set of workflow steps to execute in order to setup the workflow container.

---

##### `versionrcOptions`<sup>Optional</sup> <a name="versionrcOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.versionrcOptions"></a>

```typescript
public readonly versionrcOptions: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}
- *Default:* standard configuration applicable for GitHub repositories

Custom configuration used when creating changelog with standard-version package.

Given values either append to default configuration or overwrite values in it.

---

##### `workflowContainerImage`<sup>Optional</sup> <a name="workflowContainerImage" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workflowContainerImage"></a>

```typescript
public readonly workflowContainerImage: string;
```

- *Type:* string
- *Default:* default image

Container image to use for GitHub workflows.

---

##### `workflowRunsOn`<sup>Optional</sup> <a name="workflowRunsOn" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workflowRunsOn"></a>

```typescript
public readonly workflowRunsOn: string[];
```

- *Type:* string[]
- *Default:* ["ubuntu-latest"]

Github Runner selection labels.

---

##### `defaultReleaseBranch`<sup>Required</sup> <a name="defaultReleaseBranch" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.defaultReleaseBranch"></a>

```typescript
public readonly defaultReleaseBranch: string;
```

- *Type:* string
- *Default:* "main"

The name of the main release branch.

---

##### `artifactsDirectory`<sup>Optional</sup> <a name="artifactsDirectory" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.artifactsDirectory"></a>

```typescript
public readonly artifactsDirectory: string;
```

- *Type:* string
- *Default:* "dist"

A directory which will contain build artifacts.

---

##### `autoApproveUpgrades`<sup>Optional</sup> <a name="autoApproveUpgrades" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.autoApproveUpgrades"></a>

```typescript
public readonly autoApproveUpgrades: boolean;
```

- *Type:* boolean
- *Default:* true

Automatically approve deps upgrade PRs, allowing them to be merged by mergify (if configued).

Throw if set to true but `autoApproveOptions` are not defined.

---

##### `buildWorkflow`<sup>Optional</sup> <a name="buildWorkflow" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.buildWorkflow"></a>

```typescript
public readonly buildWorkflow: boolean;
```

- *Type:* boolean
- *Default:* true if not a subproject

Define a GitHub workflow for building PRs.

---

##### `buildWorkflowTriggers`<sup>Optional</sup> <a name="buildWorkflowTriggers" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.buildWorkflowTriggers"></a>

```typescript
public readonly buildWorkflowTriggers: Triggers;
```

- *Type:* projen.github.workflows.Triggers
- *Default:* "{ pullRequest: {}, workflowDispatch: {} }"

Build workflow triggers.

---

##### `bundlerOptions`<sup>Optional</sup> <a name="bundlerOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.bundlerOptions"></a>

```typescript
public readonly bundlerOptions: BundlerOptions;
```

- *Type:* projen.javascript.BundlerOptions

Options for `Bundler`.

---

##### `codeCov`<sup>Optional</sup> <a name="codeCov" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.codeCov"></a>

```typescript
public readonly codeCov: boolean;
```

- *Type:* boolean
- *Default:* false

Define a GitHub workflow step for sending code coverage metrics to https://codecov.io/ Uses codecov/codecov-action@v3 A secret is required for private repos. Configured with `@codeCovTokenSecret`.

---

##### `codeCovTokenSecret`<sup>Optional</sup> <a name="codeCovTokenSecret" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.codeCovTokenSecret"></a>

```typescript
public readonly codeCovTokenSecret: string;
```

- *Type:* string
- *Default:* if this option is not specified, only public repositories are supported

Define the secret name for a specified https://codecov.io/ token A secret is required to send coverage for private repositories.

---

##### `copyrightOwner`<sup>Optional</sup> <a name="copyrightOwner" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.copyrightOwner"></a>

```typescript
public readonly copyrightOwner: string;
```

- *Type:* string
- *Default:* defaults to the value of authorName or "" if `authorName` is undefined.

License copyright owner.

---

##### `copyrightPeriod`<sup>Optional</sup> <a name="copyrightPeriod" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.copyrightPeriod"></a>

```typescript
public readonly copyrightPeriod: string;
```

- *Type:* string
- *Default:* current year

The copyright years to put in the LICENSE file.

---

##### `dependabot`<sup>Optional</sup> <a name="dependabot" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.dependabot"></a>

```typescript
public readonly dependabot: boolean;
```

- *Type:* boolean
- *Default:* false

Use dependabot to handle dependency upgrades.

Cannot be used in conjunction with `depsUpgrade`.

---

##### `dependabotOptions`<sup>Optional</sup> <a name="dependabotOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.dependabotOptions"></a>

```typescript
public readonly dependabotOptions: DependabotOptions;
```

- *Type:* projen.github.DependabotOptions
- *Default:* default options

Options for dependabot.

---

##### `depsUpgrade`<sup>Optional</sup> <a name="depsUpgrade" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.depsUpgrade"></a>

```typescript
public readonly depsUpgrade: boolean;
```

- *Type:* boolean
- *Default:* true

Use github workflows to handle dependency upgrades.

Cannot be used in conjunction with `dependabot`.

---

##### `depsUpgradeOptions`<sup>Optional</sup> <a name="depsUpgradeOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.depsUpgradeOptions"></a>

```typescript
public readonly depsUpgradeOptions: UpgradeDependenciesOptions;
```

- *Type:* projen.javascript.UpgradeDependenciesOptions
- *Default:* default options

Options for `UpgradeDependencies`.

---

##### `gitignore`<sup>Optional</sup> <a name="gitignore" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.gitignore"></a>

```typescript
public readonly gitignore: string[];
```

- *Type:* string[]

Additional entries to .gitignore.

---

##### `jest`<sup>Optional</sup> <a name="jest" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.jest"></a>

```typescript
public readonly jest: boolean;
```

- *Type:* boolean
- *Default:* true

Setup jest unit tests.

---

##### `jestOptions`<sup>Optional</sup> <a name="jestOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.jestOptions"></a>

```typescript
public readonly jestOptions: JestOptions;
```

- *Type:* projen.javascript.JestOptions
- *Default:* default options

Jest options.

---

##### `mutableBuild`<sup>Optional</sup> <a name="mutableBuild" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.mutableBuild"></a>

```typescript
public readonly mutableBuild: boolean;
```

- *Type:* boolean
- *Default:* true

Automatically update files modified during builds to pull-request branches.

This means
that any files synthesized by projen or e.g. test snapshots will always be up-to-date
before a PR is merged.

Implies that PR builds do not have anti-tamper checks.

---

##### ~~`npmignore`~~<sup>Optional</sup> <a name="npmignore" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmignore"></a>

- *Deprecated:* - use `project.addPackageIgnore`

```typescript
public readonly npmignore: string[];
```

- *Type:* string[]

Additional entries to .npmignore.

---

##### `npmignoreEnabled`<sup>Optional</sup> <a name="npmignoreEnabled" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmignoreEnabled"></a>

```typescript
public readonly npmignoreEnabled: boolean;
```

- *Type:* boolean
- *Default:* true

Defines an .npmignore file. Normally this is only needed for libraries that are packaged as tarballs.

---

##### `npmIgnoreOptions`<sup>Optional</sup> <a name="npmIgnoreOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.npmIgnoreOptions"></a>

```typescript
public readonly npmIgnoreOptions: IgnoreFileOptions;
```

- *Type:* projen.IgnoreFileOptions

Configuration options for .npmignore file.

---

##### `package`<sup>Optional</sup> <a name="package" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.package"></a>

```typescript
public readonly package: boolean;
```

- *Type:* boolean
- *Default:* true

Defines a `package` task that will produce an npm tarball under the artifacts directory (e.g. `dist`).

---

##### `prettier`<sup>Optional</sup> <a name="prettier" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.prettier"></a>

```typescript
public readonly prettier: boolean;
```

- *Type:* boolean
- *Default:* false

Setup prettier.

---

##### `prettierOptions`<sup>Optional</sup> <a name="prettierOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.prettierOptions"></a>

```typescript
public readonly prettierOptions: PrettierOptions;
```

- *Type:* projen.javascript.PrettierOptions
- *Default:* default options

Prettier options.

---

##### `projenDevDependency`<sup>Optional</sup> <a name="projenDevDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenDevDependency"></a>

```typescript
public readonly projenDevDependency: boolean;
```

- *Type:* boolean
- *Default:* true

Indicates of "projen" should be installed as a devDependency.

---

##### `projenrcJs`<sup>Optional</sup> <a name="projenrcJs" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenrcJs"></a>

```typescript
public readonly projenrcJs: boolean;
```

- *Type:* boolean
- *Default:* true if projenrcJson is false

Generate (once) .projenrc.js (in JavaScript). Set to `false` in order to disable .projenrc.js generation.

---

##### `projenrcJsOptions`<sup>Optional</sup> <a name="projenrcJsOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenrcJsOptions"></a>

```typescript
public readonly projenrcJsOptions: ProjenrcOptions;
```

- *Type:* projen.javascript.ProjenrcOptions
- *Default:* default options

Options for .projenrc.js.

---

##### `projenVersion`<sup>Optional</sup> <a name="projenVersion" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenVersion"></a>

```typescript
public readonly projenVersion: string;
```

- *Type:* string
- *Default:* Defaults to the latest version.

Version of projen to install.

---

##### `pullRequestTemplate`<sup>Optional</sup> <a name="pullRequestTemplate" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.pullRequestTemplate"></a>

```typescript
public readonly pullRequestTemplate: boolean;
```

- *Type:* boolean
- *Default:* true

Include a GitHub pull request template.

---

##### `pullRequestTemplateContents`<sup>Optional</sup> <a name="pullRequestTemplateContents" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.pullRequestTemplateContents"></a>

```typescript
public readonly pullRequestTemplateContents: string[];
```

- *Type:* string[]
- *Default:* default content

The contents of the pull request template.

---

##### `release`<sup>Optional</sup> <a name="release" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.release"></a>

```typescript
public readonly release: boolean;
```

- *Type:* boolean
- *Default:* true (false for subprojects)

Add release management to this project.

---

##### `releaseToNpm`<sup>Optional</sup> <a name="releaseToNpm" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseToNpm"></a>

```typescript
public readonly releaseToNpm: boolean;
```

- *Type:* boolean
- *Default:* false

Automatically release to npm when new versions are introduced.

---

##### ~~`releaseWorkflow`~~<sup>Optional</sup> <a name="releaseWorkflow" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.releaseWorkflow"></a>

- *Deprecated:* see `release`.

```typescript
public readonly releaseWorkflow: boolean;
```

- *Type:* boolean
- *Default:* true if not a subproject

DEPRECATED: renamed to `release`.

---

##### `workflowBootstrapSteps`<sup>Optional</sup> <a name="workflowBootstrapSteps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workflowBootstrapSteps"></a>

```typescript
public readonly workflowBootstrapSteps: JobStep[];
```

- *Type:* projen.github.workflows.JobStep[]
- *Default:* "yarn install --frozen-lockfile && yarn projen"

Workflow steps to use in order to bootstrap this repo.

---

##### `workflowGitIdentity`<sup>Optional</sup> <a name="workflowGitIdentity" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workflowGitIdentity"></a>

```typescript
public readonly workflowGitIdentity: GitIdentity;
```

- *Type:* projen.github.GitIdentity
- *Default:* GitHub Actions

The git identity to use in workflows.

---

##### `workflowNodeVersion`<sup>Optional</sup> <a name="workflowNodeVersion" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workflowNodeVersion"></a>

```typescript
public readonly workflowNodeVersion: string;
```

- *Type:* string
- *Default:* same as `minNodeVersion`

The node version to use in GitHub workflows.

---

##### `workflowPackageCache`<sup>Optional</sup> <a name="workflowPackageCache" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workflowPackageCache"></a>

```typescript
public readonly workflowPackageCache: boolean;
```

- *Type:* boolean
- *Default:* false

Enable Node.js package cache in GitHub workflows.

---

##### `disableTsconfig`<sup>Optional</sup> <a name="disableTsconfig" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.disableTsconfig"></a>

```typescript
public readonly disableTsconfig: boolean;
```

- *Type:* boolean
- *Default:* false

Do not generate a `tsconfig.json` file (used by jsii projects since tsconfig.json is generated by the jsii compiler).

---

##### `disableTsconfigDev`<sup>Optional</sup> <a name="disableTsconfigDev" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.disableTsconfigDev"></a>

```typescript
public readonly disableTsconfigDev: boolean;
```

- *Type:* boolean
- *Default:* false

Do not generate a `tsconfig.dev.json` file.

---

##### `docgen`<sup>Optional</sup> <a name="docgen" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.docgen"></a>

```typescript
public readonly docgen: boolean;
```

- *Type:* boolean
- *Default:* false

Docgen by Typedoc.

---

##### `docsDirectory`<sup>Optional</sup> <a name="docsDirectory" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.docsDirectory"></a>

```typescript
public readonly docsDirectory: string;
```

- *Type:* string
- *Default:* "docs"

Docs directory.

---

##### `entrypointTypes`<sup>Optional</sup> <a name="entrypointTypes" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.entrypointTypes"></a>

```typescript
public readonly entrypointTypes: string;
```

- *Type:* string
- *Default:* .d.ts file derived from the project's entrypoint (usually lib/index.d.ts)

The .d.ts file that includes the type declarations for this module.

---

##### `eslint`<sup>Optional</sup> <a name="eslint" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.eslint"></a>

```typescript
public readonly eslint: boolean;
```

- *Type:* boolean
- *Default:* true

Setup eslint.

---

##### `eslintOptions`<sup>Optional</sup> <a name="eslintOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.eslintOptions"></a>

```typescript
public readonly eslintOptions: EslintOptions;
```

- *Type:* projen.javascript.EslintOptions
- *Default:* opinionated default options

Eslint options.

---

##### `libdir`<sup>Optional</sup> <a name="libdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.libdir"></a>

```typescript
public readonly libdir: string;
```

- *Type:* string
- *Default:* "lib"

Typescript  artifacts output directory.

---

##### `projenrcTs`<sup>Optional</sup> <a name="projenrcTs" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenrcTs"></a>

```typescript
public readonly projenrcTs: boolean;
```

- *Type:* boolean
- *Default:* false

Use TypeScript for your projenrc file (`.projenrc.ts`).

---

##### `projenrcTsOptions`<sup>Optional</sup> <a name="projenrcTsOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.projenrcTsOptions"></a>

```typescript
public readonly projenrcTsOptions: ProjenrcOptions;
```

- *Type:* projen.typescript.ProjenrcOptions

Options for .projenrc.ts.

---

##### `sampleCode`<sup>Optional</sup> <a name="sampleCode" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.sampleCode"></a>

```typescript
public readonly sampleCode: boolean;
```

- *Type:* boolean
- *Default:* true

Generate one-time sample in `src/` and `test/` if there are no files there.

---

##### `srcdir`<sup>Optional</sup> <a name="srcdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.srcdir"></a>

```typescript
public readonly srcdir: string;
```

- *Type:* string
- *Default:* "src"

Typescript sources directory.

---

##### `testdir`<sup>Optional</sup> <a name="testdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.testdir"></a>

```typescript
public readonly testdir: string;
```

- *Type:* string
- *Default:* "test"

Jest tests directory. Tests files should be named `xxx.test.ts`.

If this directory is under `srcdir` (e.g. `src/test`, `src/__tests__`),
then tests are going to be compiled into `lib/` and executed as javascript.
If the test directory is outside of `src`, then we configure jest to
compile the code in-memory.

---

##### `tsconfig`<sup>Optional</sup> <a name="tsconfig" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.tsconfig"></a>

```typescript
public readonly tsconfig: TypescriptConfigOptions;
```

- *Type:* projen.javascript.TypescriptConfigOptions
- *Default:* default options

Custom TSConfig.

---

##### `tsconfigDev`<sup>Optional</sup> <a name="tsconfigDev" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.tsconfigDev"></a>

```typescript
public readonly tsconfigDev: TypescriptConfigOptions;
```

- *Type:* projen.javascript.TypescriptConfigOptions
- *Default:* use the production tsconfig options

Custom tsconfig options for the development tsconfig.json file (used for testing).

---

##### `tsconfigDevFile`<sup>Optional</sup> <a name="tsconfigDevFile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.tsconfigDevFile"></a>

```typescript
public readonly tsconfigDevFile: string;
```

- *Type:* string
- *Default:* "tsconfig.dev.json"

The name of the development tsconfig.json file.

---

##### `typescriptVersion`<sup>Optional</sup> <a name="typescriptVersion" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.typescriptVersion"></a>

```typescript
public readonly typescriptVersion: string;
```

- *Type:* string
- *Default:* "latest"

TypeScript version to use.

NOTE: Typescript is not semantically versioned and should remain on the
same minor, so we recommend using a `~` dependency (e.g. `~1.2.3`).

---

##### `disableNodeWarnings`<sup>Optional</sup> <a name="disableNodeWarnings" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.disableNodeWarnings"></a>

```typescript
public readonly disableNodeWarnings: boolean;
```

- *Type:* boolean
- *Default:* false

Disable node warnings from being emitted during build tasks.

---

##### `monorepoUpgradeDeps`<sup>Optional</sup> <a name="monorepoUpgradeDeps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.monorepoUpgradeDeps"></a>

```typescript
public readonly monorepoUpgradeDeps: boolean;
```

- *Type:* boolean
- *Default:* true

Whether to include an upgrade-deps task at the root of the monorepo which will upgrade all dependencies.

---

##### `monorepoUpgradeDepsOptions`<sup>Optional</sup> <a name="monorepoUpgradeDepsOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.monorepoUpgradeDepsOptions"></a>

```typescript
public readonly monorepoUpgradeDepsOptions: MonorepoUpgradeDepsOptions;
```

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.MonorepoUpgradeDepsOptions">MonorepoUpgradeDepsOptions</a>
- *Default:* undefined

Monorepo Upgrade Deps options.

This is only used if monorepoUpgradeDeps is true.

---

##### `workspaceConfig`<sup>Optional</sup> <a name="workspaceConfig" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions.property.workspaceConfig"></a>

```typescript
public readonly workspaceConfig: WorkspaceConfig;
```

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.WorkspaceConfig">WorkspaceConfig</a>

Configuration for workspace.

---

### NxMonorepoPythonProjectOptions <a name="NxMonorepoPythonProjectOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions"></a>

Configuration options for the NxMonorepoPythonProject.

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.Initializer"></a>

```typescript
import { NxMonorepoPythonProjectOptions } from '@aws-prototyping-sdk/nx-monorepo'

const nxMonorepoPythonProjectOptions: NxMonorepoPythonProjectOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.name">name</a></code> | <code>string</code> | This is the name of your project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.commitGenerated">commitGenerated</a></code> | <code>boolean</code> | Whether to commit the managed files by default. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.gitIgnoreOptions">gitIgnoreOptions</a></code> | <code>projen.IgnoreFileOptions</code> | Configuration options for .gitignore file. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.gitOptions">gitOptions</a></code> | <code>projen.GitOptions</code> | Configuration options for git. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.logging">logging</a></code> | <code>projen.LoggerOptions</code> | Configure logging options such as verbosity. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.outdir">outdir</a></code> | <code>string</code> | The root directory of the project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.parent">parent</a></code> | <code>projen.Project</code> | The parent project, if this project is part of a bigger project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenCommand">projenCommand</a></code> | <code>string</code> | The shell command to use in order to run the projen CLI. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcJson">projenrcJson</a></code> | <code>boolean</code> | Generate (once) .projenrc.json (in JSON). Set to `false` in order to disable .projenrc.json generation. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcJsonOptions">projenrcJsonOptions</a></code> | <code>projen.ProjenrcJsonOptions</code> | Options for .projenrc.json. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.renovatebot">renovatebot</a></code> | <code>boolean</code> | Use renovatebot to handle dependency upgrades. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.renovatebotOptions">renovatebotOptions</a></code> | <code>projen.RenovatebotOptions</code> | Options for renovatebot. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.autoApproveOptions">autoApproveOptions</a></code> | <code>projen.github.AutoApproveOptions</code> | Enable and configure the 'auto approve' workflow. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.autoMerge">autoMerge</a></code> | <code>boolean</code> | Enable automatic merging on GitHub. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.autoMergeOptions">autoMergeOptions</a></code> | <code>projen.github.AutoMergeOptions</code> | Configure options for automatic merging on GitHub. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.clobber">clobber</a></code> | <code>boolean</code> | Add a `clobber` task which resets the repo to origin. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.devContainer">devContainer</a></code> | <code>boolean</code> | Add a VSCode development environment (used for GitHub Codespaces). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.github">github</a></code> | <code>boolean</code> | Enable GitHub integration. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.githubOptions">githubOptions</a></code> | <code>projen.github.GitHubOptions</code> | Options for GitHub integration. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.gitpod">gitpod</a></code> | <code>boolean</code> | Add a Gitpod development environment. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.mergify">mergify</a></code> | <code>boolean</code> | Whether mergify should be enabled on this repository or not. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.mergifyOptions">mergifyOptions</a></code> | <code>projen.github.MergifyOptions</code> | Options for mergify. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projectType">projectType</a></code> | <code>projen.ProjectType</code> | Which type of project this is (library/app). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenCredentials">projenCredentials</a></code> | <code>projen.github.GithubCredentials</code> | Choose a method of providing GitHub API access for projen workflows. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenTokenSecret">projenTokenSecret</a></code> | <code>string</code> | The name of a secret which includes a GitHub Personal Access Token to be used by projen workflows. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.readme">readme</a></code> | <code>projen.SampleReadmeProps</code> | The README setup. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.stale">stale</a></code> | <code>boolean</code> | Auto-close of stale issues and pull request. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.staleOptions">staleOptions</a></code> | <code>projen.github.StaleOptions</code> | Auto-close stale issues and pull requests. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.vscode">vscode</a></code> | <code>boolean</code> | Enable VSCode integration. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.authorEmail">authorEmail</a></code> | <code>string</code> | Author's e-mail. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.authorName">authorName</a></code> | <code>string</code> | Author's name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.version">version</a></code> | <code>string</code> | Version of the package. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.classifiers">classifiers</a></code> | <code>string[]</code> | A list of PyPI trove classifiers that describe the project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.description">description</a></code> | <code>string</code> | A short description of the package. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.homepage">homepage</a></code> | <code>string</code> | A URL to the website of the project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.license">license</a></code> | <code>string</code> | License of this package as an SPDX identifier. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.packageName">packageName</a></code> | <code>string</code> | Package name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.poetryOptions">poetryOptions</a></code> | <code>projen.python.PoetryPyprojectOptionsWithoutDeps</code> | Additional options to set for poetry if using poetry. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.setupConfig">setupConfig</a></code> | <code>{[ key: string ]: any}</code> | Additional fields to pass in the setup() function if using setuptools. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.moduleName">moduleName</a></code> | <code>string</code> | Name of the python package as used in imports and filenames. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.deps">deps</a></code> | <code>string[]</code> | List of runtime dependencies for this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.devDeps">devDeps</a></code> | <code>string[]</code> | List of dev dependencies for this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.pip">pip</a></code> | <code>boolean</code> | Use pip with a requirements.txt file to track project dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.poetry">poetry</a></code> | <code>boolean</code> | Use poetry to manage your project dependencies, virtual environment, and (optional) packaging/publishing. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcJs">projenrcJs</a></code> | <code>boolean</code> | Use projenrc in javascript. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcJsOptions">projenrcJsOptions</a></code> | <code>projen.javascript.ProjenrcOptions</code> | Options related to projenrc in JavaScript. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcPython">projenrcPython</a></code> | <code>boolean</code> | Use projenrc in Python. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcPythonOptions">projenrcPythonOptions</a></code> | <code>projen.python.ProjenrcOptions</code> | Options related to projenrc in python. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcTs">projenrcTs</a></code> | <code>boolean</code> | Use projenrc in TypeScript. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcTsOptions">projenrcTsOptions</a></code> | <code>projen.typescript.ProjenrcTsOptions</code> | Options related to projenrc in TypeScript. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.pytest">pytest</a></code> | <code>boolean</code> | Include pytest tests. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.pytestOptions">pytestOptions</a></code> | <code>projen.python.PytestOptions</code> | pytest options. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.pythonExec">pythonExec</a></code> | <code>string</code> | Path to the python executable to use. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.sample">sample</a></code> | <code>boolean</code> | Include sample code and test if the relevant directories don't exist. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.setuptools">setuptools</a></code> | <code>boolean</code> | Use setuptools with a setup.py script for packaging and publishing. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.venv">venv</a></code> | <code>boolean</code> | Use venv to manage a virtual environment for installing dependencies inside. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.venvOptions">venvOptions</a></code> | <code>projen.python.VenvOptions</code> | Venv options. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.defaultReleaseBranch">defaultReleaseBranch</a></code> | <code>string</code> | *No description.* |

---

##### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string
- *Default:* $BASEDIR

This is the name of your project.

---

##### `commitGenerated`<sup>Optional</sup> <a name="commitGenerated" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.commitGenerated"></a>

```typescript
public readonly commitGenerated: boolean;
```

- *Type:* boolean
- *Default:* true

Whether to commit the managed files by default.

---

##### `gitIgnoreOptions`<sup>Optional</sup> <a name="gitIgnoreOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.gitIgnoreOptions"></a>

```typescript
public readonly gitIgnoreOptions: IgnoreFileOptions;
```

- *Type:* projen.IgnoreFileOptions

Configuration options for .gitignore file.

---

##### `gitOptions`<sup>Optional</sup> <a name="gitOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.gitOptions"></a>

```typescript
public readonly gitOptions: GitOptions;
```

- *Type:* projen.GitOptions

Configuration options for git.

---

##### `logging`<sup>Optional</sup> <a name="logging" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.logging"></a>

```typescript
public readonly logging: LoggerOptions;
```

- *Type:* projen.LoggerOptions
- *Default:* {}

Configure logging options such as verbosity.

---

##### `outdir`<sup>Optional</sup> <a name="outdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.outdir"></a>

```typescript
public readonly outdir: string;
```

- *Type:* string
- *Default:* "."

The root directory of the project.

Relative to this directory, all files are synthesized.

If this project has a parent, this directory is relative to the parent
directory and it cannot be the same as the parent or any of it's other
sub-projects.

---

##### `parent`<sup>Optional</sup> <a name="parent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.parent"></a>

```typescript
public readonly parent: Project;
```

- *Type:* projen.Project

The parent project, if this project is part of a bigger project.

---

##### `projenCommand`<sup>Optional</sup> <a name="projenCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenCommand"></a>

```typescript
public readonly projenCommand: string;
```

- *Type:* string
- *Default:* "npx projen"

The shell command to use in order to run the projen CLI.

Can be used to customize in special environments.

---

##### `projenrcJson`<sup>Optional</sup> <a name="projenrcJson" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcJson"></a>

```typescript
public readonly projenrcJson: boolean;
```

- *Type:* boolean
- *Default:* false

Generate (once) .projenrc.json (in JSON). Set to `false` in order to disable .projenrc.json generation.

---

##### `projenrcJsonOptions`<sup>Optional</sup> <a name="projenrcJsonOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcJsonOptions"></a>

```typescript
public readonly projenrcJsonOptions: ProjenrcJsonOptions;
```

- *Type:* projen.ProjenrcJsonOptions
- *Default:* default options

Options for .projenrc.json.

---

##### `renovatebot`<sup>Optional</sup> <a name="renovatebot" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.renovatebot"></a>

```typescript
public readonly renovatebot: boolean;
```

- *Type:* boolean
- *Default:* false

Use renovatebot to handle dependency upgrades.

---

##### `renovatebotOptions`<sup>Optional</sup> <a name="renovatebotOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.renovatebotOptions"></a>

```typescript
public readonly renovatebotOptions: RenovatebotOptions;
```

- *Type:* projen.RenovatebotOptions
- *Default:* default options

Options for renovatebot.

---

##### `autoApproveOptions`<sup>Optional</sup> <a name="autoApproveOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.autoApproveOptions"></a>

```typescript
public readonly autoApproveOptions: AutoApproveOptions;
```

- *Type:* projen.github.AutoApproveOptions
- *Default:* auto approve is disabled

Enable and configure the 'auto approve' workflow.

---

##### `autoMerge`<sup>Optional</sup> <a name="autoMerge" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.autoMerge"></a>

```typescript
public readonly autoMerge: boolean;
```

- *Type:* boolean
- *Default:* true

Enable automatic merging on GitHub.

Has no effect if `github.mergify`
is set to false.

---

##### `autoMergeOptions`<sup>Optional</sup> <a name="autoMergeOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.autoMergeOptions"></a>

```typescript
public readonly autoMergeOptions: AutoMergeOptions;
```

- *Type:* projen.github.AutoMergeOptions
- *Default:* see defaults in `AutoMergeOptions`

Configure options for automatic merging on GitHub.

Has no effect if
`github.mergify` or `autoMerge` is set to false.

---

##### `clobber`<sup>Optional</sup> <a name="clobber" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.clobber"></a>

```typescript
public readonly clobber: boolean;
```

- *Type:* boolean
- *Default:* true, but false for subprojects

Add a `clobber` task which resets the repo to origin.

---

##### `devContainer`<sup>Optional</sup> <a name="devContainer" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.devContainer"></a>

```typescript
public readonly devContainer: boolean;
```

- *Type:* boolean
- *Default:* false

Add a VSCode development environment (used for GitHub Codespaces).

---

##### `github`<sup>Optional</sup> <a name="github" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.github"></a>

```typescript
public readonly github: boolean;
```

- *Type:* boolean
- *Default:* true

Enable GitHub integration.

Enabled by default for root projects. Disabled for non-root projects.

---

##### `githubOptions`<sup>Optional</sup> <a name="githubOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.githubOptions"></a>

```typescript
public readonly githubOptions: GitHubOptions;
```

- *Type:* projen.github.GitHubOptions
- *Default:* see GitHubOptions

Options for GitHub integration.

---

##### `gitpod`<sup>Optional</sup> <a name="gitpod" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.gitpod"></a>

```typescript
public readonly gitpod: boolean;
```

- *Type:* boolean
- *Default:* false

Add a Gitpod development environment.

---

##### ~~`mergify`~~<sup>Optional</sup> <a name="mergify" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.mergify"></a>

- *Deprecated:* use `githubOptions.mergify` instead

```typescript
public readonly mergify: boolean;
```

- *Type:* boolean
- *Default:* true

Whether mergify should be enabled on this repository or not.

---

##### ~~`mergifyOptions`~~<sup>Optional</sup> <a name="mergifyOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.mergifyOptions"></a>

- *Deprecated:* use `githubOptions.mergifyOptions` instead

```typescript
public readonly mergifyOptions: MergifyOptions;
```

- *Type:* projen.github.MergifyOptions
- *Default:* default options

Options for mergify.

---

##### ~~`projectType`~~<sup>Optional</sup> <a name="projectType" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projectType"></a>

- *Deprecated:* no longer supported at the base project level

```typescript
public readonly projectType: ProjectType;
```

- *Type:* projen.ProjectType
- *Default:* ProjectType.UNKNOWN

Which type of project this is (library/app).

---

##### `projenCredentials`<sup>Optional</sup> <a name="projenCredentials" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenCredentials"></a>

```typescript
public readonly projenCredentials: GithubCredentials;
```

- *Type:* projen.github.GithubCredentials
- *Default:* use a personal access token named PROJEN_GITHUB_TOKEN

Choose a method of providing GitHub API access for projen workflows.

---

##### ~~`projenTokenSecret`~~<sup>Optional</sup> <a name="projenTokenSecret" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenTokenSecret"></a>

- *Deprecated:* use `projenCredentials`

```typescript
public readonly projenTokenSecret: string;
```

- *Type:* string
- *Default:* "PROJEN_GITHUB_TOKEN"

The name of a secret which includes a GitHub Personal Access Token to be used by projen workflows.

This token needs to have the `repo`, `workflows`
and `packages` scope.

---

##### `readme`<sup>Optional</sup> <a name="readme" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.readme"></a>

```typescript
public readonly readme: SampleReadmeProps;
```

- *Type:* projen.SampleReadmeProps
- *Default:* { filename: 'README.md', contents: '# replace this' }

The README setup.

---

*Example*

```typescript
"{ filename: 'readme.md', contents: '# title' }"
```


##### `stale`<sup>Optional</sup> <a name="stale" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.stale"></a>

```typescript
public readonly stale: boolean;
```

- *Type:* boolean
- *Default:* false

Auto-close of stale issues and pull request.

See `staleOptions` for options.

---

##### `staleOptions`<sup>Optional</sup> <a name="staleOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.staleOptions"></a>

```typescript
public readonly staleOptions: StaleOptions;
```

- *Type:* projen.github.StaleOptions
- *Default:* see defaults in `StaleOptions`

Auto-close stale issues and pull requests.

To disable set `stale` to `false`.

---

##### `vscode`<sup>Optional</sup> <a name="vscode" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.vscode"></a>

```typescript
public readonly vscode: boolean;
```

- *Type:* boolean
- *Default:* true

Enable VSCode integration.

Enabled by default for root projects. Disabled for non-root projects.

---

##### `authorEmail`<sup>Required</sup> <a name="authorEmail" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.authorEmail"></a>

```typescript
public readonly authorEmail: string;
```

- *Type:* string
- *Default:* $GIT_USER_EMAIL

Author's e-mail.

---

##### `authorName`<sup>Required</sup> <a name="authorName" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.authorName"></a>

```typescript
public readonly authorName: string;
```

- *Type:* string
- *Default:* $GIT_USER_NAME

Author's name.

---

##### `version`<sup>Required</sup> <a name="version" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string
- *Default:* "0.1.0"

Version of the package.

---

##### `classifiers`<sup>Optional</sup> <a name="classifiers" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.classifiers"></a>

```typescript
public readonly classifiers: string[];
```

- *Type:* string[]

A list of PyPI trove classifiers that describe the project.

> [https://pypi.org/classifiers/](https://pypi.org/classifiers/)

---

##### `description`<sup>Optional</sup> <a name="description" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.description"></a>

```typescript
public readonly description: string;
```

- *Type:* string

A short description of the package.

---

##### `homepage`<sup>Optional</sup> <a name="homepage" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.homepage"></a>

```typescript
public readonly homepage: string;
```

- *Type:* string

A URL to the website of the project.

---

##### `license`<sup>Optional</sup> <a name="license" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.license"></a>

```typescript
public readonly license: string;
```

- *Type:* string

License of this package as an SPDX identifier.

---

##### `packageName`<sup>Optional</sup> <a name="packageName" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.packageName"></a>

```typescript
public readonly packageName: string;
```

- *Type:* string

Package name.

---

##### `poetryOptions`<sup>Optional</sup> <a name="poetryOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.poetryOptions"></a>

```typescript
public readonly poetryOptions: PoetryPyprojectOptionsWithoutDeps;
```

- *Type:* projen.python.PoetryPyprojectOptionsWithoutDeps

Additional options to set for poetry if using poetry.

---

##### `setupConfig`<sup>Optional</sup> <a name="setupConfig" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.setupConfig"></a>

```typescript
public readonly setupConfig: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

Additional fields to pass in the setup() function if using setuptools.

---

##### `moduleName`<sup>Required</sup> <a name="moduleName" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.moduleName"></a>

```typescript
public readonly moduleName: string;
```

- *Type:* string
- *Default:* $PYTHON_MODULE_NAME

Name of the python package as used in imports and filenames.

Must only consist of alphanumeric characters and underscores.

---

##### `deps`<sup>Optional</sup> <a name="deps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.deps"></a>

```typescript
public readonly deps: string[];
```

- *Type:* string[]
- *Default:* []

List of runtime dependencies for this project.

Dependencies use the format: `<module>@<semver>`

Additional dependencies can be added via `project.addDependency()`.

---

##### `devDeps`<sup>Optional</sup> <a name="devDeps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.devDeps"></a>

```typescript
public readonly devDeps: string[];
```

- *Type:* string[]
- *Default:* []

List of dev dependencies for this project.

Dependencies use the format: `<module>@<semver>`

Additional dependencies can be added via `project.addDevDependency()`.

---

##### `pip`<sup>Optional</sup> <a name="pip" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.pip"></a>

```typescript
public readonly pip: boolean;
```

- *Type:* boolean
- *Default:* true, unless poetry is true, then false

Use pip with a requirements.txt file to track project dependencies.

---

##### `poetry`<sup>Optional</sup> <a name="poetry" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.poetry"></a>

```typescript
public readonly poetry: boolean;
```

- *Type:* boolean
- *Default:* false

Use poetry to manage your project dependencies, virtual environment, and (optional) packaging/publishing.

This feature is incompatible with pip, setuptools, or venv.
If you set this option to `true`, then pip, setuptools, and venv must be set to `false`.

---

##### `projenrcJs`<sup>Optional</sup> <a name="projenrcJs" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcJs"></a>

```typescript
public readonly projenrcJs: boolean;
```

- *Type:* boolean
- *Default:* false

Use projenrc in javascript.

This will install `projen` as a JavaScript dependency and add a `synth`
task which will run `.projenrc.js`.

---

##### `projenrcJsOptions`<sup>Optional</sup> <a name="projenrcJsOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcJsOptions"></a>

```typescript
public readonly projenrcJsOptions: ProjenrcOptions;
```

- *Type:* projen.javascript.ProjenrcOptions
- *Default:* default options

Options related to projenrc in JavaScript.

---

##### `projenrcPython`<sup>Optional</sup> <a name="projenrcPython" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcPython"></a>

```typescript
public readonly projenrcPython: boolean;
```

- *Type:* boolean
- *Default:* true

Use projenrc in Python.

This will install `projen` as a Python dependency and add a `synth`
task which will run `.projenrc.py`.

---

##### `projenrcPythonOptions`<sup>Optional</sup> <a name="projenrcPythonOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcPythonOptions"></a>

```typescript
public readonly projenrcPythonOptions: ProjenrcOptions;
```

- *Type:* projen.python.ProjenrcOptions
- *Default:* default options

Options related to projenrc in python.

---

##### `projenrcTs`<sup>Optional</sup> <a name="projenrcTs" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcTs"></a>

```typescript
public readonly projenrcTs: boolean;
```

- *Type:* boolean
- *Default:* false

Use projenrc in TypeScript.

This will create a tsconfig file (default: `tsconfig.projen.json`)
and use `ts-node` in the default task to parse the project source files.

---

##### `projenrcTsOptions`<sup>Optional</sup> <a name="projenrcTsOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.projenrcTsOptions"></a>

```typescript
public readonly projenrcTsOptions: ProjenrcTsOptions;
```

- *Type:* projen.typescript.ProjenrcTsOptions
- *Default:* default options

Options related to projenrc in TypeScript.

---

##### `pytest`<sup>Optional</sup> <a name="pytest" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.pytest"></a>

```typescript
public readonly pytest: boolean;
```

- *Type:* boolean
- *Default:* true

Include pytest tests.

---

##### `pytestOptions`<sup>Optional</sup> <a name="pytestOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.pytestOptions"></a>

```typescript
public readonly pytestOptions: PytestOptions;
```

- *Type:* projen.python.PytestOptions
- *Default:* defaults

pytest options.

---

##### `pythonExec`<sup>Optional</sup> <a name="pythonExec" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.pythonExec"></a>

```typescript
public readonly pythonExec: string;
```

- *Type:* string
- *Default:* "python"

Path to the python executable to use.

---

##### `sample`<sup>Optional</sup> <a name="sample" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.sample"></a>

```typescript
public readonly sample: boolean;
```

- *Type:* boolean
- *Default:* true

Include sample code and test if the relevant directories don't exist.

---

##### `setuptools`<sup>Optional</sup> <a name="setuptools" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.setuptools"></a>

```typescript
public readonly setuptools: boolean;
```

- *Type:* boolean
- *Default:* true, unless poetry is true, then false

Use setuptools with a setup.py script for packaging and publishing.

---

##### `venv`<sup>Optional</sup> <a name="venv" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.venv"></a>

```typescript
public readonly venv: boolean;
```

- *Type:* boolean
- *Default:* true, unless poetry is true, then false

Use venv to manage a virtual environment for installing dependencies inside.

---

##### `venvOptions`<sup>Optional</sup> <a name="venvOptions" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.venvOptions"></a>

```typescript
public readonly venvOptions: VenvOptions;
```

- *Type:* projen.python.VenvOptions
- *Default:* defaults

Venv options.

---

##### `defaultReleaseBranch`<sup>Optional</sup> <a name="defaultReleaseBranch" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions.property.defaultReleaseBranch"></a>

```typescript
public readonly defaultReleaseBranch: string;
```

- *Type:* string

---

### ProjectConfig <a name="ProjectConfig" id="@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig"></a>

> [https://github.com/nrwl/nx/blob/master/packages/nx/schemas/project-schema.json](https://github.com/nrwl/nx/blob/master/packages/nx/schemas/project-schema.json)

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.Initializer"></a>

```typescript
import { Nx } from '@aws-prototyping-sdk/nx-monorepo'

const projectConfig: Nx.ProjectConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.implicitDependencies">implicitDependencies</a></code> | <code>string[]</code> | Implicit dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.includedScripts">includedScripts</a></code> | <code>string[]</code> | Explicit list of scripts for Nx to include. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.name">name</a></code> | <code>string</code> | Name of project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.namedInputs">namedInputs</a></code> | <code>{[ key: string ]: string[]}</code> | Named inputs. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.root">root</a></code> | <code>string</code> | Project root dir path relative to workspace. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.tags">tags</a></code> | <code>string[]</code> | Project tag annotations. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.targets">targets</a></code> | <code>{[ key: string ]: @aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget}</code> | Targets configuration. |

---

##### `implicitDependencies`<sup>Optional</sup> <a name="implicitDependencies" id="@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.implicitDependencies"></a>

```typescript
public readonly implicitDependencies: string[];
```

- *Type:* string[]

Implicit dependencies.

> [https://nx.dev/reference/project-configuration#implicitdependencies](https://nx.dev/reference/project-configuration#implicitdependencies)

---

##### `includedScripts`<sup>Optional</sup> <a name="includedScripts" id="@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.includedScripts"></a>

```typescript
public readonly includedScripts: string[];
```

- *Type:* string[]

Explicit list of scripts for Nx to include.

> [https://nx.dev/reference/project-configuration#ignoring-package.json-scripts](https://nx.dev/reference/project-configuration#ignoring-package.json-scripts)

---

##### `name`<sup>Optional</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Name of project.

---

##### `namedInputs`<sup>Optional</sup> <a name="namedInputs" id="@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.namedInputs"></a>

```typescript
public readonly namedInputs: {[ key: string ]: string[]};
```

- *Type:* {[ key: string ]: string[]}

Named inputs.

> [https://nx.dev/reference/nx-json#inputs-&-namedinputs](https://nx.dev/reference/nx-json#inputs-&-namedinputs)

---

##### `root`<sup>Optional</sup> <a name="root" id="@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.root"></a>

```typescript
public readonly root: string;
```

- *Type:* string

Project root dir path relative to workspace.

---

##### `tags`<sup>Optional</sup> <a name="tags" id="@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* string[]

Project tag annotations.

> [https://nx.dev/reference/project-configuration#tags](https://nx.dev/reference/project-configuration#tags)

---

##### `targets`<sup>Optional</sup> <a name="targets" id="@aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig.property.targets"></a>

```typescript
public readonly targets: {[ key: string ]: IProjectTarget};
```

- *Type:* {[ key: string ]: @aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget}

Targets configuration.

> [https://nx.dev/reference/project-configuration](https://nx.dev/reference/project-configuration)

---

### RunManyOptions <a name="RunManyOptions" id="@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions"></a>

> [https://nx.dev/packages/nx/documents/run-many#options](https://nx.dev/packages/nx/documents/run-many#options)

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.Initializer"></a>

```typescript
import { Nx } from '@aws-prototyping-sdk/nx-monorepo'

const runManyOptions: Nx.RunManyOptions = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.target">target</a></code> | <code>string</code> | Task to run for affected projects. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.configuration">configuration</a></code> | <code>string</code> | This is the configuration to use when performing tasks on projects. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.exclude">exclude</a></code> | <code>string</code> | Exclude certain projects from being processed. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.ignoreCycles">ignoreCycles</a></code> | <code>boolean</code> | Ignore cycles in the task graph. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.noBail">noBail</a></code> | <code>boolean</code> | Do not stop command execution after the first failed task. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.outputStyle">outputStyle</a></code> | <code>string</code> | Defines how Nx emits outputs tasks logs. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.parallel">parallel</a></code> | <code>number</code> | Max number of parallel processes. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.projects">projects</a></code> | <code>string[]</code> | Project to run as list project names and/or patterns. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.runner">runner</a></code> | <code>string</code> | This is the name of the tasks runner configuration in nx.json. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.skipCache">skipCache</a></code> | <code>boolean</code> | Rerun the tasks even when the results are available in the cache. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.verbose">verbose</a></code> | <code>boolean</code> | Prints additional information about the commands (e.g. stack traces). |

---

##### `target`<sup>Required</sup> <a name="target" id="@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.target"></a>

```typescript
public readonly target: string;
```

- *Type:* string

Task to run for affected projects.

---

##### `configuration`<sup>Optional</sup> <a name="configuration" id="@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.configuration"></a>

```typescript
public readonly configuration: string;
```

- *Type:* string

This is the configuration to use when performing tasks on projects.

---

##### `exclude`<sup>Optional</sup> <a name="exclude" id="@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.exclude"></a>

```typescript
public readonly exclude: string;
```

- *Type:* string

Exclude certain projects from being processed.

---

##### `ignoreCycles`<sup>Optional</sup> <a name="ignoreCycles" id="@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.ignoreCycles"></a>

```typescript
public readonly ignoreCycles: boolean;
```

- *Type:* boolean

Ignore cycles in the task graph.

---

##### `noBail`<sup>Optional</sup> <a name="noBail" id="@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.noBail"></a>

```typescript
public readonly noBail: boolean;
```

- *Type:* boolean

Do not stop command execution after the first failed task.

---

##### `outputStyle`<sup>Optional</sup> <a name="outputStyle" id="@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.outputStyle"></a>

```typescript
public readonly outputStyle: string;
```

- *Type:* string
- *Default:* "stream"

Defines how Nx emits outputs tasks logs.

---

##### `parallel`<sup>Optional</sup> <a name="parallel" id="@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.parallel"></a>

```typescript
public readonly parallel: number;
```

- *Type:* number
- *Default:* 3

Max number of parallel processes.

---

##### `projects`<sup>Optional</sup> <a name="projects" id="@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.projects"></a>

```typescript
public readonly projects: string[];
```

- *Type:* string[]

Project to run as list project names and/or patterns.

---

##### `runner`<sup>Optional</sup> <a name="runner" id="@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.runner"></a>

```typescript
public readonly runner: string;
```

- *Type:* string

This is the name of the tasks runner configuration in nx.json.

---

##### `skipCache`<sup>Optional</sup> <a name="skipCache" id="@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.skipCache"></a>

```typescript
public readonly skipCache: boolean;
```

- *Type:* boolean

Rerun the tasks even when the results are available in the cache.

---

##### `verbose`<sup>Optional</sup> <a name="verbose" id="@aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions.property.verbose"></a>

```typescript
public readonly verbose: boolean;
```

- *Type:* boolean

Prints additional information about the commands (e.g. stack traces).

---

### SemverGroup <a name="SemverGroup" id="@aws-prototyping-sdk/nx-monorepo.SemverGroup"></a>

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/nx-monorepo.SemverGroup.Initializer"></a>

```typescript
import { SemverGroup } from '@aws-prototyping-sdk/nx-monorepo'

const semverGroup: SemverGroup = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SemverGroup.property.dependencies">dependencies</a></code> | <code>string[]</code> | the names of the dependencies (eg. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SemverGroup.property.packages">packages</a></code> | <code>string[]</code> | the names of packages in your monorepo which belong to this group, taken from the "name" field in package.json, not the package directory name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SemverGroup.property.range">range</a></code> | <code>string</code> | the semver range which dependencies in this group should use. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SemverGroup.property.dependencyTypes">dependencyTypes</a></code> | <code>string[]</code> | optionally only apply this group to dependencies of the provided types. |

---

##### `dependencies`<sup>Required</sup> <a name="dependencies" id="@aws-prototyping-sdk/nx-monorepo.SemverGroup.property.dependencies"></a>

```typescript
public readonly dependencies: string[];
```

- *Type:* string[]

the names of the dependencies (eg.

"lodash") which belong to this group

---

##### `packages`<sup>Required</sup> <a name="packages" id="@aws-prototyping-sdk/nx-monorepo.SemverGroup.property.packages"></a>

```typescript
public readonly packages: string[];
```

- *Type:* string[]

the names of packages in your monorepo which belong to this group, taken from the "name" field in package.json, not the package directory name.

---

##### `range`<sup>Required</sup> <a name="range" id="@aws-prototyping-sdk/nx-monorepo.SemverGroup.property.range"></a>

```typescript
public readonly range: string;
```

- *Type:* string

the semver range which dependencies in this group should use.

---

##### `dependencyTypes`<sup>Optional</sup> <a name="dependencyTypes" id="@aws-prototyping-sdk/nx-monorepo.SemverGroup.property.dependencyTypes"></a>

```typescript
public readonly dependencyTypes: string[];
```

- *Type:* string[]

optionally only apply this group to dependencies of the provided types.

---

### SyncpackConfig <a name="SyncpackConfig" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig"></a>

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.Initializer"></a>

```typescript
import { SyncpackConfig } from '@aws-prototyping-sdk/nx-monorepo'

const syncpackConfig: SyncpackConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.dependencyTypes">dependencyTypes</a></code> | <code>string[]</code> | which dependency properties to search within. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.dev">dev</a></code> | <code>boolean</code> | whether to search within devDependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.filter">filter</a></code> | <code>string</code> | a string which will be passed to `new RegExp()` to match against package names that should be included. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.indent">indent</a></code> | <code>string</code> | the character(s) to be used to indent your package.json files when writing to disk. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.overrides">overrides</a></code> | <code>boolean</code> | whether to search within npm overrides. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.peer">peer</a></code> | <code>boolean</code> | whether to search within peerDependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.pnpmOverrides">pnpmOverrides</a></code> | <code>boolean</code> | whether to search within pnpm overrides. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.prod">prod</a></code> | <code>boolean</code> | whether to search within dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.resolutions">resolutions</a></code> | <code>boolean</code> | whether to search within yarn resolutions. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.semverGroups">semverGroups</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.SemverGroup">SemverGroup</a>[]</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.semverRange">semverRange</a></code> | <code>string</code> | defaults to `""` to ensure that exact dependency versions are used instead of loose ranges. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.sortAz">sortAz</a></code> | <code>string[]</code> | which fields within package.json files should be sorted alphabetically. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.sortFirst">sortFirst</a></code> | <code>string[]</code> | which fields within package.json files should appear at the top, and in what order. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.source">source</a></code> | <code>string[]</code> | glob patterns for package.json file locations. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.versionGroups">versionGroups</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.VersionGroup">VersionGroup</a>[]</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.workspace">workspace</a></code> | <code>boolean</code> | whether to include the versions of the `--source` packages developed in your workspace/monorepo as part of the search for versions to sync. |

---

##### `dependencyTypes`<sup>Required</sup> <a name="dependencyTypes" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.dependencyTypes"></a>

```typescript
public readonly dependencyTypes: string[];
```

- *Type:* string[]

which dependency properties to search within.

---

##### `dev`<sup>Required</sup> <a name="dev" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.dev"></a>

```typescript
public readonly dev: boolean;
```

- *Type:* boolean

whether to search within devDependencies.

---

##### `filter`<sup>Required</sup> <a name="filter" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.filter"></a>

```typescript
public readonly filter: string;
```

- *Type:* string

a string which will be passed to `new RegExp()` to match against package names that should be included.

---

##### `indent`<sup>Required</sup> <a name="indent" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.indent"></a>

```typescript
public readonly indent: string;
```

- *Type:* string

the character(s) to be used to indent your package.json files when writing to disk.

---

##### `overrides`<sup>Required</sup> <a name="overrides" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.overrides"></a>

```typescript
public readonly overrides: boolean;
```

- *Type:* boolean

whether to search within npm overrides.

---

##### `peer`<sup>Required</sup> <a name="peer" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.peer"></a>

```typescript
public readonly peer: boolean;
```

- *Type:* boolean

whether to search within peerDependencies.

---

##### `pnpmOverrides`<sup>Required</sup> <a name="pnpmOverrides" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.pnpmOverrides"></a>

```typescript
public readonly pnpmOverrides: boolean;
```

- *Type:* boolean

whether to search within pnpm overrides.

---

##### `prod`<sup>Required</sup> <a name="prod" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.prod"></a>

```typescript
public readonly prod: boolean;
```

- *Type:* boolean

whether to search within dependencies.

---

##### `resolutions`<sup>Required</sup> <a name="resolutions" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.resolutions"></a>

```typescript
public readonly resolutions: boolean;
```

- *Type:* boolean

whether to search within yarn resolutions.

---

##### `semverGroups`<sup>Required</sup> <a name="semverGroups" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.semverGroups"></a>

```typescript
public readonly semverGroups: SemverGroup[];
```

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.SemverGroup">SemverGroup</a>[]

---

##### `semverRange`<sup>Required</sup> <a name="semverRange" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.semverRange"></a>

```typescript
public readonly semverRange: string;
```

- *Type:* string

defaults to `""` to ensure that exact dependency versions are used instead of loose ranges.

---

##### `sortAz`<sup>Required</sup> <a name="sortAz" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.sortAz"></a>

```typescript
public readonly sortAz: string[];
```

- *Type:* string[]

which fields within package.json files should be sorted alphabetically.

---

##### `sortFirst`<sup>Required</sup> <a name="sortFirst" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.sortFirst"></a>

```typescript
public readonly sortFirst: string[];
```

- *Type:* string[]

which fields within package.json files should appear at the top, and in what order.

---

##### `source`<sup>Required</sup> <a name="source" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.source"></a>

```typescript
public readonly source: string[];
```

- *Type:* string[]

glob patterns for package.json file locations.

---

##### `versionGroups`<sup>Required</sup> <a name="versionGroups" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.versionGroups"></a>

```typescript
public readonly versionGroups: VersionGroup[];
```

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.VersionGroup">VersionGroup</a>[]

---

##### `workspace`<sup>Required</sup> <a name="workspace" id="@aws-prototyping-sdk/nx-monorepo.SyncpackConfig.property.workspace"></a>

```typescript
public readonly workspace: boolean;
```

- *Type:* boolean

whether to include the versions of the `--source` packages developed in your workspace/monorepo as part of the search for versions to sync.

---

### VersionGroup <a name="VersionGroup" id="@aws-prototyping-sdk/nx-monorepo.VersionGroup"></a>

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/nx-monorepo.VersionGroup.Initializer"></a>

```typescript
import { VersionGroup } from '@aws-prototyping-sdk/nx-monorepo'

const versionGroup: VersionGroup = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.VersionGroup.property.dependencies">dependencies</a></code> | <code>string[]</code> | the names of the dependencies (eg. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.VersionGroup.property.packages">packages</a></code> | <code>string[]</code> | the names of packages in your monorepo which belong to this group, taken from the "name" field in package.json, not the package directory name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.VersionGroup.property.dependencyTypes">dependencyTypes</a></code> | <code>string[]</code> | optionally only apply this group to dependencies of the provided types. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.VersionGroup.property.isBanned">isBanned</a></code> | <code>boolean</code> | optionally force all dependencies in this group to be removed. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.VersionGroup.property.pinVersion">pinVersion</a></code> | <code>string</code> | optionally force all dependencies in this group to have this version. |

---

##### `dependencies`<sup>Required</sup> <a name="dependencies" id="@aws-prototyping-sdk/nx-monorepo.VersionGroup.property.dependencies"></a>

```typescript
public readonly dependencies: string[];
```

- *Type:* string[]

the names of the dependencies (eg.

"lodash") which belong to this group

---

##### `packages`<sup>Required</sup> <a name="packages" id="@aws-prototyping-sdk/nx-monorepo.VersionGroup.property.packages"></a>

```typescript
public readonly packages: string[];
```

- *Type:* string[]

the names of packages in your monorepo which belong to this group, taken from the "name" field in package.json, not the package directory name.

---

##### `dependencyTypes`<sup>Optional</sup> <a name="dependencyTypes" id="@aws-prototyping-sdk/nx-monorepo.VersionGroup.property.dependencyTypes"></a>

```typescript
public readonly dependencyTypes: string[];
```

- *Type:* string[]

optionally only apply this group to dependencies of the provided types.

---

##### `isBanned`<sup>Optional</sup> <a name="isBanned" id="@aws-prototyping-sdk/nx-monorepo.VersionGroup.property.isBanned"></a>

```typescript
public readonly isBanned: boolean;
```

- *Type:* boolean

optionally force all dependencies in this group to be removed.

---

##### `pinVersion`<sup>Optional</sup> <a name="pinVersion" id="@aws-prototyping-sdk/nx-monorepo.VersionGroup.property.pinVersion"></a>

```typescript
public readonly pinVersion: string;
```

- *Type:* string

optionally force all dependencies in this group to have this version.

---

### WorkspaceConfig <a name="WorkspaceConfig" id="@aws-prototyping-sdk/nx-monorepo.WorkspaceConfig"></a>

Workspace configurations.

> [https://classic.yarnpkg.com/lang/en/docs/workspaces/](https://classic.yarnpkg.com/lang/en/docs/workspaces/)

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/nx-monorepo.WorkspaceConfig.Initializer"></a>

```typescript
import { WorkspaceConfig } from '@aws-prototyping-sdk/nx-monorepo'

const workspaceConfig: WorkspaceConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.WorkspaceConfig.property.additionalPackages">additionalPackages</a></code> | <code>string[]</code> | List of additional package globs to include in the workspace. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.WorkspaceConfig.property.disableNoHoistBundled">disableNoHoistBundled</a></code> | <code>boolean</code> | Disable automatically applying `noHoist` logic for all sub-project "bundledDependencies". |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.WorkspaceConfig.property.linkLocalWorkspaceBins">linkLocalWorkspaceBins</a></code> | <code>boolean</code> | Links all local workspace project bins so they can be used for local development. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.WorkspaceConfig.property.noHoist">noHoist</a></code> | <code>string[]</code> | List of package globs to exclude from hoisting in the workspace. |

---

##### `additionalPackages`<sup>Optional</sup> <a name="additionalPackages" id="@aws-prototyping-sdk/nx-monorepo.WorkspaceConfig.property.additionalPackages"></a>

```typescript
public readonly additionalPackages: string[];
```

- *Type:* string[]

List of additional package globs to include in the workspace.

All packages which are parented by the monorepo are automatically added to the workspace, but you can use this
property to specify any additional paths to packages which may not be managed by projen.

---

##### `disableNoHoistBundled`<sup>Optional</sup> <a name="disableNoHoistBundled" id="@aws-prototyping-sdk/nx-monorepo.WorkspaceConfig.property.disableNoHoistBundled"></a>

```typescript
public readonly disableNoHoistBundled: boolean;
```

- *Type:* boolean
- *Default:* false

Disable automatically applying `noHoist` logic for all sub-project "bundledDependencies".

---

##### `linkLocalWorkspaceBins`<sup>Optional</sup> <a name="linkLocalWorkspaceBins" id="@aws-prototyping-sdk/nx-monorepo.WorkspaceConfig.property.linkLocalWorkspaceBins"></a>

```typescript
public readonly linkLocalWorkspaceBins: boolean;
```

- *Type:* boolean

Links all local workspace project bins so they can be used for local development.

Package bins are only linked when installed from the registry, however it is very useful
for monorepo development to also utilize these bin scripts. When enabled, this flag will
recursively link all bins from packages.json files to the root node_modules/.bin.

---

##### `noHoist`<sup>Optional</sup> <a name="noHoist" id="@aws-prototyping-sdk/nx-monorepo.WorkspaceConfig.property.noHoist"></a>

```typescript
public readonly noHoist: string[];
```

- *Type:* string[]

List of package globs to exclude from hoisting in the workspace.

> [https://classic.yarnpkg.com/blog/2018/02/15/nohoist/](https://classic.yarnpkg.com/blog/2018/02/15/nohoist/)

---

### WorkspaceConfig <a name="WorkspaceConfig" id="@aws-prototyping-sdk/nx-monorepo.Nx.WorkspaceConfig"></a>

NX workspace configurations.

> [https://nx.dev/configuration/packagejson](https://nx.dev/configuration/packagejson)

#### Initializer <a name="Initializer" id="@aws-prototyping-sdk/nx-monorepo.Nx.WorkspaceConfig.Initializer"></a>

```typescript
import { Nx } from '@aws-prototyping-sdk/nx-monorepo'

const workspaceConfig: Nx.WorkspaceConfig = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.WorkspaceConfig.property.cacheableOperations">cacheableOperations</a></code> | <code>string[]</code> | Defines the list of targets/operations that are cached by Nx. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.WorkspaceConfig.property.defaultBuildOutputs">defaultBuildOutputs</a></code> | <code>string[]</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.WorkspaceConfig.property.nonNativeHasher">nonNativeHasher</a></code> | <code>boolean</code> | Use non-native hasher for nx tasks. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.WorkspaceConfig.property.nxCloudReadOnlyAccessToken">nxCloudReadOnlyAccessToken</a></code> | <code>string</code> | Read only access token if enabling nx cloud. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.WorkspaceConfig.property.nxIgnore">nxIgnore</a></code> | <code>string[]</code> | List of patterns to include in the .nxignore file. |

---

##### `cacheableOperations`<sup>Optional</sup> <a name="cacheableOperations" id="@aws-prototyping-sdk/nx-monorepo.Nx.WorkspaceConfig.property.cacheableOperations"></a>

```typescript
public readonly cacheableOperations: string[];
```

- *Type:* string[]
- *Default:* ["build", "test"]

Defines the list of targets/operations that are cached by Nx.

> [https://nx.dev/reference/nx-json#tasks-runner-options](https://nx.dev/reference/nx-json#tasks-runner-options)

---

##### `defaultBuildOutputs`<sup>Optional</sup> <a name="defaultBuildOutputs" id="@aws-prototyping-sdk/nx-monorepo.Nx.WorkspaceConfig.property.defaultBuildOutputs"></a>

```typescript
public readonly defaultBuildOutputs: string[];
```

- *Type:* string[]

---

##### `nonNativeHasher`<sup>Optional</sup> <a name="nonNativeHasher" id="@aws-prototyping-sdk/nx-monorepo.Nx.WorkspaceConfig.property.nonNativeHasher"></a>

```typescript
public readonly nonNativeHasher: boolean;
```

- *Type:* boolean

Use non-native hasher for nx tasks.

Sets `NX_NON_NATIVE_HASHER=true` environment variable on nx based tasks.

> [https://github.com/nrwl/nx/pull/15071](https://github.com/nrwl/nx/pull/15071)

---

##### `nxCloudReadOnlyAccessToken`<sup>Optional</sup> <a name="nxCloudReadOnlyAccessToken" id="@aws-prototyping-sdk/nx-monorepo.Nx.WorkspaceConfig.property.nxCloudReadOnlyAccessToken"></a>

```typescript
public readonly nxCloudReadOnlyAccessToken: string;
```

- *Type:* string

Read only access token if enabling nx cloud.

---

##### `nxIgnore`<sup>Optional</sup> <a name="nxIgnore" id="@aws-prototyping-sdk/nx-monorepo.Nx.WorkspaceConfig.property.nxIgnore"></a>

```typescript
public readonly nxIgnore: string[];
```

- *Type:* string[]

List of patterns to include in the .nxignore file.

> [https://nx.dev/configuration/packagejson#nxignore](https://nx.dev/configuration/packagejson#nxignore)

---

## Classes <a name="Classes" id="Classes"></a>

### NxConfigurator <a name="NxConfigurator" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator"></a>

- *Implements:* <a href="#@aws-prototyping-sdk/nx-monorepo.INxProjectCore">INxProjectCore</a>

Configues common NX related tasks and methods.

#### Initializers <a name="Initializers" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.Initializer"></a>

```typescript
import { NxConfigurator } from '@aws-prototyping-sdk/nx-monorepo'

new NxConfigurator(project: Project, options?: NxConfiguratorOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.Initializer.parameter.project">project</a></code> | <code>projen.Project</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.Initializer.parameter.options">options</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfiguratorOptions">NxConfiguratorOptions</a></code> | *No description.* |

---

##### `project`<sup>Required</sup> <a name="project" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.Initializer.parameter.project"></a>

- *Type:* projen.Project

---

##### `options`<sup>Optional</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.Initializer.parameter.options"></a>

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.NxConfiguratorOptions">NxConfiguratorOptions</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.postSynthesize">postSynthesize</a></code> | Called after synthesis. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.preSynthesize">preSynthesize</a></code> | Called before synthesis. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.synthesize">synthesize</a></code> | Synthesizes files to the project output directory. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addImplicitDependency">addImplicitDependency</a></code> | Create an implicit dependency between two Projects. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addJavaDependency">addJavaDependency</a></code> | Adds a dependency between two Java Projects in the monorepo. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addNxRunManyTask">addNxRunManyTask</a></code> | Add project task that executes `npx nx run-many ...` style command. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addPythonPoetryDependency">addPythonPoetryDependency</a></code> | Adds a dependency between two Python Projects in the monorepo. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.composeNxRunManyCommand">composeNxRunManyCommand</a></code> | Helper to format `npx nx run-many ...` style command. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.ensureNxInstallTask">ensureNxInstallTask</a></code> | Returns the install task or creates one with nx installation command added. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.execNxRunManyCommand">execNxRunManyCommand</a></code> | Helper to format `npx nx run-many ...` style command execution in package manager. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.synth">synth</a></code> | *No description.* |

---

##### `postSynthesize` <a name="postSynthesize" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.postSynthesize"></a>

```typescript
public postSynthesize(): void
```

Called after synthesis.

Order is *not* guaranteed.

##### `preSynthesize` <a name="preSynthesize" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.preSynthesize"></a>

```typescript
public preSynthesize(): void
```

Called before synthesis.

##### `synthesize` <a name="synthesize" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.synthesize"></a>

```typescript
public synthesize(): void
```

Synthesizes files to the project output directory.

##### `addImplicitDependency` <a name="addImplicitDependency" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addImplicitDependency"></a>

```typescript
public addImplicitDependency(dependent: Project, dependee: string | Project): void
```

Create an implicit dependency between two Projects.

This is typically
used in polygot repos where a Typescript project wants a build dependency
on a Python project as an example.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addImplicitDependency.parameter.dependent"></a>

- *Type:* projen.Project

project you want to have the dependency.

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addImplicitDependency.parameter.dependee"></a>

- *Type:* string | projen.Project

project you wish to depend on.

---

##### `addJavaDependency` <a name="addJavaDependency" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addJavaDependency"></a>

```typescript
public addJavaDependency(dependent: JavaProject, dependee: JavaProject): void
```

Adds a dependency between two Java Projects in the monorepo.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addJavaDependency.parameter.dependent"></a>

- *Type:* projen.java.JavaProject

project you want to have the dependency.

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addJavaDependency.parameter.dependee"></a>

- *Type:* projen.java.JavaProject

project you wish to depend on.

---

##### `addNxRunManyTask` <a name="addNxRunManyTask" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addNxRunManyTask"></a>

```typescript
public addNxRunManyTask(name: string, options: RunManyOptions): Task
```

Add project task that executes `npx nx run-many ...` style command.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addNxRunManyTask.parameter.name"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addNxRunManyTask.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---

##### `addPythonPoetryDependency` <a name="addPythonPoetryDependency" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addPythonPoetryDependency"></a>

```typescript
public addPythonPoetryDependency(dependent: PythonProject, dependee: PythonProject): void
```

Adds a dependency between two Python Projects in the monorepo.

The dependent must have Poetry enabled.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addPythonPoetryDependency.parameter.dependent"></a>

- *Type:* projen.python.PythonProject

project you want to have the dependency (must be a Poetry Python Project).

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.addPythonPoetryDependency.parameter.dependee"></a>

- *Type:* projen.python.PythonProject

project you wish to depend on.

---

##### `composeNxRunManyCommand` <a name="composeNxRunManyCommand" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.composeNxRunManyCommand"></a>

```typescript
public composeNxRunManyCommand(options: RunManyOptions): string[]
```

Helper to format `npx nx run-many ...` style command.

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.composeNxRunManyCommand.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---

##### `ensureNxInstallTask` <a name="ensureNxInstallTask" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.ensureNxInstallTask"></a>

```typescript
public ensureNxInstallTask(nxPlugins: string): Task
```

Returns the install task or creates one with nx installation command added.

Note: this should only be called from non-node projects

###### `nxPlugins`<sup>Required</sup> <a name="nxPlugins" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.ensureNxInstallTask.parameter.nxPlugins"></a>

- *Type:* string

additional plugins to install.

---

##### `execNxRunManyCommand` <a name="execNxRunManyCommand" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.execNxRunManyCommand"></a>

```typescript
public execNxRunManyCommand(options: RunManyOptions): string
```

Helper to format `npx nx run-many ...` style command execution in package manager.

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.execNxRunManyCommand.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---

##### `synth` <a name="synth" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.synth"></a>

```typescript
public synth(): void
```


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.property.project">project</a></code> | <code>projen.Project</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator.property.nx">nx</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace">NxWorkspace</a></code> | Return the NxWorkspace instance. |

---

##### `project`<sup>Required</sup> <a name="project" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.property.project"></a>

```typescript
public readonly project: Project;
```

- *Type:* projen.Project

---

##### `nx`<sup>Required</sup> <a name="nx" id="@aws-prototyping-sdk/nx-monorepo.NxConfigurator.property.nx"></a>

```typescript
public readonly nx: NxWorkspace;
```

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace">NxWorkspace</a>

Return the NxWorkspace instance.

This should be implemented using a getter.

---


### NxMonorepoJavaProject <a name="NxMonorepoJavaProject" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject"></a>

- *Implements:* <a href="#@aws-prototyping-sdk/nx-monorepo.INxProjectCore">INxProjectCore</a>

This project type will bootstrap a NX based monorepo with support for polygot builds, build caching, dependency graph visualization and much more.

#### Initializers <a name="Initializers" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.Initializer"></a>

```typescript
import { NxMonorepoJavaProject } from '@aws-prototyping-sdk/nx-monorepo'

new NxMonorepoJavaProject(options: NxMonorepoJavaOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.Initializer.parameter.options">options</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions">NxMonorepoJavaOptions</a></code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.Initializer.parameter.options"></a>

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaOptions">NxMonorepoJavaOptions</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addExcludeFromCleanup">addExcludeFromCleanup</a></code> | Exclude the matching files from pre-synth cleanup. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addGitIgnore">addGitIgnore</a></code> | Adds a .gitignore pattern. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addPackageIgnore">addPackageIgnore</a></code> | Exclude these files from the bundled package. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addTask">addTask</a></code> | Adds a new task to this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addTip">addTip</a></code> | Prints a "tip" message during synthesis. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.annotateGenerated">annotateGenerated</a></code> | Marks the provided file(s) as being generated. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.postSynthesize">postSynthesize</a></code> | Called after all components are synthesized. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.preSynthesize">preSynthesize</a></code> | Called before all components are synthesized. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.removeTask">removeTask</a></code> | Removes a task from a project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.runTaskCommand">runTaskCommand</a></code> | Returns the shell command to execute in order to run a task. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.synth">synth</a></code> | Synthesize all project files into `outdir`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.tryFindFile">tryFindFile</a></code> | Finds a file at the specified relative path within this project and all its subprojects. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.tryFindJsonFile">tryFindJsonFile</a></code> | Finds a json file by name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.tryFindObjectFile">tryFindObjectFile</a></code> | Finds an object file (like JsonFile, YamlFile, etc.) by name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.tryRemoveFile">tryRemoveFile</a></code> | Finds a file at the specified relative path within this project and removes it. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addDependency">addDependency</a></code> | Adds a runtime dependency. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addPlugin">addPlugin</a></code> | Adds a build plugin to the pom. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addTestDependency">addTestDependency</a></code> | Adds a test dependency. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addImplicitDependency">addImplicitDependency</a></code> | Create an implicit dependency between two Projects. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addJavaDependency">addJavaDependency</a></code> | Adds a dependency between two Java Projects in the monorepo. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addNxRunManyTask">addNxRunManyTask</a></code> | Add project task that executes `npx nx run-many ...` style command. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addPythonPoetryDependency">addPythonPoetryDependency</a></code> | Adds a dependency between two Python Projects in the monorepo. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.composeNxRunManyCommand">composeNxRunManyCommand</a></code> | Helper to format `npx nx run-many ...` style command. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.execNxRunManyCommand">execNxRunManyCommand</a></code> | Helper to format `npx nx run-many ...` style command execution in package manager. |

---

##### `addExcludeFromCleanup` <a name="addExcludeFromCleanup" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addExcludeFromCleanup"></a>

```typescript
public addExcludeFromCleanup(globs: string): void
```

Exclude the matching files from pre-synth cleanup.

Can be used when, for example, some
source files include the projen marker and we don't want them to be erased during synth.

###### `globs`<sup>Required</sup> <a name="globs" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addExcludeFromCleanup.parameter.globs"></a>

- *Type:* string

The glob patterns to match.

---

##### `addGitIgnore` <a name="addGitIgnore" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addGitIgnore"></a>

```typescript
public addGitIgnore(pattern: string): void
```

Adds a .gitignore pattern.

###### `pattern`<sup>Required</sup> <a name="pattern" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addGitIgnore.parameter.pattern"></a>

- *Type:* string

The glob pattern to ignore.

---

##### `addPackageIgnore` <a name="addPackageIgnore" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addPackageIgnore"></a>

```typescript
public addPackageIgnore(_pattern: string): void
```

Exclude these files from the bundled package.

Implemented by project types based on the
packaging mechanism. For example, `NodeProject` delegates this to `.npmignore`.

###### `_pattern`<sup>Required</sup> <a name="_pattern" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addPackageIgnore.parameter._pattern"></a>

- *Type:* string

The glob pattern to exclude.

---

##### `addTask` <a name="addTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addTask"></a>

```typescript
public addTask(name: string, props?: TaskOptions): Task
```

Adds a new task to this project.

This will fail if the project already has
a task with this name.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addTask.parameter.name"></a>

- *Type:* string

The task name to add.

---

###### `props`<sup>Optional</sup> <a name="props" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addTask.parameter.props"></a>

- *Type:* projen.TaskOptions

Task properties.

---

##### ~~`addTip`~~ <a name="addTip" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addTip"></a>

```typescript
public addTip(message: string): void
```

Prints a "tip" message during synthesis.

###### `message`<sup>Required</sup> <a name="message" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addTip.parameter.message"></a>

- *Type:* string

The message.

---

##### `annotateGenerated` <a name="annotateGenerated" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.annotateGenerated"></a>

```typescript
public annotateGenerated(glob: string): void
```

Marks the provided file(s) as being generated.

This is achieved using the
github-linguist attributes. Generated files do not count against the
repository statistics and language breakdown.

> [https://github.com/github/linguist/blob/master/docs/overrides.md](https://github.com/github/linguist/blob/master/docs/overrides.md)

###### `glob`<sup>Required</sup> <a name="glob" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.annotateGenerated.parameter.glob"></a>

- *Type:* string

the glob pattern to match (could be a file path).

---

##### `postSynthesize` <a name="postSynthesize" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.postSynthesize"></a>

```typescript
public postSynthesize(): void
```

Called after all components are synthesized.

Order is *not* guaranteed.

##### `preSynthesize` <a name="preSynthesize" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.preSynthesize"></a>

```typescript
public preSynthesize(): void
```

Called before all components are synthesized.

##### `removeTask` <a name="removeTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.removeTask"></a>

```typescript
public removeTask(name: string): Task
```

Removes a task from a project.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.removeTask.parameter.name"></a>

- *Type:* string

The name of the task to remove.

---

##### `runTaskCommand` <a name="runTaskCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.runTaskCommand"></a>

```typescript
public runTaskCommand(task: Task): string
```

Returns the shell command to execute in order to run a task.

By default, this is `npx projen@<version> <task>`

###### `task`<sup>Required</sup> <a name="task" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.runTaskCommand.parameter.task"></a>

- *Type:* projen.Task

The task for which the command is required.

---

##### `synth` <a name="synth" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.synth"></a>

```typescript
public synth(): void
```

Synthesize all project files into `outdir`.

1. Call "this.preSynthesize()"
2. Delete all generated files
3. Synthesize all sub-projects
4. Synthesize all components of this project
5. Call "postSynthesize()" for all components of this project
6. Call "this.postSynthesize()"

##### `tryFindFile` <a name="tryFindFile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.tryFindFile"></a>

```typescript
public tryFindFile(filePath: string): FileBase
```

Finds a file at the specified relative path within this project and all its subprojects.

###### `filePath`<sup>Required</sup> <a name="filePath" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.tryFindFile.parameter.filePath"></a>

- *Type:* string

The file path.

If this path is relative, it will be resolved
from the root of _this_ project.

---

##### ~~`tryFindJsonFile`~~ <a name="tryFindJsonFile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.tryFindJsonFile"></a>

```typescript
public tryFindJsonFile(filePath: string): JsonFile
```

Finds a json file by name.

###### `filePath`<sup>Required</sup> <a name="filePath" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.tryFindJsonFile.parameter.filePath"></a>

- *Type:* string

The file path.

---

##### `tryFindObjectFile` <a name="tryFindObjectFile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.tryFindObjectFile"></a>

```typescript
public tryFindObjectFile(filePath: string): ObjectFile
```

Finds an object file (like JsonFile, YamlFile, etc.) by name.

###### `filePath`<sup>Required</sup> <a name="filePath" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.tryFindObjectFile.parameter.filePath"></a>

- *Type:* string

The file path.

---

##### `tryRemoveFile` <a name="tryRemoveFile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.tryRemoveFile"></a>

```typescript
public tryRemoveFile(filePath: string): FileBase
```

Finds a file at the specified relative path within this project and removes it.

###### `filePath`<sup>Required</sup> <a name="filePath" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.tryRemoveFile.parameter.filePath"></a>

- *Type:* string

The file path.

If this path is relative, it will be
resolved from the root of _this_ project.

---

##### `addDependency` <a name="addDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addDependency"></a>

```typescript
public addDependency(spec: string): void
```

Adds a runtime dependency.

###### `spec`<sup>Required</sup> <a name="spec" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addDependency.parameter.spec"></a>

- *Type:* string

Format `<groupId>/<artifactId>@<semver>`.

---

##### `addPlugin` <a name="addPlugin" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addPlugin"></a>

```typescript
public addPlugin(spec: string, options?: PluginOptions): Dependency
```

Adds a build plugin to the pom.

The plug in is also added as a BUILD dep to the project.

###### `spec`<sup>Required</sup> <a name="spec" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addPlugin.parameter.spec"></a>

- *Type:* string

dependency spec (`group/artifact@version`).

---

###### `options`<sup>Optional</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addPlugin.parameter.options"></a>

- *Type:* projen.java.PluginOptions

plugin options.

---

##### `addTestDependency` <a name="addTestDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addTestDependency"></a>

```typescript
public addTestDependency(spec: string): void
```

Adds a test dependency.

###### `spec`<sup>Required</sup> <a name="spec" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addTestDependency.parameter.spec"></a>

- *Type:* string

Format `<groupId>/<artifactId>@<semver>`.

---

##### `addImplicitDependency` <a name="addImplicitDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addImplicitDependency"></a>

```typescript
public addImplicitDependency(dependent: Project, dependee: string | Project): void
```

Create an implicit dependency between two Projects.

This is typically
used in polygot repos where a Typescript project wants a build dependency
on a Python project as an example.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addImplicitDependency.parameter.dependent"></a>

- *Type:* projen.Project

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addImplicitDependency.parameter.dependee"></a>

- *Type:* string | projen.Project

---

##### `addJavaDependency` <a name="addJavaDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addJavaDependency"></a>

```typescript
public addJavaDependency(dependent: JavaProject, dependee: JavaProject): void
```

Adds a dependency between two Java Projects in the monorepo.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addJavaDependency.parameter.dependent"></a>

- *Type:* projen.java.JavaProject

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addJavaDependency.parameter.dependee"></a>

- *Type:* projen.java.JavaProject

---

##### `addNxRunManyTask` <a name="addNxRunManyTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addNxRunManyTask"></a>

```typescript
public addNxRunManyTask(name: string, options: RunManyOptions): Task
```

Add project task that executes `npx nx run-many ...` style command.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addNxRunManyTask.parameter.name"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addNxRunManyTask.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---

##### `addPythonPoetryDependency` <a name="addPythonPoetryDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addPythonPoetryDependency"></a>

```typescript
public addPythonPoetryDependency(dependent: PythonProject, dependee: PythonProject): void
```

Adds a dependency between two Python Projects in the monorepo.

The dependent must have Poetry enabled.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addPythonPoetryDependency.parameter.dependent"></a>

- *Type:* projen.python.PythonProject

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.addPythonPoetryDependency.parameter.dependee"></a>

- *Type:* projen.python.PythonProject

---

##### `composeNxRunManyCommand` <a name="composeNxRunManyCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.composeNxRunManyCommand"></a>

```typescript
public composeNxRunManyCommand(options: RunManyOptions): string[]
```

Helper to format `npx nx run-many ...` style command.

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.composeNxRunManyCommand.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---

##### `execNxRunManyCommand` <a name="execNxRunManyCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.execNxRunManyCommand"></a>

```typescript
public execNxRunManyCommand(options: RunManyOptions): string
```

Helper to format `npx nx run-many ...` style command execution in package manager.

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.execNxRunManyCommand.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.buildTask">buildTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.commitGenerated">commitGenerated</a></code> | <code>boolean</code> | Whether to commit the managed files by default. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.compileTask">compileTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.components">components</a></code> | <code>projen.Component[]</code> | Returns all the components within this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.deps">deps</a></code> | <code>projen.Dependencies</code> | Project dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.ejected">ejected</a></code> | <code>boolean</code> | Whether or not the project is being ejected. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.files">files</a></code> | <code>projen.FileBase[]</code> | All files in this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.gitattributes">gitattributes</a></code> | <code>projen.GitAttributesFile</code> | The .gitattributes file for this repository. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.gitignore">gitignore</a></code> | <code>projen.IgnoreFile</code> | .gitignore. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.logger">logger</a></code> | <code>projen.Logger</code> | Logging utilities. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.name">name</a></code> | <code>string</code> | Project name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.outdir">outdir</a></code> | <code>string</code> | Absolute output directory of this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.packageTask">packageTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.postCompileTask">postCompileTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.preCompileTask">preCompileTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.projectBuild">projectBuild</a></code> | <code>projen.ProjectBuild</code> | Manages the build process of the project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.projenCommand">projenCommand</a></code> | <code>string</code> | The command to use in order to run the projen CLI. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.root">root</a></code> | <code>projen.Project</code> | The root project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.subprojects">subprojects</a></code> | <code>projen.Project[]</code> | Returns all the subprojects within this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.tasks">tasks</a></code> | <code>projen.Tasks</code> | Project tasks. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.testTask">testTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.defaultTask">defaultTask</a></code> | <code>projen.Task</code> | This is the "default" task, the one that executes "projen". |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.initProject">initProject</a></code> | <code>projen.InitProject</code> | The options used when this project is bootstrapped via `projen new`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.parent">parent</a></code> | <code>projen.Project</code> | A parent project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.projectType">projectType</a></code> | <code>projen.ProjectType</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.autoApprove">autoApprove</a></code> | <code>projen.github.AutoApprove</code> | Auto approve set up for this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.devContainer">devContainer</a></code> | <code>projen.vscode.DevContainer</code> | Access for .devcontainer.json (used for GitHub Codespaces). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.github">github</a></code> | <code>projen.github.GitHub</code> | Access all github components. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.gitpod">gitpod</a></code> | <code>projen.Gitpod</code> | Access for Gitpod. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.vscode">vscode</a></code> | <code>projen.vscode.VsCode</code> | Access all VSCode components. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.compile">compile</a></code> | <code>projen.java.MavenCompile</code> | Compile component. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.distdir">distdir</a></code> | <code>string</code> | Maven artifact output directory. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.packaging">packaging</a></code> | <code>projen.java.MavenPackaging</code> | Packaging component. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.pom">pom</a></code> | <code>projen.java.Pom</code> | API for managing `pom.xml`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.junit">junit</a></code> | <code>projen.java.Junit</code> | JUnit component. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.projenrc">projenrc</a></code> | <code>projen.java.Projenrc</code> | Projenrc component. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.nx">nx</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace">NxWorkspace</a></code> | Return the NxWorkspace instance. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.nxConfigurator">nxConfigurator</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator">NxConfigurator</a></code> | *No description.* |

---

##### `buildTask`<sup>Required</sup> <a name="buildTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.buildTask"></a>

```typescript
public readonly buildTask: Task;
```

- *Type:* projen.Task

---

##### `commitGenerated`<sup>Required</sup> <a name="commitGenerated" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.commitGenerated"></a>

```typescript
public readonly commitGenerated: boolean;
```

- *Type:* boolean

Whether to commit the managed files by default.

---

##### `compileTask`<sup>Required</sup> <a name="compileTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.compileTask"></a>

```typescript
public readonly compileTask: Task;
```

- *Type:* projen.Task

---

##### `components`<sup>Required</sup> <a name="components" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.components"></a>

```typescript
public readonly components: Component[];
```

- *Type:* projen.Component[]

Returns all the components within this project.

---

##### `deps`<sup>Required</sup> <a name="deps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.deps"></a>

```typescript
public readonly deps: Dependencies;
```

- *Type:* projen.Dependencies

Project dependencies.

---

##### `ejected`<sup>Required</sup> <a name="ejected" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.ejected"></a>

```typescript
public readonly ejected: boolean;
```

- *Type:* boolean

Whether or not the project is being ejected.

---

##### `files`<sup>Required</sup> <a name="files" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.files"></a>

```typescript
public readonly files: FileBase[];
```

- *Type:* projen.FileBase[]

All files in this project.

---

##### `gitattributes`<sup>Required</sup> <a name="gitattributes" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.gitattributes"></a>

```typescript
public readonly gitattributes: GitAttributesFile;
```

- *Type:* projen.GitAttributesFile

The .gitattributes file for this repository.

---

##### `gitignore`<sup>Required</sup> <a name="gitignore" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.gitignore"></a>

```typescript
public readonly gitignore: IgnoreFile;
```

- *Type:* projen.IgnoreFile

.gitignore.

---

##### `logger`<sup>Required</sup> <a name="logger" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.logger"></a>

```typescript
public readonly logger: Logger;
```

- *Type:* projen.Logger

Logging utilities.

---

##### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Project name.

---

##### `outdir`<sup>Required</sup> <a name="outdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.outdir"></a>

```typescript
public readonly outdir: string;
```

- *Type:* string

Absolute output directory of this project.

---

##### `packageTask`<sup>Required</sup> <a name="packageTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.packageTask"></a>

```typescript
public readonly packageTask: Task;
```

- *Type:* projen.Task

---

##### `postCompileTask`<sup>Required</sup> <a name="postCompileTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.postCompileTask"></a>

```typescript
public readonly postCompileTask: Task;
```

- *Type:* projen.Task

---

##### `preCompileTask`<sup>Required</sup> <a name="preCompileTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.preCompileTask"></a>

```typescript
public readonly preCompileTask: Task;
```

- *Type:* projen.Task

---

##### `projectBuild`<sup>Required</sup> <a name="projectBuild" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.projectBuild"></a>

```typescript
public readonly projectBuild: ProjectBuild;
```

- *Type:* projen.ProjectBuild

Manages the build process of the project.

---

##### `projenCommand`<sup>Required</sup> <a name="projenCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.projenCommand"></a>

```typescript
public readonly projenCommand: string;
```

- *Type:* string

The command to use in order to run the projen CLI.

---

##### `root`<sup>Required</sup> <a name="root" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.root"></a>

```typescript
public readonly root: Project;
```

- *Type:* projen.Project

The root project.

---

##### `subprojects`<sup>Required</sup> <a name="subprojects" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.subprojects"></a>

```typescript
public readonly subprojects: Project[];
```

- *Type:* projen.Project[]

Returns all the subprojects within this project.

---

##### `tasks`<sup>Required</sup> <a name="tasks" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.tasks"></a>

```typescript
public readonly tasks: Tasks;
```

- *Type:* projen.Tasks

Project tasks.

---

##### `testTask`<sup>Required</sup> <a name="testTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.testTask"></a>

```typescript
public readonly testTask: Task;
```

- *Type:* projen.Task

---

##### `defaultTask`<sup>Optional</sup> <a name="defaultTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.defaultTask"></a>

```typescript
public readonly defaultTask: Task;
```

- *Type:* projen.Task

This is the "default" task, the one that executes "projen".

Undefined if
the project is being ejected.

---

##### `initProject`<sup>Optional</sup> <a name="initProject" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.initProject"></a>

```typescript
public readonly initProject: InitProject;
```

- *Type:* projen.InitProject

The options used when this project is bootstrapped via `projen new`.

It
includes the original set of options passed to the CLI and also the JSII
FQN of the project type.

---

##### `parent`<sup>Optional</sup> <a name="parent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.parent"></a>

```typescript
public readonly parent: Project;
```

- *Type:* projen.Project

A parent project.

If undefined, this is the root project.

---

##### `projectType`<sup>Required</sup> <a name="projectType" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.projectType"></a>

```typescript
public readonly projectType: ProjectType;
```

- *Type:* projen.ProjectType

---

##### `autoApprove`<sup>Optional</sup> <a name="autoApprove" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.autoApprove"></a>

```typescript
public readonly autoApprove: AutoApprove;
```

- *Type:* projen.github.AutoApprove

Auto approve set up for this project.

---

##### `devContainer`<sup>Optional</sup> <a name="devContainer" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.devContainer"></a>

```typescript
public readonly devContainer: DevContainer;
```

- *Type:* projen.vscode.DevContainer

Access for .devcontainer.json (used for GitHub Codespaces).

This will be `undefined` if devContainer boolean is false

---

##### `github`<sup>Optional</sup> <a name="github" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.github"></a>

```typescript
public readonly github: GitHub;
```

- *Type:* projen.github.GitHub

Access all github components.

This will be `undefined` for subprojects.

---

##### `gitpod`<sup>Optional</sup> <a name="gitpod" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.gitpod"></a>

```typescript
public readonly gitpod: Gitpod;
```

- *Type:* projen.Gitpod

Access for Gitpod.

This will be `undefined` if gitpod boolean is false

---

##### `vscode`<sup>Optional</sup> <a name="vscode" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.vscode"></a>

```typescript
public readonly vscode: VsCode;
```

- *Type:* projen.vscode.VsCode

Access all VSCode components.

This will be `undefined` for subprojects.

---

##### `compile`<sup>Required</sup> <a name="compile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.compile"></a>

```typescript
public readonly compile: MavenCompile;
```

- *Type:* projen.java.MavenCompile

Compile component.

---

##### `distdir`<sup>Required</sup> <a name="distdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.distdir"></a>

```typescript
public readonly distdir: string;
```

- *Type:* string

Maven artifact output directory.

---

##### `packaging`<sup>Required</sup> <a name="packaging" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.packaging"></a>

```typescript
public readonly packaging: MavenPackaging;
```

- *Type:* projen.java.MavenPackaging

Packaging component.

---

##### `pom`<sup>Required</sup> <a name="pom" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.pom"></a>

```typescript
public readonly pom: Pom;
```

- *Type:* projen.java.Pom

API for managing `pom.xml`.

---

##### `junit`<sup>Optional</sup> <a name="junit" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.junit"></a>

```typescript
public readonly junit: Junit;
```

- *Type:* projen.java.Junit

JUnit component.

---

##### `projenrc`<sup>Optional</sup> <a name="projenrc" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.projenrc"></a>

```typescript
public readonly projenrc: Projenrc;
```

- *Type:* projen.java.Projenrc

Projenrc component.

---

##### `nx`<sup>Required</sup> <a name="nx" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.nx"></a>

```typescript
public readonly nx: NxWorkspace;
```

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace">NxWorkspace</a>

Return the NxWorkspace instance.

This should be implemented using a getter.

---

##### `nxConfigurator`<sup>Required</sup> <a name="nxConfigurator" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.nxConfigurator"></a>

```typescript
public readonly nxConfigurator: NxConfigurator;
```

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator">NxConfigurator</a>

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.DEFAULT_TASK">DEFAULT_TASK</a></code> | <code>string</code> | The name of the default task (the task executed when `projen` is run without arguments). |

---

##### `DEFAULT_TASK`<sup>Required</sup> <a name="DEFAULT_TASK" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject.property.DEFAULT_TASK"></a>

```typescript
public readonly DEFAULT_TASK: string;
```

- *Type:* string

The name of the default task (the task executed when `projen` is run without arguments).

Normally
this task should synthesize the project files.

---

### NxMonorepoProject <a name="NxMonorepoProject" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject"></a>

- *Implements:* <a href="#@aws-prototyping-sdk/nx-monorepo.INxProjectCore">INxProjectCore</a>

This project type will bootstrap a NX based monorepo with support for polygot builds, build caching, dependency graph visualization and much more.

#### Initializers <a name="Initializers" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.Initializer"></a>

```typescript
import { NxMonorepoProject } from '@aws-prototyping-sdk/nx-monorepo'

new NxMonorepoProject(options: NxMonorepoProjectOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.Initializer.parameter.options">options</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions">NxMonorepoProjectOptions</a></code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.Initializer.parameter.options"></a>

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProjectOptions">NxMonorepoProjectOptions</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addExcludeFromCleanup">addExcludeFromCleanup</a></code> | Exclude the matching files from pre-synth cleanup. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addGitIgnore">addGitIgnore</a></code> | Adds a .gitignore pattern. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addPackageIgnore">addPackageIgnore</a></code> | Exclude these files from the bundled package. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addTask">addTask</a></code> | Adds a new task to this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addTip">addTip</a></code> | Prints a "tip" message during synthesis. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.annotateGenerated">annotateGenerated</a></code> | Marks the provided file(s) as being generated. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.postSynthesize">postSynthesize</a></code> | Called after all components are synthesized. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.preSynthesize">preSynthesize</a></code> | Called before all components are synthesized. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.removeTask">removeTask</a></code> | Removes a task from a project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.runTaskCommand">runTaskCommand</a></code> | Returns the shell command to execute in order to run a task. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.synth">synth</a></code> | Synthesize all project files into `outdir`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.tryFindFile">tryFindFile</a></code> | Finds a file at the specified relative path within this project and all its subprojects. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.tryFindJsonFile">tryFindJsonFile</a></code> | Finds a json file by name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.tryFindObjectFile">tryFindObjectFile</a></code> | Finds an object file (like JsonFile, YamlFile, etc.) by name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.tryRemoveFile">tryRemoveFile</a></code> | Finds a file at the specified relative path within this project and removes it. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addBins">addBins</a></code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addBundledDeps">addBundledDeps</a></code> | Defines bundled dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addCompileCommand">addCompileCommand</a></code> | DEPRECATED. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addDeps">addDeps</a></code> | Defines normal dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addDevDeps">addDevDeps</a></code> | Defines development/test dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addFields">addFields</a></code> | Directly set fields in `package.json`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addKeywords">addKeywords</a></code> | Adds keywords to package.json (deduplicated). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addPeerDeps">addPeerDeps</a></code> | Defines peer dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addScripts">addScripts</a></code> | Replaces the contents of multiple npm package.json scripts. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addTestCommand">addTestCommand</a></code> | DEPRECATED. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.hasScript">hasScript</a></code> | Indicates if a script by the name name is defined. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.removeScript">removeScript</a></code> | Removes the npm script (always successful). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.renderWorkflowSetup">renderWorkflowSetup</a></code> | Returns the set of workflow steps which should be executed to bootstrap a workflow. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.setScript">setScript</a></code> | Replaces the contents of an npm package.json script. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addImplicitDependency">addImplicitDependency</a></code> | Create an implicit dependency between two Projects. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addJavaDependency">addJavaDependency</a></code> | Adds a dependency between two Java Projects in the monorepo. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addNxRunManyTask">addNxRunManyTask</a></code> | Add project task that executes `npx nx run-many ...` style command. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addPythonPoetryDependency">addPythonPoetryDependency</a></code> | Adds a dependency between two Python Projects in the monorepo. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addWorkspacePackages">addWorkspacePackages</a></code> | Add one or more additional package globs to the workspace. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.composeNxRunManyCommand">composeNxRunManyCommand</a></code> | Helper to format `npx nx run-many ...` style command. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.execNxRunManyCommand">execNxRunManyCommand</a></code> | Helper to format `npx nx run-many ...` style command execution in package manager. |

---

##### `addExcludeFromCleanup` <a name="addExcludeFromCleanup" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addExcludeFromCleanup"></a>

```typescript
public addExcludeFromCleanup(globs: string): void
```

Exclude the matching files from pre-synth cleanup.

Can be used when, for example, some
source files include the projen marker and we don't want them to be erased during synth.

###### `globs`<sup>Required</sup> <a name="globs" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addExcludeFromCleanup.parameter.globs"></a>

- *Type:* string

The glob patterns to match.

---

##### `addGitIgnore` <a name="addGitIgnore" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addGitIgnore"></a>

```typescript
public addGitIgnore(pattern: string): void
```

Adds a .gitignore pattern.

###### `pattern`<sup>Required</sup> <a name="pattern" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addGitIgnore.parameter.pattern"></a>

- *Type:* string

The glob pattern to ignore.

---

##### `addPackageIgnore` <a name="addPackageIgnore" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addPackageIgnore"></a>

```typescript
public addPackageIgnore(pattern: string): void
```

Exclude these files from the bundled package.

Implemented by project types based on the
packaging mechanism. For example, `NodeProject` delegates this to `.npmignore`.

###### `pattern`<sup>Required</sup> <a name="pattern" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addPackageIgnore.parameter.pattern"></a>

- *Type:* string

---

##### `addTask` <a name="addTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addTask"></a>

```typescript
public addTask(name: string, props?: TaskOptions): Task
```

Adds a new task to this project.

This will fail if the project already has
a task with this name.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addTask.parameter.name"></a>

- *Type:* string

The task name to add.

---

###### `props`<sup>Optional</sup> <a name="props" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addTask.parameter.props"></a>

- *Type:* projen.TaskOptions

Task properties.

---

##### ~~`addTip`~~ <a name="addTip" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addTip"></a>

```typescript
public addTip(message: string): void
```

Prints a "tip" message during synthesis.

###### `message`<sup>Required</sup> <a name="message" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addTip.parameter.message"></a>

- *Type:* string

The message.

---

##### `annotateGenerated` <a name="annotateGenerated" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.annotateGenerated"></a>

```typescript
public annotateGenerated(glob: string): void
```

Marks the provided file(s) as being generated.

This is achieved using the
github-linguist attributes. Generated files do not count against the
repository statistics and language breakdown.

> [https://github.com/github/linguist/blob/master/docs/overrides.md](https://github.com/github/linguist/blob/master/docs/overrides.md)

###### `glob`<sup>Required</sup> <a name="glob" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.annotateGenerated.parameter.glob"></a>

- *Type:* string

the glob pattern to match (could be a file path).

---

##### `postSynthesize` <a name="postSynthesize" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.postSynthesize"></a>

```typescript
public postSynthesize(): void
```

Called after all components are synthesized.

Order is *not* guaranteed.

##### `preSynthesize` <a name="preSynthesize" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.preSynthesize"></a>

```typescript
public preSynthesize(): void
```

Called before all components are synthesized.

##### `removeTask` <a name="removeTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.removeTask"></a>

```typescript
public removeTask(name: string): Task
```

Removes a task from a project.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.removeTask.parameter.name"></a>

- *Type:* string

The name of the task to remove.

---

##### `runTaskCommand` <a name="runTaskCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.runTaskCommand"></a>

```typescript
public runTaskCommand(task: Task): string
```

Returns the shell command to execute in order to run a task.

This will
typically be `npx projen TASK`.

###### `task`<sup>Required</sup> <a name="task" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.runTaskCommand.parameter.task"></a>

- *Type:* projen.Task

The task for which the command is required.

---

##### `synth` <a name="synth" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.synth"></a>

```typescript
public synth(): void
```

Synthesize all project files into `outdir`.

1. Call "this.preSynthesize()"
2. Delete all generated files
3. Synthesize all sub-projects
4. Synthesize all components of this project
5. Call "postSynthesize()" for all components of this project
6. Call "this.postSynthesize()"

##### `tryFindFile` <a name="tryFindFile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.tryFindFile"></a>

```typescript
public tryFindFile(filePath: string): FileBase
```

Finds a file at the specified relative path within this project and all its subprojects.

###### `filePath`<sup>Required</sup> <a name="filePath" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.tryFindFile.parameter.filePath"></a>

- *Type:* string

The file path.

If this path is relative, it will be resolved
from the root of _this_ project.

---

##### ~~`tryFindJsonFile`~~ <a name="tryFindJsonFile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.tryFindJsonFile"></a>

```typescript
public tryFindJsonFile(filePath: string): JsonFile
```

Finds a json file by name.

###### `filePath`<sup>Required</sup> <a name="filePath" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.tryFindJsonFile.parameter.filePath"></a>

- *Type:* string

The file path.

---

##### `tryFindObjectFile` <a name="tryFindObjectFile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.tryFindObjectFile"></a>

```typescript
public tryFindObjectFile(filePath: string): ObjectFile
```

Finds an object file (like JsonFile, YamlFile, etc.) by name.

###### `filePath`<sup>Required</sup> <a name="filePath" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.tryFindObjectFile.parameter.filePath"></a>

- *Type:* string

The file path.

---

##### `tryRemoveFile` <a name="tryRemoveFile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.tryRemoveFile"></a>

```typescript
public tryRemoveFile(filePath: string): FileBase
```

Finds a file at the specified relative path within this project and removes it.

###### `filePath`<sup>Required</sup> <a name="filePath" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.tryRemoveFile.parameter.filePath"></a>

- *Type:* string

The file path.

If this path is relative, it will be
resolved from the root of _this_ project.

---

##### `addBins` <a name="addBins" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addBins"></a>

```typescript
public addBins(bins: {[ key: string ]: string}): void
```

###### `bins`<sup>Required</sup> <a name="bins" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addBins.parameter.bins"></a>

- *Type:* {[ key: string ]: string}

---

##### `addBundledDeps` <a name="addBundledDeps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addBundledDeps"></a>

```typescript
public addBundledDeps(deps: string): void
```

Defines bundled dependencies.

Bundled dependencies will be added as normal dependencies as well as to the
`bundledDependencies` section of your `package.json`.

###### `deps`<sup>Required</sup> <a name="deps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addBundledDeps.parameter.deps"></a>

- *Type:* string

Names modules to install.

By default, the the dependency will
be installed in the next `npx projen` run and the version will be recorded
in your `package.json` file. You can upgrade manually or using `yarn
add/upgrade`. If you wish to specify a version range use this syntax:
`module@^7`.

---

##### ~~`addCompileCommand`~~ <a name="addCompileCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addCompileCommand"></a>

```typescript
public addCompileCommand(commands: string): void
```

DEPRECATED.

###### `commands`<sup>Required</sup> <a name="commands" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addCompileCommand.parameter.commands"></a>

- *Type:* string

---

##### `addDeps` <a name="addDeps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addDeps"></a>

```typescript
public addDeps(deps: string): void
```

Defines normal dependencies.

###### `deps`<sup>Required</sup> <a name="deps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addDeps.parameter.deps"></a>

- *Type:* string

Names modules to install.

By default, the the dependency will
be installed in the next `npx projen` run and the version will be recorded
in your `package.json` file. You can upgrade manually or using `yarn
add/upgrade`. If you wish to specify a version range use this syntax:
`module@^7`.

---

##### `addDevDeps` <a name="addDevDeps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addDevDeps"></a>

```typescript
public addDevDeps(deps: string): void
```

Defines development/test dependencies.

###### `deps`<sup>Required</sup> <a name="deps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addDevDeps.parameter.deps"></a>

- *Type:* string

Names modules to install.

By default, the the dependency will
be installed in the next `npx projen` run and the version will be recorded
in your `package.json` file. You can upgrade manually or using `yarn
add/upgrade`. If you wish to specify a version range use this syntax:
`module@^7`.

---

##### `addFields` <a name="addFields" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addFields"></a>

```typescript
public addFields(fields: {[ key: string ]: any}): void
```

Directly set fields in `package.json`.

###### `fields`<sup>Required</sup> <a name="fields" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addFields.parameter.fields"></a>

- *Type:* {[ key: string ]: any}

The fields to set.

---

##### `addKeywords` <a name="addKeywords" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addKeywords"></a>

```typescript
public addKeywords(keywords: string): void
```

Adds keywords to package.json (deduplicated).

###### `keywords`<sup>Required</sup> <a name="keywords" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addKeywords.parameter.keywords"></a>

- *Type:* string

The keywords to add.

---

##### `addPeerDeps` <a name="addPeerDeps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addPeerDeps"></a>

```typescript
public addPeerDeps(deps: string): void
```

Defines peer dependencies.

When adding peer dependencies, a devDependency will also be added on the
pinned version of the declared peer. This will ensure that you are testing
your code against the minimum version required from your consumers.

###### `deps`<sup>Required</sup> <a name="deps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addPeerDeps.parameter.deps"></a>

- *Type:* string

Names modules to install.

By default, the the dependency will
be installed in the next `npx projen` run and the version will be recorded
in your `package.json` file. You can upgrade manually or using `yarn
add/upgrade`. If you wish to specify a version range use this syntax:
`module@^7`.

---

##### `addScripts` <a name="addScripts" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addScripts"></a>

```typescript
public addScripts(scripts: {[ key: string ]: string}): void
```

Replaces the contents of multiple npm package.json scripts.

###### `scripts`<sup>Required</sup> <a name="scripts" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addScripts.parameter.scripts"></a>

- *Type:* {[ key: string ]: string}

The scripts to set.

---

##### ~~`addTestCommand`~~ <a name="addTestCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addTestCommand"></a>

```typescript
public addTestCommand(commands: string): void
```

DEPRECATED.

###### `commands`<sup>Required</sup> <a name="commands" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addTestCommand.parameter.commands"></a>

- *Type:* string

---

##### ~~`hasScript`~~ <a name="hasScript" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.hasScript"></a>

```typescript
public hasScript(name: string): boolean
```

Indicates if a script by the name name is defined.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.hasScript.parameter.name"></a>

- *Type:* string

The name of the script.

---

##### `removeScript` <a name="removeScript" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.removeScript"></a>

```typescript
public removeScript(name: string): void
```

Removes the npm script (always successful).

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.removeScript.parameter.name"></a>

- *Type:* string

The name of the script.

---

##### `renderWorkflowSetup` <a name="renderWorkflowSetup" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.renderWorkflowSetup"></a>

```typescript
public renderWorkflowSetup(options?: RenderWorkflowSetupOptions): JobStep[]
```

Returns the set of workflow steps which should be executed to bootstrap a workflow.

###### `options`<sup>Optional</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.renderWorkflowSetup.parameter.options"></a>

- *Type:* projen.javascript.RenderWorkflowSetupOptions

Options.

---

##### `setScript` <a name="setScript" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.setScript"></a>

```typescript
public setScript(name: string, command: string): void
```

Replaces the contents of an npm package.json script.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.setScript.parameter.name"></a>

- *Type:* string

The script name.

---

###### `command`<sup>Required</sup> <a name="command" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.setScript.parameter.command"></a>

- *Type:* string

The command to execute.

---

##### `addImplicitDependency` <a name="addImplicitDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addImplicitDependency"></a>

```typescript
public addImplicitDependency(dependent: Project, dependee: string | Project): void
```

Create an implicit dependency between two Projects.

This is typically
used in polygot repos where a Typescript project wants a build dependency
on a Python project as an example.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addImplicitDependency.parameter.dependent"></a>

- *Type:* projen.Project

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addImplicitDependency.parameter.dependee"></a>

- *Type:* string | projen.Project

---

##### `addJavaDependency` <a name="addJavaDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addJavaDependency"></a>

```typescript
public addJavaDependency(dependent: JavaProject, dependee: JavaProject): void
```

Adds a dependency between two Java Projects in the monorepo.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addJavaDependency.parameter.dependent"></a>

- *Type:* projen.java.JavaProject

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addJavaDependency.parameter.dependee"></a>

- *Type:* projen.java.JavaProject

---

##### `addNxRunManyTask` <a name="addNxRunManyTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addNxRunManyTask"></a>

```typescript
public addNxRunManyTask(name: string, options: RunManyOptions): Task
```

Add project task that executes `npx nx run-many ...` style command.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addNxRunManyTask.parameter.name"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addNxRunManyTask.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---

##### `addPythonPoetryDependency` <a name="addPythonPoetryDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addPythonPoetryDependency"></a>

```typescript
public addPythonPoetryDependency(dependent: PythonProject, dependee: PythonProject): void
```

Adds a dependency between two Python Projects in the monorepo.

The dependent must have Poetry enabled.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addPythonPoetryDependency.parameter.dependent"></a>

- *Type:* projen.python.PythonProject

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addPythonPoetryDependency.parameter.dependee"></a>

- *Type:* projen.python.PythonProject

---

##### `addWorkspacePackages` <a name="addWorkspacePackages" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addWorkspacePackages"></a>

```typescript
public addWorkspacePackages(packageGlobs: string): void
```

Add one or more additional package globs to the workspace.

###### `packageGlobs`<sup>Required</sup> <a name="packageGlobs" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.addWorkspacePackages.parameter.packageGlobs"></a>

- *Type:* string

paths to the package to include in the workspace (for example packages/my-package).

---

##### `composeNxRunManyCommand` <a name="composeNxRunManyCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.composeNxRunManyCommand"></a>

```typescript
public composeNxRunManyCommand(options: RunManyOptions): string[]
```

Helper to format `npx nx run-many ...` style command.

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.composeNxRunManyCommand.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---

##### `execNxRunManyCommand` <a name="execNxRunManyCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.execNxRunManyCommand"></a>

```typescript
public execNxRunManyCommand(options: RunManyOptions): string
```

Helper to format `npx nx run-many ...` style command execution in package manager.

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.execNxRunManyCommand.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.buildTask">buildTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.commitGenerated">commitGenerated</a></code> | <code>boolean</code> | Whether to commit the managed files by default. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.compileTask">compileTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.components">components</a></code> | <code>projen.Component[]</code> | Returns all the components within this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.deps">deps</a></code> | <code>projen.Dependencies</code> | Project dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.ejected">ejected</a></code> | <code>boolean</code> | Whether or not the project is being ejected. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.files">files</a></code> | <code>projen.FileBase[]</code> | All files in this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.gitattributes">gitattributes</a></code> | <code>projen.GitAttributesFile</code> | The .gitattributes file for this repository. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.gitignore">gitignore</a></code> | <code>projen.IgnoreFile</code> | .gitignore. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.logger">logger</a></code> | <code>projen.Logger</code> | Logging utilities. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.name">name</a></code> | <code>string</code> | Project name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.outdir">outdir</a></code> | <code>string</code> | Absolute output directory of this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.packageTask">packageTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.postCompileTask">postCompileTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.preCompileTask">preCompileTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.projectBuild">projectBuild</a></code> | <code>projen.ProjectBuild</code> | Manages the build process of the project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.projenCommand">projenCommand</a></code> | <code>string</code> | The command to use in order to run the projen CLI. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.root">root</a></code> | <code>projen.Project</code> | The root project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.subprojects">subprojects</a></code> | <code>projen.Project[]</code> | Returns all the subprojects within this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.tasks">tasks</a></code> | <code>projen.Tasks</code> | Project tasks. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.testTask">testTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.defaultTask">defaultTask</a></code> | <code>projen.Task</code> | This is the "default" task, the one that executes "projen". |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.initProject">initProject</a></code> | <code>projen.InitProject</code> | The options used when this project is bootstrapped via `projen new`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.parent">parent</a></code> | <code>projen.Project</code> | A parent project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.projectType">projectType</a></code> | <code>projen.ProjectType</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.autoApprove">autoApprove</a></code> | <code>projen.github.AutoApprove</code> | Auto approve set up for this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.devContainer">devContainer</a></code> | <code>projen.vscode.DevContainer</code> | Access for .devcontainer.json (used for GitHub Codespaces). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.github">github</a></code> | <code>projen.github.GitHub</code> | Access all github components. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.gitpod">gitpod</a></code> | <code>projen.Gitpod</code> | Access for Gitpod. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.vscode">vscode</a></code> | <code>projen.vscode.VsCode</code> | Access all VSCode components. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.allowLibraryDependencies">allowLibraryDependencies</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.artifactsDirectory">artifactsDirectory</a></code> | <code>string</code> | The build output directory. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.artifactsJavascriptDirectory">artifactsJavascriptDirectory</a></code> | <code>string</code> | The location of the npm tarball after build (`${artifactsDirectory}/js`). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.bundler">bundler</a></code> | <code>projen.javascript.Bundler</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.entrypoint">entrypoint</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.manifest">manifest</a></code> | <code>any</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.npmrc">npmrc</a></code> | <code>projen.javascript.NpmConfig</code> | The .npmrc file. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.package">package</a></code> | <code>projen.javascript.NodePackage</code> | API for managing the node package. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.packageManager">packageManager</a></code> | <code>projen.javascript.NodePackageManager</code> | The package manager to use. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.runScriptCommand">runScriptCommand</a></code> | <code>string</code> | The command to use to run scripts (e.g. `yarn run` or `npm run` depends on the package manager). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.autoMerge">autoMerge</a></code> | <code>projen.github.AutoMerge</code> | Component that sets up mergify for merging approved pull requests. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.buildWorkflow">buildWorkflow</a></code> | <code>projen.build.BuildWorkflow</code> | The PR build GitHub workflow. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.buildWorkflowJobId">buildWorkflowJobId</a></code> | <code>string</code> | The job ID of the build workflow. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.jest">jest</a></code> | <code>projen.javascript.Jest</code> | The Jest configuration (if enabled). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.maxNodeVersion">maxNodeVersion</a></code> | <code>string</code> | Maximum node version required by this package. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.minNodeVersion">minNodeVersion</a></code> | <code>string</code> | Minimum node.js version required by this package. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.npmignore">npmignore</a></code> | <code>projen.IgnoreFile</code> | The .npmignore file. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.prettier">prettier</a></code> | <code>projen.javascript.Prettier</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.publisher">publisher</a></code> | <code>projen.release.Publisher</code> | Package publisher. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.release">release</a></code> | <code>projen.release.Release</code> | Release management. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.upgradeWorkflow">upgradeWorkflow</a></code> | <code>projen.javascript.UpgradeDependencies</code> | The upgrade workflow. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.docsDirectory">docsDirectory</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.libdir">libdir</a></code> | <code>string</code> | The directory in which compiled .js files reside. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.srcdir">srcdir</a></code> | <code>string</code> | The directory in which the .ts sources reside. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.testdir">testdir</a></code> | <code>string</code> | The directory in which tests reside. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.tsconfigDev">tsconfigDev</a></code> | <code>projen.javascript.TypescriptConfig</code> | A typescript configuration file which covers all files (sources, tests, projen). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.watchTask">watchTask</a></code> | <code>projen.Task</code> | The "watch" task. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.docgen">docgen</a></code> | <code>boolean</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.eslint">eslint</a></code> | <code>projen.javascript.Eslint</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.tsconfig">tsconfig</a></code> | <code>projen.javascript.TypescriptConfig</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.tsconfigEslint">tsconfigEslint</a></code> | <code>projen.javascript.TypescriptConfig</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.nx">nx</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace">NxWorkspace</a></code> | Return the NxWorkspace instance. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.nxConfigurator">nxConfigurator</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator">NxConfigurator</a></code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.sortedSubProjects">sortedSubProjects</a></code> | <code>projen.Project[]</code> | Get consistently sorted list of subprojects. |

---

##### `buildTask`<sup>Required</sup> <a name="buildTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.buildTask"></a>

```typescript
public readonly buildTask: Task;
```

- *Type:* projen.Task

---

##### `commitGenerated`<sup>Required</sup> <a name="commitGenerated" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.commitGenerated"></a>

```typescript
public readonly commitGenerated: boolean;
```

- *Type:* boolean

Whether to commit the managed files by default.

---

##### `compileTask`<sup>Required</sup> <a name="compileTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.compileTask"></a>

```typescript
public readonly compileTask: Task;
```

- *Type:* projen.Task

---

##### `components`<sup>Required</sup> <a name="components" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.components"></a>

```typescript
public readonly components: Component[];
```

- *Type:* projen.Component[]

Returns all the components within this project.

---

##### `deps`<sup>Required</sup> <a name="deps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.deps"></a>

```typescript
public readonly deps: Dependencies;
```

- *Type:* projen.Dependencies

Project dependencies.

---

##### `ejected`<sup>Required</sup> <a name="ejected" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.ejected"></a>

```typescript
public readonly ejected: boolean;
```

- *Type:* boolean

Whether or not the project is being ejected.

---

##### `files`<sup>Required</sup> <a name="files" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.files"></a>

```typescript
public readonly files: FileBase[];
```

- *Type:* projen.FileBase[]

All files in this project.

---

##### `gitattributes`<sup>Required</sup> <a name="gitattributes" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.gitattributes"></a>

```typescript
public readonly gitattributes: GitAttributesFile;
```

- *Type:* projen.GitAttributesFile

The .gitattributes file for this repository.

---

##### `gitignore`<sup>Required</sup> <a name="gitignore" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.gitignore"></a>

```typescript
public readonly gitignore: IgnoreFile;
```

- *Type:* projen.IgnoreFile

.gitignore.

---

##### `logger`<sup>Required</sup> <a name="logger" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.logger"></a>

```typescript
public readonly logger: Logger;
```

- *Type:* projen.Logger

Logging utilities.

---

##### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Project name.

---

##### `outdir`<sup>Required</sup> <a name="outdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.outdir"></a>

```typescript
public readonly outdir: string;
```

- *Type:* string

Absolute output directory of this project.

---

##### `packageTask`<sup>Required</sup> <a name="packageTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.packageTask"></a>

```typescript
public readonly packageTask: Task;
```

- *Type:* projen.Task

---

##### `postCompileTask`<sup>Required</sup> <a name="postCompileTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.postCompileTask"></a>

```typescript
public readonly postCompileTask: Task;
```

- *Type:* projen.Task

---

##### `preCompileTask`<sup>Required</sup> <a name="preCompileTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.preCompileTask"></a>

```typescript
public readonly preCompileTask: Task;
```

- *Type:* projen.Task

---

##### `projectBuild`<sup>Required</sup> <a name="projectBuild" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.projectBuild"></a>

```typescript
public readonly projectBuild: ProjectBuild;
```

- *Type:* projen.ProjectBuild

Manages the build process of the project.

---

##### `projenCommand`<sup>Required</sup> <a name="projenCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.projenCommand"></a>

```typescript
public readonly projenCommand: string;
```

- *Type:* string

The command to use in order to run the projen CLI.

---

##### `root`<sup>Required</sup> <a name="root" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.root"></a>

```typescript
public readonly root: Project;
```

- *Type:* projen.Project

The root project.

---

##### `subprojects`<sup>Required</sup> <a name="subprojects" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.subprojects"></a>

```typescript
public readonly subprojects: Project[];
```

- *Type:* projen.Project[]

Returns all the subprojects within this project.

---

##### `tasks`<sup>Required</sup> <a name="tasks" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.tasks"></a>

```typescript
public readonly tasks: Tasks;
```

- *Type:* projen.Tasks

Project tasks.

---

##### `testTask`<sup>Required</sup> <a name="testTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.testTask"></a>

```typescript
public readonly testTask: Task;
```

- *Type:* projen.Task

---

##### `defaultTask`<sup>Optional</sup> <a name="defaultTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.defaultTask"></a>

```typescript
public readonly defaultTask: Task;
```

- *Type:* projen.Task

This is the "default" task, the one that executes "projen".

Undefined if
the project is being ejected.

---

##### `initProject`<sup>Optional</sup> <a name="initProject" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.initProject"></a>

```typescript
public readonly initProject: InitProject;
```

- *Type:* projen.InitProject

The options used when this project is bootstrapped via `projen new`.

It
includes the original set of options passed to the CLI and also the JSII
FQN of the project type.

---

##### `parent`<sup>Optional</sup> <a name="parent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.parent"></a>

```typescript
public readonly parent: Project;
```

- *Type:* projen.Project

A parent project.

If undefined, this is the root project.

---

##### `projectType`<sup>Required</sup> <a name="projectType" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.projectType"></a>

```typescript
public readonly projectType: ProjectType;
```

- *Type:* projen.ProjectType

---

##### `autoApprove`<sup>Optional</sup> <a name="autoApprove" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.autoApprove"></a>

```typescript
public readonly autoApprove: AutoApprove;
```

- *Type:* projen.github.AutoApprove

Auto approve set up for this project.

---

##### `devContainer`<sup>Optional</sup> <a name="devContainer" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.devContainer"></a>

```typescript
public readonly devContainer: DevContainer;
```

- *Type:* projen.vscode.DevContainer

Access for .devcontainer.json (used for GitHub Codespaces).

This will be `undefined` if devContainer boolean is false

---

##### `github`<sup>Optional</sup> <a name="github" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.github"></a>

```typescript
public readonly github: GitHub;
```

- *Type:* projen.github.GitHub

Access all github components.

This will be `undefined` for subprojects.

---

##### `gitpod`<sup>Optional</sup> <a name="gitpod" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.gitpod"></a>

```typescript
public readonly gitpod: Gitpod;
```

- *Type:* projen.Gitpod

Access for Gitpod.

This will be `undefined` if gitpod boolean is false

---

##### `vscode`<sup>Optional</sup> <a name="vscode" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.vscode"></a>

```typescript
public readonly vscode: VsCode;
```

- *Type:* projen.vscode.VsCode

Access all VSCode components.

This will be `undefined` for subprojects.

---

##### ~~`allowLibraryDependencies`~~<sup>Required</sup> <a name="allowLibraryDependencies" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.allowLibraryDependencies"></a>

- *Deprecated:* use `package.allowLibraryDependencies`

```typescript
public readonly allowLibraryDependencies: boolean;
```

- *Type:* boolean

---

##### `artifactsDirectory`<sup>Required</sup> <a name="artifactsDirectory" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.artifactsDirectory"></a>

```typescript
public readonly artifactsDirectory: string;
```

- *Type:* string

The build output directory.

An npm tarball will be created under the `js`
subdirectory. For example, if this is set to `dist` (the default), the npm
tarball will be placed under `dist/js/boom-boom-1.2.3.tg`.

---

##### `artifactsJavascriptDirectory`<sup>Required</sup> <a name="artifactsJavascriptDirectory" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.artifactsJavascriptDirectory"></a>

```typescript
public readonly artifactsJavascriptDirectory: string;
```

- *Type:* string

The location of the npm tarball after build (`${artifactsDirectory}/js`).

---

##### `bundler`<sup>Required</sup> <a name="bundler" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.bundler"></a>

```typescript
public readonly bundler: Bundler;
```

- *Type:* projen.javascript.Bundler

---

##### ~~`entrypoint`~~<sup>Required</sup> <a name="entrypoint" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.entrypoint"></a>

- *Deprecated:* use `package.entrypoint`

```typescript
public readonly entrypoint: string;
```

- *Type:* string

---

##### ~~`manifest`~~<sup>Required</sup> <a name="manifest" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.manifest"></a>

- *Deprecated:* use `package.addField(x, y)`

```typescript
public readonly manifest: any;
```

- *Type:* any

---

##### `npmrc`<sup>Required</sup> <a name="npmrc" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.npmrc"></a>

```typescript
public readonly npmrc: NpmConfig;
```

- *Type:* projen.javascript.NpmConfig

The .npmrc file.

---

##### `package`<sup>Required</sup> <a name="package" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.package"></a>

```typescript
public readonly package: NodePackage;
```

- *Type:* projen.javascript.NodePackage

API for managing the node package.

---

##### ~~`packageManager`~~<sup>Required</sup> <a name="packageManager" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.packageManager"></a>

- *Deprecated:* use `package.packageManager`

```typescript
public readonly packageManager: NodePackageManager;
```

- *Type:* projen.javascript.NodePackageManager

The package manager to use.

---

##### `runScriptCommand`<sup>Required</sup> <a name="runScriptCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.runScriptCommand"></a>

```typescript
public readonly runScriptCommand: string;
```

- *Type:* string

The command to use to run scripts (e.g. `yarn run` or `npm run` depends on the package manager).

---

##### `autoMerge`<sup>Optional</sup> <a name="autoMerge" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.autoMerge"></a>

```typescript
public readonly autoMerge: AutoMerge;
```

- *Type:* projen.github.AutoMerge

Component that sets up mergify for merging approved pull requests.

---

##### `buildWorkflow`<sup>Optional</sup> <a name="buildWorkflow" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.buildWorkflow"></a>

```typescript
public readonly buildWorkflow: BuildWorkflow;
```

- *Type:* projen.build.BuildWorkflow

The PR build GitHub workflow.

`undefined` if `buildWorkflow` is disabled.

---

##### `buildWorkflowJobId`<sup>Optional</sup> <a name="buildWorkflowJobId" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.buildWorkflowJobId"></a>

```typescript
public readonly buildWorkflowJobId: string;
```

- *Type:* string

The job ID of the build workflow.

---

##### `jest`<sup>Optional</sup> <a name="jest" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.jest"></a>

```typescript
public readonly jest: Jest;
```

- *Type:* projen.javascript.Jest

The Jest configuration (if enabled).

---

##### `maxNodeVersion`<sup>Optional</sup> <a name="maxNodeVersion" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.maxNodeVersion"></a>

```typescript
public readonly maxNodeVersion: string;
```

- *Type:* string

Maximum node version required by this package.

---

##### `minNodeVersion`<sup>Optional</sup> <a name="minNodeVersion" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.minNodeVersion"></a>

```typescript
public readonly minNodeVersion: string;
```

- *Type:* string

Minimum node.js version required by this package.

---

##### `npmignore`<sup>Optional</sup> <a name="npmignore" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.npmignore"></a>

```typescript
public readonly npmignore: IgnoreFile;
```

- *Type:* projen.IgnoreFile

The .npmignore file.

---

##### `prettier`<sup>Optional</sup> <a name="prettier" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.prettier"></a>

```typescript
public readonly prettier: Prettier;
```

- *Type:* projen.javascript.Prettier

---

##### ~~`publisher`~~<sup>Optional</sup> <a name="publisher" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.publisher"></a>

- *Deprecated:* use `release.publisher`.

```typescript
public readonly publisher: Publisher;
```

- *Type:* projen.release.Publisher

Package publisher.

This will be `undefined` if the project does not have a
release workflow.

---

##### `release`<sup>Optional</sup> <a name="release" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.release"></a>

```typescript
public readonly release: Release;
```

- *Type:* projen.release.Release

Release management.

---

##### `upgradeWorkflow`<sup>Optional</sup> <a name="upgradeWorkflow" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.upgradeWorkflow"></a>

```typescript
public readonly upgradeWorkflow: UpgradeDependencies;
```

- *Type:* projen.javascript.UpgradeDependencies

The upgrade workflow.

---

##### `docsDirectory`<sup>Required</sup> <a name="docsDirectory" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.docsDirectory"></a>

```typescript
public readonly docsDirectory: string;
```

- *Type:* string

---

##### `libdir`<sup>Required</sup> <a name="libdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.libdir"></a>

```typescript
public readonly libdir: string;
```

- *Type:* string

The directory in which compiled .js files reside.

---

##### `srcdir`<sup>Required</sup> <a name="srcdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.srcdir"></a>

```typescript
public readonly srcdir: string;
```

- *Type:* string

The directory in which the .ts sources reside.

---

##### `testdir`<sup>Required</sup> <a name="testdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.testdir"></a>

```typescript
public readonly testdir: string;
```

- *Type:* string

The directory in which tests reside.

---

##### `tsconfigDev`<sup>Required</sup> <a name="tsconfigDev" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.tsconfigDev"></a>

```typescript
public readonly tsconfigDev: TypescriptConfig;
```

- *Type:* projen.javascript.TypescriptConfig

A typescript configuration file which covers all files (sources, tests, projen).

---

##### `watchTask`<sup>Required</sup> <a name="watchTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.watchTask"></a>

```typescript
public readonly watchTask: Task;
```

- *Type:* projen.Task

The "watch" task.

---

##### `docgen`<sup>Optional</sup> <a name="docgen" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.docgen"></a>

```typescript
public readonly docgen: boolean;
```

- *Type:* boolean

---

##### `eslint`<sup>Optional</sup> <a name="eslint" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.eslint"></a>

```typescript
public readonly eslint: Eslint;
```

- *Type:* projen.javascript.Eslint

---

##### `tsconfig`<sup>Optional</sup> <a name="tsconfig" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.tsconfig"></a>

```typescript
public readonly tsconfig: TypescriptConfig;
```

- *Type:* projen.javascript.TypescriptConfig

---

##### `tsconfigEslint`<sup>Optional</sup> <a name="tsconfigEslint" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.tsconfigEslint"></a>

```typescript
public readonly tsconfigEslint: TypescriptConfig;
```

- *Type:* projen.javascript.TypescriptConfig

---

##### `nx`<sup>Required</sup> <a name="nx" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.nx"></a>

```typescript
public readonly nx: NxWorkspace;
```

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace">NxWorkspace</a>

Return the NxWorkspace instance.

This should be implemented using a getter.

---

##### `nxConfigurator`<sup>Required</sup> <a name="nxConfigurator" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.nxConfigurator"></a>

```typescript
public readonly nxConfigurator: NxConfigurator;
```

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator">NxConfigurator</a>

---

##### `sortedSubProjects`<sup>Required</sup> <a name="sortedSubProjects" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.sortedSubProjects"></a>

```typescript
public readonly sortedSubProjects: Project[];
```

- *Type:* projen.Project[]

Get consistently sorted list of subprojects.

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.DEFAULT_TASK">DEFAULT_TASK</a></code> | <code>string</code> | The name of the default task (the task executed when `projen` is run without arguments). |

---

##### `DEFAULT_TASK`<sup>Required</sup> <a name="DEFAULT_TASK" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject.property.DEFAULT_TASK"></a>

```typescript
public readonly DEFAULT_TASK: string;
```

- *Type:* string

The name of the default task (the task executed when `projen` is run without arguments).

Normally
this task should synthesize the project files.

---

### NxMonorepoPythonProject <a name="NxMonorepoPythonProject" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject"></a>

- *Implements:* <a href="#@aws-prototyping-sdk/nx-monorepo.INxProjectCore">INxProjectCore</a>

This project type will bootstrap a NX based monorepo with support for polygot builds, build caching, dependency graph visualization and much more.

#### Initializers <a name="Initializers" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.Initializer"></a>

```typescript
import { NxMonorepoPythonProject } from '@aws-prototyping-sdk/nx-monorepo'

new NxMonorepoPythonProject(options: NxMonorepoPythonProjectOptions)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.Initializer.parameter.options">options</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions">NxMonorepoPythonProjectOptions</a></code> | *No description.* |

---

##### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.Initializer.parameter.options"></a>

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProjectOptions">NxMonorepoPythonProjectOptions</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addExcludeFromCleanup">addExcludeFromCleanup</a></code> | Exclude the matching files from pre-synth cleanup. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addGitIgnore">addGitIgnore</a></code> | Adds a .gitignore pattern. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addPackageIgnore">addPackageIgnore</a></code> | Exclude these files from the bundled package. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addTask">addTask</a></code> | Adds a new task to this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addTip">addTip</a></code> | Prints a "tip" message during synthesis. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.annotateGenerated">annotateGenerated</a></code> | Marks the provided file(s) as being generated. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.postSynthesize">postSynthesize</a></code> | Called after all components are synthesized. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.preSynthesize">preSynthesize</a></code> | Called before all components are synthesized. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.removeTask">removeTask</a></code> | Removes a task from a project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.runTaskCommand">runTaskCommand</a></code> | Returns the shell command to execute in order to run a task. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.synth">synth</a></code> | Synthesize all project files into `outdir`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.tryFindFile">tryFindFile</a></code> | Finds a file at the specified relative path within this project and all its subprojects. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.tryFindJsonFile">tryFindJsonFile</a></code> | Finds a json file by name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.tryFindObjectFile">tryFindObjectFile</a></code> | Finds an object file (like JsonFile, YamlFile, etc.) by name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.tryRemoveFile">tryRemoveFile</a></code> | Finds a file at the specified relative path within this project and removes it. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addDependency">addDependency</a></code> | Adds a runtime dependency. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addDevDependency">addDevDependency</a></code> | Adds a dev dependency. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addImplicitDependency">addImplicitDependency</a></code> | Create an implicit dependency between two Projects. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addJavaDependency">addJavaDependency</a></code> | Adds a dependency between two Java Projects in the monorepo. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addNxRunManyTask">addNxRunManyTask</a></code> | Add project task that executes `npx nx run-many ...` style command. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addPythonPoetryDependency">addPythonPoetryDependency</a></code> | Adds a dependency between two Python Projects in the monorepo. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.composeNxRunManyCommand">composeNxRunManyCommand</a></code> | Helper to format `npx nx run-many ...` style command. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.execNxRunManyCommand">execNxRunManyCommand</a></code> | Helper to format `npx nx run-many ...` style command execution in package manager. |

---

##### `addExcludeFromCleanup` <a name="addExcludeFromCleanup" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addExcludeFromCleanup"></a>

```typescript
public addExcludeFromCleanup(globs: string): void
```

Exclude the matching files from pre-synth cleanup.

Can be used when, for example, some
source files include the projen marker and we don't want them to be erased during synth.

###### `globs`<sup>Required</sup> <a name="globs" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addExcludeFromCleanup.parameter.globs"></a>

- *Type:* string

The glob patterns to match.

---

##### `addGitIgnore` <a name="addGitIgnore" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addGitIgnore"></a>

```typescript
public addGitIgnore(pattern: string): void
```

Adds a .gitignore pattern.

###### `pattern`<sup>Required</sup> <a name="pattern" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addGitIgnore.parameter.pattern"></a>

- *Type:* string

The glob pattern to ignore.

---

##### `addPackageIgnore` <a name="addPackageIgnore" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addPackageIgnore"></a>

```typescript
public addPackageIgnore(_pattern: string): void
```

Exclude these files from the bundled package.

Implemented by project types based on the
packaging mechanism. For example, `NodeProject` delegates this to `.npmignore`.

###### `_pattern`<sup>Required</sup> <a name="_pattern" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addPackageIgnore.parameter._pattern"></a>

- *Type:* string

The glob pattern to exclude.

---

##### `addTask` <a name="addTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addTask"></a>

```typescript
public addTask(name: string, props?: TaskOptions): Task
```

Adds a new task to this project.

This will fail if the project already has
a task with this name.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addTask.parameter.name"></a>

- *Type:* string

The task name to add.

---

###### `props`<sup>Optional</sup> <a name="props" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addTask.parameter.props"></a>

- *Type:* projen.TaskOptions

Task properties.

---

##### ~~`addTip`~~ <a name="addTip" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addTip"></a>

```typescript
public addTip(message: string): void
```

Prints a "tip" message during synthesis.

###### `message`<sup>Required</sup> <a name="message" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addTip.parameter.message"></a>

- *Type:* string

The message.

---

##### `annotateGenerated` <a name="annotateGenerated" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.annotateGenerated"></a>

```typescript
public annotateGenerated(glob: string): void
```

Marks the provided file(s) as being generated.

This is achieved using the
github-linguist attributes. Generated files do not count against the
repository statistics and language breakdown.

> [https://github.com/github/linguist/blob/master/docs/overrides.md](https://github.com/github/linguist/blob/master/docs/overrides.md)

###### `glob`<sup>Required</sup> <a name="glob" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.annotateGenerated.parameter.glob"></a>

- *Type:* string

the glob pattern to match (could be a file path).

---

##### `postSynthesize` <a name="postSynthesize" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.postSynthesize"></a>

```typescript
public postSynthesize(): void
```

Called after all components are synthesized.

Order is *not* guaranteed.
NOTE: Be sure to ensure the VIRTUAL_ENV is unset during postSynthesize as the individual poetry envs will only be created if a existing VIRTUAL_ENV cannot be found.

##### `preSynthesize` <a name="preSynthesize" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.preSynthesize"></a>

```typescript
public preSynthesize(): void
```

Called before all components are synthesized.

##### `removeTask` <a name="removeTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.removeTask"></a>

```typescript
public removeTask(name: string): Task
```

Removes a task from a project.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.removeTask.parameter.name"></a>

- *Type:* string

The name of the task to remove.

---

##### `runTaskCommand` <a name="runTaskCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.runTaskCommand"></a>

```typescript
public runTaskCommand(task: Task): string
```

Returns the shell command to execute in order to run a task.

By default, this is `npx projen@<version> <task>`

###### `task`<sup>Required</sup> <a name="task" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.runTaskCommand.parameter.task"></a>

- *Type:* projen.Task

The task for which the command is required.

---

##### `synth` <a name="synth" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.synth"></a>

```typescript
public synth(): void
```

Synthesize all project files into `outdir`.

1. Call "this.preSynthesize()"
2. Delete all generated files
3. Synthesize all sub-projects
4. Synthesize all components of this project
5. Call "postSynthesize()" for all components of this project
6. Call "this.postSynthesize()"

##### `tryFindFile` <a name="tryFindFile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.tryFindFile"></a>

```typescript
public tryFindFile(filePath: string): FileBase
```

Finds a file at the specified relative path within this project and all its subprojects.

###### `filePath`<sup>Required</sup> <a name="filePath" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.tryFindFile.parameter.filePath"></a>

- *Type:* string

The file path.

If this path is relative, it will be resolved
from the root of _this_ project.

---

##### ~~`tryFindJsonFile`~~ <a name="tryFindJsonFile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.tryFindJsonFile"></a>

```typescript
public tryFindJsonFile(filePath: string): JsonFile
```

Finds a json file by name.

###### `filePath`<sup>Required</sup> <a name="filePath" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.tryFindJsonFile.parameter.filePath"></a>

- *Type:* string

The file path.

---

##### `tryFindObjectFile` <a name="tryFindObjectFile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.tryFindObjectFile"></a>

```typescript
public tryFindObjectFile(filePath: string): ObjectFile
```

Finds an object file (like JsonFile, YamlFile, etc.) by name.

###### `filePath`<sup>Required</sup> <a name="filePath" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.tryFindObjectFile.parameter.filePath"></a>

- *Type:* string

The file path.

---

##### `tryRemoveFile` <a name="tryRemoveFile" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.tryRemoveFile"></a>

```typescript
public tryRemoveFile(filePath: string): FileBase
```

Finds a file at the specified relative path within this project and removes it.

###### `filePath`<sup>Required</sup> <a name="filePath" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.tryRemoveFile.parameter.filePath"></a>

- *Type:* string

The file path.

If this path is relative, it will be
resolved from the root of _this_ project.

---

##### `addDependency` <a name="addDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addDependency"></a>

```typescript
public addDependency(spec: string): void
```

Adds a runtime dependency.

###### `spec`<sup>Required</sup> <a name="spec" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addDependency.parameter.spec"></a>

- *Type:* string

Format `<module>@<semver>`.

---

##### `addDevDependency` <a name="addDevDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addDevDependency"></a>

```typescript
public addDevDependency(spec: string): void
```

Adds a dev dependency.

###### `spec`<sup>Required</sup> <a name="spec" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addDevDependency.parameter.spec"></a>

- *Type:* string

Format `<module>@<semver>`.

---

##### `addImplicitDependency` <a name="addImplicitDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addImplicitDependency"></a>

```typescript
public addImplicitDependency(dependent: Project, dependee: string | Project): void
```

Create an implicit dependency between two Projects.

This is typically
used in polygot repos where a Typescript project wants a build dependency
on a Python project as an example.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addImplicitDependency.parameter.dependent"></a>

- *Type:* projen.Project

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addImplicitDependency.parameter.dependee"></a>

- *Type:* string | projen.Project

---

##### `addJavaDependency` <a name="addJavaDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addJavaDependency"></a>

```typescript
public addJavaDependency(dependent: JavaProject, dependee: JavaProject): void
```

Adds a dependency between two Java Projects in the monorepo.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addJavaDependency.parameter.dependent"></a>

- *Type:* projen.java.JavaProject

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addJavaDependency.parameter.dependee"></a>

- *Type:* projen.java.JavaProject

---

##### `addNxRunManyTask` <a name="addNxRunManyTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addNxRunManyTask"></a>

```typescript
public addNxRunManyTask(name: string, options: RunManyOptions): Task
```

Add project task that executes `npx nx run-many ...` style command.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addNxRunManyTask.parameter.name"></a>

- *Type:* string

---

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addNxRunManyTask.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---

##### `addPythonPoetryDependency` <a name="addPythonPoetryDependency" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addPythonPoetryDependency"></a>

```typescript
public addPythonPoetryDependency(dependent: PythonProject, dependee: PythonProject): void
```

Adds a dependency between two Python Projects in the monorepo.

The dependent must have Poetry enabled.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addPythonPoetryDependency.parameter.dependent"></a>

- *Type:* projen.python.PythonProject

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.addPythonPoetryDependency.parameter.dependee"></a>

- *Type:* projen.python.PythonProject

---

##### `composeNxRunManyCommand` <a name="composeNxRunManyCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.composeNxRunManyCommand"></a>

```typescript
public composeNxRunManyCommand(options: RunManyOptions): string[]
```

Helper to format `npx nx run-many ...` style command.

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.composeNxRunManyCommand.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---

##### `execNxRunManyCommand` <a name="execNxRunManyCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.execNxRunManyCommand"></a>

```typescript
public execNxRunManyCommand(options: RunManyOptions): string
```

Helper to format `npx nx run-many ...` style command execution in package manager.

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.execNxRunManyCommand.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.buildTask">buildTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.commitGenerated">commitGenerated</a></code> | <code>boolean</code> | Whether to commit the managed files by default. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.compileTask">compileTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.components">components</a></code> | <code>projen.Component[]</code> | Returns all the components within this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.deps">deps</a></code> | <code>projen.Dependencies</code> | Project dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.ejected">ejected</a></code> | <code>boolean</code> | Whether or not the project is being ejected. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.files">files</a></code> | <code>projen.FileBase[]</code> | All files in this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.gitattributes">gitattributes</a></code> | <code>projen.GitAttributesFile</code> | The .gitattributes file for this repository. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.gitignore">gitignore</a></code> | <code>projen.IgnoreFile</code> | .gitignore. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.logger">logger</a></code> | <code>projen.Logger</code> | Logging utilities. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.name">name</a></code> | <code>string</code> | Project name. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.outdir">outdir</a></code> | <code>string</code> | Absolute output directory of this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.packageTask">packageTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.postCompileTask">postCompileTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.preCompileTask">preCompileTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.projectBuild">projectBuild</a></code> | <code>projen.ProjectBuild</code> | Manages the build process of the project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.projenCommand">projenCommand</a></code> | <code>string</code> | The command to use in order to run the projen CLI. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.root">root</a></code> | <code>projen.Project</code> | The root project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.subprojects">subprojects</a></code> | <code>projen.Project[]</code> | Returns all the subprojects within this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.tasks">tasks</a></code> | <code>projen.Tasks</code> | Project tasks. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.testTask">testTask</a></code> | <code>projen.Task</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.defaultTask">defaultTask</a></code> | <code>projen.Task</code> | This is the "default" task, the one that executes "projen". |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.initProject">initProject</a></code> | <code>projen.InitProject</code> | The options used when this project is bootstrapped via `projen new`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.parent">parent</a></code> | <code>projen.Project</code> | A parent project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.projectType">projectType</a></code> | <code>projen.ProjectType</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.autoApprove">autoApprove</a></code> | <code>projen.github.AutoApprove</code> | Auto approve set up for this project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.devContainer">devContainer</a></code> | <code>projen.vscode.DevContainer</code> | Access for .devcontainer.json (used for GitHub Codespaces). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.github">github</a></code> | <code>projen.github.GitHub</code> | Access all github components. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.gitpod">gitpod</a></code> | <code>projen.Gitpod</code> | Access for Gitpod. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.vscode">vscode</a></code> | <code>projen.vscode.VsCode</code> | Access all VSCode components. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.depsManager">depsManager</a></code> | <code>projen.python.IPythonDeps</code> | API for managing dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.envManager">envManager</a></code> | <code>projen.python.IPythonEnv</code> | API for mangaging the Python runtime environment. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.moduleName">moduleName</a></code> | <code>string</code> | Python module name (the project name, with any hyphens or periods replaced with underscores). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.version">version</a></code> | <code>string</code> | Version of the package for distribution (should follow semver). |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.packagingManager">packagingManager</a></code> | <code>projen.python.IPythonPackaging</code> | API for managing packaging the project as a library. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.pytest">pytest</a></code> | <code>projen.python.Pytest</code> | Pytest component. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.nx">nx</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace">NxWorkspace</a></code> | Return the NxWorkspace instance. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.nxConfigurator">nxConfigurator</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator">NxConfigurator</a></code> | *No description.* |

---

##### `buildTask`<sup>Required</sup> <a name="buildTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.buildTask"></a>

```typescript
public readonly buildTask: Task;
```

- *Type:* projen.Task

---

##### `commitGenerated`<sup>Required</sup> <a name="commitGenerated" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.commitGenerated"></a>

```typescript
public readonly commitGenerated: boolean;
```

- *Type:* boolean

Whether to commit the managed files by default.

---

##### `compileTask`<sup>Required</sup> <a name="compileTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.compileTask"></a>

```typescript
public readonly compileTask: Task;
```

- *Type:* projen.Task

---

##### `components`<sup>Required</sup> <a name="components" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.components"></a>

```typescript
public readonly components: Component[];
```

- *Type:* projen.Component[]

Returns all the components within this project.

---

##### `deps`<sup>Required</sup> <a name="deps" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.deps"></a>

```typescript
public readonly deps: Dependencies;
```

- *Type:* projen.Dependencies

Project dependencies.

---

##### `ejected`<sup>Required</sup> <a name="ejected" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.ejected"></a>

```typescript
public readonly ejected: boolean;
```

- *Type:* boolean

Whether or not the project is being ejected.

---

##### `files`<sup>Required</sup> <a name="files" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.files"></a>

```typescript
public readonly files: FileBase[];
```

- *Type:* projen.FileBase[]

All files in this project.

---

##### `gitattributes`<sup>Required</sup> <a name="gitattributes" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.gitattributes"></a>

```typescript
public readonly gitattributes: GitAttributesFile;
```

- *Type:* projen.GitAttributesFile

The .gitattributes file for this repository.

---

##### `gitignore`<sup>Required</sup> <a name="gitignore" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.gitignore"></a>

```typescript
public readonly gitignore: IgnoreFile;
```

- *Type:* projen.IgnoreFile

.gitignore.

---

##### `logger`<sup>Required</sup> <a name="logger" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.logger"></a>

```typescript
public readonly logger: Logger;
```

- *Type:* projen.Logger

Logging utilities.

---

##### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.name"></a>

```typescript
public readonly name: string;
```

- *Type:* string

Project name.

---

##### `outdir`<sup>Required</sup> <a name="outdir" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.outdir"></a>

```typescript
public readonly outdir: string;
```

- *Type:* string

Absolute output directory of this project.

---

##### `packageTask`<sup>Required</sup> <a name="packageTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.packageTask"></a>

```typescript
public readonly packageTask: Task;
```

- *Type:* projen.Task

---

##### `postCompileTask`<sup>Required</sup> <a name="postCompileTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.postCompileTask"></a>

```typescript
public readonly postCompileTask: Task;
```

- *Type:* projen.Task

---

##### `preCompileTask`<sup>Required</sup> <a name="preCompileTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.preCompileTask"></a>

```typescript
public readonly preCompileTask: Task;
```

- *Type:* projen.Task

---

##### `projectBuild`<sup>Required</sup> <a name="projectBuild" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.projectBuild"></a>

```typescript
public readonly projectBuild: ProjectBuild;
```

- *Type:* projen.ProjectBuild

Manages the build process of the project.

---

##### `projenCommand`<sup>Required</sup> <a name="projenCommand" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.projenCommand"></a>

```typescript
public readonly projenCommand: string;
```

- *Type:* string

The command to use in order to run the projen CLI.

---

##### `root`<sup>Required</sup> <a name="root" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.root"></a>

```typescript
public readonly root: Project;
```

- *Type:* projen.Project

The root project.

---

##### `subprojects`<sup>Required</sup> <a name="subprojects" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.subprojects"></a>

```typescript
public readonly subprojects: Project[];
```

- *Type:* projen.Project[]

Returns all the subprojects within this project.

---

##### `tasks`<sup>Required</sup> <a name="tasks" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.tasks"></a>

```typescript
public readonly tasks: Tasks;
```

- *Type:* projen.Tasks

Project tasks.

---

##### `testTask`<sup>Required</sup> <a name="testTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.testTask"></a>

```typescript
public readonly testTask: Task;
```

- *Type:* projen.Task

---

##### `defaultTask`<sup>Optional</sup> <a name="defaultTask" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.defaultTask"></a>

```typescript
public readonly defaultTask: Task;
```

- *Type:* projen.Task

This is the "default" task, the one that executes "projen".

Undefined if
the project is being ejected.

---

##### `initProject`<sup>Optional</sup> <a name="initProject" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.initProject"></a>

```typescript
public readonly initProject: InitProject;
```

- *Type:* projen.InitProject

The options used when this project is bootstrapped via `projen new`.

It
includes the original set of options passed to the CLI and also the JSII
FQN of the project type.

---

##### `parent`<sup>Optional</sup> <a name="parent" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.parent"></a>

```typescript
public readonly parent: Project;
```

- *Type:* projen.Project

A parent project.

If undefined, this is the root project.

---

##### `projectType`<sup>Required</sup> <a name="projectType" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.projectType"></a>

```typescript
public readonly projectType: ProjectType;
```

- *Type:* projen.ProjectType

---

##### `autoApprove`<sup>Optional</sup> <a name="autoApprove" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.autoApprove"></a>

```typescript
public readonly autoApprove: AutoApprove;
```

- *Type:* projen.github.AutoApprove

Auto approve set up for this project.

---

##### `devContainer`<sup>Optional</sup> <a name="devContainer" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.devContainer"></a>

```typescript
public readonly devContainer: DevContainer;
```

- *Type:* projen.vscode.DevContainer

Access for .devcontainer.json (used for GitHub Codespaces).

This will be `undefined` if devContainer boolean is false

---

##### `github`<sup>Optional</sup> <a name="github" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.github"></a>

```typescript
public readonly github: GitHub;
```

- *Type:* projen.github.GitHub

Access all github components.

This will be `undefined` for subprojects.

---

##### `gitpod`<sup>Optional</sup> <a name="gitpod" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.gitpod"></a>

```typescript
public readonly gitpod: Gitpod;
```

- *Type:* projen.Gitpod

Access for Gitpod.

This will be `undefined` if gitpod boolean is false

---

##### `vscode`<sup>Optional</sup> <a name="vscode" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.vscode"></a>

```typescript
public readonly vscode: VsCode;
```

- *Type:* projen.vscode.VsCode

Access all VSCode components.

This will be `undefined` for subprojects.

---

##### `depsManager`<sup>Required</sup> <a name="depsManager" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.depsManager"></a>

```typescript
public readonly depsManager: IPythonDeps;
```

- *Type:* projen.python.IPythonDeps

API for managing dependencies.

---

##### `envManager`<sup>Required</sup> <a name="envManager" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.envManager"></a>

```typescript
public readonly envManager: IPythonEnv;
```

- *Type:* projen.python.IPythonEnv

API for mangaging the Python runtime environment.

---

##### `moduleName`<sup>Required</sup> <a name="moduleName" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.moduleName"></a>

```typescript
public readonly moduleName: string;
```

- *Type:* string

Python module name (the project name, with any hyphens or periods replaced with underscores).

---

##### `version`<sup>Required</sup> <a name="version" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.version"></a>

```typescript
public readonly version: string;
```

- *Type:* string

Version of the package for distribution (should follow semver).

---

##### `packagingManager`<sup>Optional</sup> <a name="packagingManager" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.packagingManager"></a>

```typescript
public readonly packagingManager: IPythonPackaging;
```

- *Type:* projen.python.IPythonPackaging

API for managing packaging the project as a library.

Only applies when the `projectType` is LIB.

---

##### `pytest`<sup>Optional</sup> <a name="pytest" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.pytest"></a>

```typescript
public readonly pytest: Pytest;
```

- *Type:* projen.python.Pytest

Pytest component.

---

##### `nx`<sup>Required</sup> <a name="nx" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.nx"></a>

```typescript
public readonly nx: NxWorkspace;
```

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace">NxWorkspace</a>

Return the NxWorkspace instance.

This should be implemented using a getter.

---

##### `nxConfigurator`<sup>Required</sup> <a name="nxConfigurator" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.nxConfigurator"></a>

```typescript
public readonly nxConfigurator: NxConfigurator;
```

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator">NxConfigurator</a>

---

#### Constants <a name="Constants" id="Constants"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.DEFAULT_TASK">DEFAULT_TASK</a></code> | <code>string</code> | The name of the default task (the task executed when `projen` is run without arguments). |

---

##### `DEFAULT_TASK`<sup>Required</sup> <a name="DEFAULT_TASK" id="@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject.property.DEFAULT_TASK"></a>

```typescript
public readonly DEFAULT_TASK: string;
```

- *Type:* string

The name of the default task (the task executed when `projen` is run without arguments).

Normally
this task should synthesize the project files.

---

### NxProject <a name="NxProject" id="@aws-prototyping-sdk/nx-monorepo.NxProject"></a>

Component which manages the project specific NX Config and is added to all NXMonorepo subprojects.

#### Initializers <a name="Initializers" id="@aws-prototyping-sdk/nx-monorepo.NxProject.Initializer"></a>

```typescript
import { NxProject } from '@aws-prototyping-sdk/nx-monorepo'

new NxProject(project: Project)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.Initializer.parameter.project">project</a></code> | <code>projen.Project</code> | *No description.* |

---

##### `project`<sup>Required</sup> <a name="project" id="@aws-prototyping-sdk/nx-monorepo.NxProject.Initializer.parameter.project"></a>

- *Type:* projen.Project

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.postSynthesize">postSynthesize</a></code> | Called after synthesis. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.preSynthesize">preSynthesize</a></code> | Called before synthesis. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.synthesize">synthesize</a></code> | Synthesizes files to the project output directory. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.addBuildTargetFiles">addBuildTargetFiles</a></code> | Add input and output files to build target. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.addImplicitDependency">addImplicitDependency</a></code> | Adds an implicit dependency between the dependant (this project) and dependee. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.addTag">addTag</a></code> | Add tag. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.inferTargets">inferTargets</a></code> | Automatically infer targets based on project type. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.merge">merge</a></code> | Merge configuration into existing config. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.setNamedInput">setNamedInput</a></code> | Set `namedInputs` helper. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.setTarget">setTarget</a></code> | Set `targets` helper. |

---

##### `postSynthesize` <a name="postSynthesize" id="@aws-prototyping-sdk/nx-monorepo.NxProject.postSynthesize"></a>

```typescript
public postSynthesize(): void
```

Called after synthesis.

Order is *not* guaranteed.

##### `preSynthesize` <a name="preSynthesize" id="@aws-prototyping-sdk/nx-monorepo.NxProject.preSynthesize"></a>

```typescript
public preSynthesize(): void
```

Called before synthesis.

##### `synthesize` <a name="synthesize" id="@aws-prototyping-sdk/nx-monorepo.NxProject.synthesize"></a>

```typescript
public synthesize(): void
```

Synthesizes files to the project output directory.

##### `addBuildTargetFiles` <a name="addBuildTargetFiles" id="@aws-prototyping-sdk/nx-monorepo.NxProject.addBuildTargetFiles"></a>

```typescript
public addBuildTargetFiles(inputs?: string | IInput[], outputs?: string[]): void
```

Add input and output files to build target.

###### `inputs`<sup>Optional</sup> <a name="inputs" id="@aws-prototyping-sdk/nx-monorepo.NxProject.addBuildTargetFiles.parameter.inputs"></a>

- *Type:* string | @aws-prototyping-sdk/nx-monorepo.Nx.IInput[]

Input files.

---

###### `outputs`<sup>Optional</sup> <a name="outputs" id="@aws-prototyping-sdk/nx-monorepo.NxProject.addBuildTargetFiles.parameter.outputs"></a>

- *Type:* string[]

Output files.

---

##### `addImplicitDependency` <a name="addImplicitDependency" id="@aws-prototyping-sdk/nx-monorepo.NxProject.addImplicitDependency"></a>

```typescript
public addImplicitDependency(dependee: string | Project): void
```

Adds an implicit dependency between the dependant (this project) and dependee.

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.NxProject.addImplicitDependency.parameter.dependee"></a>

- *Type:* string | projen.Project

project to add the implicit dependency on.

---

##### `addTag` <a name="addTag" id="@aws-prototyping-sdk/nx-monorepo.NxProject.addTag"></a>

```typescript
public addTag(tags: string): void
```

Add tag.

###### `tags`<sup>Required</sup> <a name="tags" id="@aws-prototyping-sdk/nx-monorepo.NxProject.addTag.parameter.tags"></a>

- *Type:* string

---

##### `inferTargets` <a name="inferTargets" id="@aws-prototyping-sdk/nx-monorepo.NxProject.inferTargets"></a>

```typescript
public inferTargets(): void
```

Automatically infer targets based on project type.

##### `merge` <a name="merge" id="@aws-prototyping-sdk/nx-monorepo.NxProject.merge"></a>

```typescript
public merge(config: ProjectConfig): void
```

Merge configuration into existing config.

###### `config`<sup>Required</sup> <a name="config" id="@aws-prototyping-sdk/nx-monorepo.NxProject.merge.parameter.config"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.ProjectConfig

---

##### `setNamedInput` <a name="setNamedInput" id="@aws-prototyping-sdk/nx-monorepo.NxProject.setNamedInput"></a>

```typescript
public setNamedInput(name: string, inputs: string[]): void
```

Set `namedInputs` helper.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxProject.setNamedInput.parameter.name"></a>

- *Type:* string

---

###### `inputs`<sup>Required</sup> <a name="inputs" id="@aws-prototyping-sdk/nx-monorepo.NxProject.setNamedInput.parameter.inputs"></a>

- *Type:* string[]

---

##### `setTarget` <a name="setTarget" id="@aws-prototyping-sdk/nx-monorepo.NxProject.setTarget"></a>

```typescript
public setTarget(name: string, target: IProjectTarget, includeDefaults?: string | boolean): void
```

Set `targets` helper.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxProject.setTarget.parameter.name"></a>

- *Type:* string

---

###### `target`<sup>Required</sup> <a name="target" id="@aws-prototyping-sdk/nx-monorepo.NxProject.setTarget.parameter.target"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget

---

###### `includeDefaults`<sup>Optional</sup> <a name="includeDefaults" id="@aws-prototyping-sdk/nx-monorepo.NxProject.setTarget.parameter.includeDefaults"></a>

- *Type:* string | boolean

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.ensure">ensure</a></code> | Retrieves an instance of NXProject if one is associated to the given project, otherwise created a NXProject instance for the project. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.of">of</a></code> | Retrieves an instance of NXProject if one is associated to the given project. |

---

##### `ensure` <a name="ensure" id="@aws-prototyping-sdk/nx-monorepo.NxProject.ensure"></a>

```typescript
import { NxProject } from '@aws-prototyping-sdk/nx-monorepo'

NxProject.ensure(project: Project)
```

Retrieves an instance of NXProject if one is associated to the given project, otherwise created a NXProject instance for the project.

###### `project`<sup>Required</sup> <a name="project" id="@aws-prototyping-sdk/nx-monorepo.NxProject.ensure.parameter.project"></a>

- *Type:* projen.Project

project instance.

---

##### `of` <a name="of" id="@aws-prototyping-sdk/nx-monorepo.NxProject.of"></a>

```typescript
import { NxProject } from '@aws-prototyping-sdk/nx-monorepo'

NxProject.of(project: Project)
```

Retrieves an instance of NXProject if one is associated to the given project.

###### `project`<sup>Required</sup> <a name="project" id="@aws-prototyping-sdk/nx-monorepo.NxProject.of.parameter.project"></a>

- *Type:* projen.Project

project instance.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.property.project">project</a></code> | <code>projen.Project</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.property.file">file</a></code> | <code>projen.JsonFile</code> | Raw json file. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.property.implicitDependencies">implicitDependencies</a></code> | <code>string[]</code> | Implicit dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.property.includedScripts">includedScripts</a></code> | <code>string[]</code> | Explicit list of scripts for Nx to include. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.property.namedInputs">namedInputs</a></code> | <code>{[ key: string ]: any}</code> | Named inputs. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.property.tags">tags</a></code> | <code>string[]</code> | Project tag annotations. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxProject.property.targets">targets</a></code> | <code>{[ key: string ]: any}</code> | Targets configuration. |

---

##### `project`<sup>Required</sup> <a name="project" id="@aws-prototyping-sdk/nx-monorepo.NxProject.property.project"></a>

```typescript
public readonly project: Project;
```

- *Type:* projen.Project

---

##### `file`<sup>Required</sup> <a name="file" id="@aws-prototyping-sdk/nx-monorepo.NxProject.property.file"></a>

```typescript
public readonly file: JsonFile;
```

- *Type:* projen.JsonFile

Raw json file.

**Attention:** any overrides applied here will not be visible
in the properties and only included in final synthesized output,
and likely to override native handling.

---

##### `implicitDependencies`<sup>Required</sup> <a name="implicitDependencies" id="@aws-prototyping-sdk/nx-monorepo.NxProject.property.implicitDependencies"></a>

```typescript
public readonly implicitDependencies: string[];
```

- *Type:* string[]

Implicit dependencies.

> [https://nx.dev/reference/project-configuration#implicitdependencies](https://nx.dev/reference/project-configuration#implicitdependencies)

---

##### `includedScripts`<sup>Required</sup> <a name="includedScripts" id="@aws-prototyping-sdk/nx-monorepo.NxProject.property.includedScripts"></a>

```typescript
public readonly includedScripts: string[];
```

- *Type:* string[]

Explicit list of scripts for Nx to include.

> [https://nx.dev/reference/project-configuration#ignoring-package.json-scripts](https://nx.dev/reference/project-configuration#ignoring-package.json-scripts)

---

##### `namedInputs`<sup>Required</sup> <a name="namedInputs" id="@aws-prototyping-sdk/nx-monorepo.NxProject.property.namedInputs"></a>

```typescript
public readonly namedInputs: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

Named inputs.

> [https://nx.dev/reference/nx-json#inputs-&-namedinputs](https://nx.dev/reference/nx-json#inputs-&-namedinputs)

---

##### `tags`<sup>Required</sup> <a name="tags" id="@aws-prototyping-sdk/nx-monorepo.NxProject.property.tags"></a>

```typescript
public readonly tags: string[];
```

- *Type:* string[]

Project tag annotations.

> [https://nx.dev/reference/project-configuration#tags](https://nx.dev/reference/project-configuration#tags)

---

##### `targets`<sup>Required</sup> <a name="targets" id="@aws-prototyping-sdk/nx-monorepo.NxProject.property.targets"></a>

```typescript
public readonly targets: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

Targets configuration.

> [https://nx.dev/reference/project-configuration](https://nx.dev/reference/project-configuration)

---


### NxWorkspace <a name="NxWorkspace" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace"></a>

Component which manages the workspace specific NX Config for the root monorepo.

#### Initializers <a name="Initializers" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.Initializer"></a>

```typescript
import { NxWorkspace } from '@aws-prototyping-sdk/nx-monorepo'

new NxWorkspace(project: Project)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.Initializer.parameter.project">project</a></code> | <code>projen.Project</code> | *No description.* |

---

##### `project`<sup>Required</sup> <a name="project" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.Initializer.parameter.project"></a>

- *Type:* projen.Project

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.postSynthesize">postSynthesize</a></code> | Called after synthesis. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.preSynthesize">preSynthesize</a></code> | Called before synthesis. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.synthesize">synthesize</a></code> | Synthesizes files to the project output directory. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.setNamedInput">setNamedInput</a></code> | Set `namedInput` value helper. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.setTargetDefault">setTargetDefault</a></code> | Set `targetDefaults` helper. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.useNxCloud">useNxCloud</a></code> | Setup workspace to use nx-cloud. |

---

##### `postSynthesize` <a name="postSynthesize" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.postSynthesize"></a>

```typescript
public postSynthesize(): void
```

Called after synthesis.

Order is *not* guaranteed.

##### `preSynthesize` <a name="preSynthesize" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.preSynthesize"></a>

```typescript
public preSynthesize(): void
```

Called before synthesis.

##### `synthesize` <a name="synthesize" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.synthesize"></a>

```typescript
public synthesize(): void
```

Synthesizes files to the project output directory.

##### `setNamedInput` <a name="setNamedInput" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.setNamedInput"></a>

```typescript
public setNamedInput(name: string, inputs: string[]): void
```

Set `namedInput` value helper.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.setNamedInput.parameter.name"></a>

- *Type:* string

---

###### `inputs`<sup>Required</sup> <a name="inputs" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.setNamedInput.parameter.inputs"></a>

- *Type:* string[]

---

##### `setTargetDefault` <a name="setTargetDefault" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.setTargetDefault"></a>

```typescript
public setTargetDefault(name: string, target: IProjectTarget, merge?: boolean): void
```

Set `targetDefaults` helper.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.setTargetDefault.parameter.name"></a>

- *Type:* string

---

###### `target`<sup>Required</sup> <a name="target" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.setTargetDefault.parameter.target"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget

---

###### `merge`<sup>Optional</sup> <a name="merge" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.setTargetDefault.parameter.merge"></a>

- *Type:* boolean

---

##### `useNxCloud` <a name="useNxCloud" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.useNxCloud"></a>

```typescript
public useNxCloud(readOnlyAccessToken: string): void
```

Setup workspace to use nx-cloud.

###### `readOnlyAccessToken`<sup>Required</sup> <a name="readOnlyAccessToken" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.useNxCloud.parameter.readOnlyAccessToken"></a>

- *Type:* string

---

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.of">of</a></code> | Retrieves the singleton instance associated with project root. |

---

##### `of` <a name="of" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.of"></a>

```typescript
import { NxWorkspace } from '@aws-prototyping-sdk/nx-monorepo'

NxWorkspace.of(scope: Project)
```

Retrieves the singleton instance associated with project root.

###### `scope`<sup>Required</sup> <a name="scope" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.of.parameter.scope"></a>

- *Type:* projen.Project

project instance.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.project">project</a></code> | <code>projen.Project</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.nxIgnore">nxIgnore</a></code> | <code>projen.IgnoreFile</code> | .nxignore file. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.nxJson">nxJson</a></code> | <code>projen.JsonFile</code> | Raw nx.json file to support overrides that aren't handled directly. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.affected">affected</a></code> | <code>@aws-prototyping-sdk/nx-monorepo.Nx.INxAffectedConfig</code> | Default options for `nx affected`. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.autoInferProjectTargets">autoInferProjectTargets</a></code> | <code>boolean</code> | Automatically infer NxProject targets based on project type. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.cacheableOperations">cacheableOperations</a></code> | <code>string[]</code> | List of cacheable operations. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.defaultTaskRunner">defaultTaskRunner</a></code> | <code>string</code> | Default task runner. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.defaultTaskRunnerOptions">defaultTaskRunnerOptions</a></code> | <code>{[ key: string ]: any}</code> | Default task runner options. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.extends">extends</a></code> | <code>string</code> | Some presets use the extends property to hide some default options in a separate json file. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.namedInputs">namedInputs</a></code> | <code>{[ key: string ]: string[]}</code> | Named inputs. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.nonNativeHasher">nonNativeHasher</a></code> | <code>boolean</code> | Indicates if non-native nx hasher will be used. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.npmScope">npmScope</a></code> | <code>string</code> | Tells Nx what prefix to use when generating library imports. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.plugins">plugins</a></code> | <code>string[]</code> | Plugins for extending the project graph. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.pluginsConfig">pluginsConfig</a></code> | <code>{[ key: string ]: any}</code> | Configuration for Nx Plugins. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.targetDefaults">targetDefaults</a></code> | <code>{[ key: string ]: @aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget}</code> | Dependencies between different target names across all projects. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.tasksRunnerOptions">tasksRunnerOptions</a></code> | <code>{[ key: string ]: any}</code> | Task runner options. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.cacheDirectory">cacheDirectory</a></code> | <code>string</code> | Override the default nx cacheDirectory. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.workspaceLayout">workspaceLayout</a></code> | <code>@aws-prototyping-sdk/nx-monorepo.Nx.IWorkspaceLayout</code> | Where new apps + libs should be placed. |

---

##### `project`<sup>Required</sup> <a name="project" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.project"></a>

```typescript
public readonly project: Project;
```

- *Type:* projen.Project

---

##### `nxIgnore`<sup>Required</sup> <a name="nxIgnore" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.nxIgnore"></a>

```typescript
public readonly nxIgnore: IgnoreFile;
```

- *Type:* projen.IgnoreFile

.nxignore file.

---

##### `nxJson`<sup>Required</sup> <a name="nxJson" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.nxJson"></a>

```typescript
public readonly nxJson: JsonFile;
```

- *Type:* projen.JsonFile

Raw nx.json file to support overrides that aren't handled directly.

**Attention:** any overrides applied here will not be visible
in the properties and only included in final synthesized output,
and likely to override native handling.

---

##### `affected`<sup>Required</sup> <a name="affected" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.affected"></a>

```typescript
public readonly affected: INxAffectedConfig;
```

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.INxAffectedConfig

Default options for `nx affected`.

---

##### `autoInferProjectTargets`<sup>Required</sup> <a name="autoInferProjectTargets" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.autoInferProjectTargets"></a>

```typescript
public readonly autoInferProjectTargets: boolean;
```

- *Type:* boolean

Automatically infer NxProject targets based on project type.

---

##### `cacheableOperations`<sup>Required</sup> <a name="cacheableOperations" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.cacheableOperations"></a>

```typescript
public readonly cacheableOperations: string[];
```

- *Type:* string[]

List of cacheable operations.

---

##### `defaultTaskRunner`<sup>Required</sup> <a name="defaultTaskRunner" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.defaultTaskRunner"></a>

```typescript
public readonly defaultTaskRunner: string;
```

- *Type:* string

Default task runner.

---

##### `defaultTaskRunnerOptions`<sup>Required</sup> <a name="defaultTaskRunnerOptions" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.defaultTaskRunnerOptions"></a>

```typescript
public readonly defaultTaskRunnerOptions: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

Default task runner options.

---

##### `extends`<sup>Required</sup> <a name="extends" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.extends"></a>

```typescript
public readonly extends: string;
```

- *Type:* string
- *Default:* "nx/presets/npm.json"

Some presets use the extends property to hide some default options in a separate json file.

The json file specified in the extends property is located in your node_modules folder.
The Nx preset files are specified in the nx package.

---

##### `namedInputs`<sup>Required</sup> <a name="namedInputs" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.namedInputs"></a>

```typescript
public readonly namedInputs: {[ key: string ]: string[]};
```

- *Type:* {[ key: string ]: string[]}

Named inputs.

> [https://nx.dev/reference/nx-json#inputs-&-namedinputs](https://nx.dev/reference/nx-json#inputs-&-namedinputs)

---

##### `nonNativeHasher`<sup>Required</sup> <a name="nonNativeHasher" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.nonNativeHasher"></a>

```typescript
public readonly nonNativeHasher: boolean;
```

- *Type:* boolean

Indicates if non-native nx hasher will be used.

If true, the NX_NON_NATIVE_HASHER env var will be set
to true for all project tasks.

---

##### `npmScope`<sup>Required</sup> <a name="npmScope" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.npmScope"></a>

```typescript
public readonly npmScope: string;
```

- *Type:* string

Tells Nx what prefix to use when generating library imports.

---

##### `plugins`<sup>Required</sup> <a name="plugins" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.plugins"></a>

```typescript
public readonly plugins: string[];
```

- *Type:* string[]

Plugins for extending the project graph.

---

##### `pluginsConfig`<sup>Required</sup> <a name="pluginsConfig" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.pluginsConfig"></a>

```typescript
public readonly pluginsConfig: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

Configuration for Nx Plugins.

---

##### `targetDefaults`<sup>Required</sup> <a name="targetDefaults" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.targetDefaults"></a>

```typescript
public readonly targetDefaults: {[ key: string ]: IProjectTarget};
```

- *Type:* {[ key: string ]: @aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget}

Dependencies between different target names across all projects.

> [https://nx.dev/reference/nx-json#target-defaults](https://nx.dev/reference/nx-json#target-defaults)

---

##### `tasksRunnerOptions`<sup>Required</sup> <a name="tasksRunnerOptions" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.tasksRunnerOptions"></a>

```typescript
public readonly tasksRunnerOptions: {[ key: string ]: any};
```

- *Type:* {[ key: string ]: any}

Task runner options.

---

##### `cacheDirectory`<sup>Optional</sup> <a name="cacheDirectory" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.cacheDirectory"></a>

```typescript
public readonly cacheDirectory: string;
```

- *Type:* string

Override the default nx cacheDirectory.

---

##### `workspaceLayout`<sup>Optional</sup> <a name="workspaceLayout" id="@aws-prototyping-sdk/nx-monorepo.NxWorkspace.property.workspaceLayout"></a>

```typescript
public readonly workspaceLayout: IWorkspaceLayout;
```

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.IWorkspaceLayout

Where new apps + libs should be placed.

---


## Protocols <a name="Protocols" id="Protocols"></a>

### IInput <a name="IInput" id="@aws-prototyping-sdk/nx-monorepo.Nx.IInput"></a>

- *Implemented By:* @aws-prototyping-sdk/nx-monorepo.Nx.IInput


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.IInput.property.env">env</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.IInput.property.fileset">fileset</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.IInput.property.runtime">runtime</a></code> | <code>string</code> | *No description.* |

---

##### `env`<sup>Optional</sup> <a name="env" id="@aws-prototyping-sdk/nx-monorepo.Nx.IInput.property.env"></a>

```typescript
public readonly env: string;
```

- *Type:* string

---

##### `fileset`<sup>Optional</sup> <a name="fileset" id="@aws-prototyping-sdk/nx-monorepo.Nx.IInput.property.fileset"></a>

```typescript
public readonly fileset: string;
```

- *Type:* string

---

##### `runtime`<sup>Optional</sup> <a name="runtime" id="@aws-prototyping-sdk/nx-monorepo.Nx.IInput.property.runtime"></a>

```typescript
public readonly runtime: string;
```

- *Type:* string

---

### INxAffectedConfig <a name="INxAffectedConfig" id="@aws-prototyping-sdk/nx-monorepo.Nx.INxAffectedConfig"></a>

- *Implemented By:* @aws-prototyping-sdk/nx-monorepo.Nx.INxAffectedConfig

Default options for `nx affected`.

> [https://github.com/nrwl/nx/blob/065477610605d5799babc3ba78f26cdfe8737250/packages/nx/src/config/nx-json.ts#L16](https://github.com/nrwl/nx/blob/065477610605d5799babc3ba78f26cdfe8737250/packages/nx/src/config/nx-json.ts#L16)


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.INxAffectedConfig.property.defaultBase">defaultBase</a></code> | <code>string</code> | Default based branch used by affected commands. |

---

##### `defaultBase`<sup>Optional</sup> <a name="defaultBase" id="@aws-prototyping-sdk/nx-monorepo.Nx.INxAffectedConfig.property.defaultBase"></a>

```typescript
public readonly defaultBase: string;
```

- *Type:* string

Default based branch used by affected commands.

---

### INxProjectCore <a name="INxProjectCore" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore"></a>

- *Implemented By:* <a href="#@aws-prototyping-sdk/nx-monorepo.NxConfigurator">NxConfigurator</a>, <a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoJavaProject">NxMonorepoJavaProject</a>, <a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoProject">NxMonorepoProject</a>, <a href="#@aws-prototyping-sdk/nx-monorepo.NxMonorepoPythonProject">NxMonorepoPythonProject</a>, <a href="#@aws-prototyping-sdk/nx-monorepo.INxProjectCore">INxProjectCore</a>

Interface that all NXProject implementations should implement.

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addImplicitDependency">addImplicitDependency</a></code> | Create an implicit dependency between two Projects. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addJavaDependency">addJavaDependency</a></code> | Adds a dependency between two Java Projects in the monorepo. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addNxRunManyTask">addNxRunManyTask</a></code> | Add project task that executes `npx nx run-many ...` style command. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addPythonPoetryDependency">addPythonPoetryDependency</a></code> | Adds a dependency between two Python Projects in the monorepo. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.INxProjectCore.composeNxRunManyCommand">composeNxRunManyCommand</a></code> | Helper to format `npx nx run-many ...` style command. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.INxProjectCore.execNxRunManyCommand">execNxRunManyCommand</a></code> | Helper to format `npx nx run-many ...` style command execution in package manager. |

---

##### `addImplicitDependency` <a name="addImplicitDependency" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addImplicitDependency"></a>

```typescript
public addImplicitDependency(dependent: Project, dependee: string | Project): void
```

Create an implicit dependency between two Projects.

This is typically
used in polygot repos where a Typescript project wants a build dependency
on a Python project as an example.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addImplicitDependency.parameter.dependent"></a>

- *Type:* projen.Project

project you want to have the dependency.

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addImplicitDependency.parameter.dependee"></a>

- *Type:* string | projen.Project

project you wish to depend on.

---

##### `addJavaDependency` <a name="addJavaDependency" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addJavaDependency"></a>

```typescript
public addJavaDependency(dependent: JavaProject, dependee: JavaProject): void
```

Adds a dependency between two Java Projects in the monorepo.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addJavaDependency.parameter.dependent"></a>

- *Type:* projen.java.JavaProject

project you want to have the dependency.

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addJavaDependency.parameter.dependee"></a>

- *Type:* projen.java.JavaProject

project you wish to depend on.

---

##### `addNxRunManyTask` <a name="addNxRunManyTask" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addNxRunManyTask"></a>

```typescript
public addNxRunManyTask(name: string, options: RunManyOptions): Task
```

Add project task that executes `npx nx run-many ...` style command.

###### `name`<sup>Required</sup> <a name="name" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addNxRunManyTask.parameter.name"></a>

- *Type:* string

task name.

---

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addNxRunManyTask.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

options.

---

##### `addPythonPoetryDependency` <a name="addPythonPoetryDependency" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addPythonPoetryDependency"></a>

```typescript
public addPythonPoetryDependency(dependent: PythonProject, dependee: PythonProject): void
```

Adds a dependency between two Python Projects in the monorepo.

The dependent must have Poetry enabled.

###### `dependent`<sup>Required</sup> <a name="dependent" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addPythonPoetryDependency.parameter.dependent"></a>

- *Type:* projen.python.PythonProject

project you want to have the dependency (must be a Poetry Python Project).

---

###### `dependee`<sup>Required</sup> <a name="dependee" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.addPythonPoetryDependency.parameter.dependee"></a>

- *Type:* projen.python.PythonProject

project you wish to depend on.

---

##### `composeNxRunManyCommand` <a name="composeNxRunManyCommand" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.composeNxRunManyCommand"></a>

```typescript
public composeNxRunManyCommand(options: RunManyOptions): string[]
```

Helper to format `npx nx run-many ...` style command.

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.composeNxRunManyCommand.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---

##### `execNxRunManyCommand` <a name="execNxRunManyCommand" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.execNxRunManyCommand"></a>

```typescript
public execNxRunManyCommand(options: RunManyOptions): string
```

Helper to format `npx nx run-many ...` style command execution in package manager.

###### `options`<sup>Required</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.execNxRunManyCommand.parameter.options"></a>

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.RunManyOptions

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.INxProjectCore.property.nx">nx</a></code> | <code><a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace">NxWorkspace</a></code> | Return the NxWorkspace instance. |

---

##### `nx`<sup>Required</sup> <a name="nx" id="@aws-prototyping-sdk/nx-monorepo.INxProjectCore.property.nx"></a>

```typescript
public readonly nx: NxWorkspace;
```

- *Type:* <a href="#@aws-prototyping-sdk/nx-monorepo.NxWorkspace">NxWorkspace</a>

Return the NxWorkspace instance.

This should be implemented using a getter.

---

### IProjectTarget <a name="IProjectTarget" id="@aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget"></a>

- *Implemented By:* @aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget

Project Target.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget.property.dependsOn">dependsOn</a></code> | <code>string \| @aws-prototyping-sdk/nx-monorepo.Nx.ITargetDependency[]</code> | List of Target Dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget.property.executor">executor</a></code> | <code>string</code> | The function that Nx will invoke when you run this target. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget.property.inputs">inputs</a></code> | <code>string \| @aws-prototyping-sdk/nx-monorepo.Nx.IInput[]</code> | List of inputs to hash for cache key, relative to the root of the monorepo. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget.property.options">options</a></code> | <code>any</code> | Contains whatever configuration properties the executor needs to run. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget.property.outputs">outputs</a></code> | <code>string[]</code> | List of outputs to cache, relative to the root of the monorepo. |

---

##### `dependsOn`<sup>Optional</sup> <a name="dependsOn" id="@aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget.property.dependsOn"></a>

```typescript
public readonly dependsOn: string | ITargetDependency[];
```

- *Type:* string | @aws-prototyping-sdk/nx-monorepo.Nx.ITargetDependency[]

List of Target Dependencies.

---

##### `executor`<sup>Optional</sup> <a name="executor" id="@aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget.property.executor"></a>

```typescript
public readonly executor: string;
```

- *Type:* string

The function that Nx will invoke when you run this target.

---

##### `inputs`<sup>Optional</sup> <a name="inputs" id="@aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget.property.inputs"></a>

```typescript
public readonly inputs: string | IInput[];
```

- *Type:* string | @aws-prototyping-sdk/nx-monorepo.Nx.IInput[]

List of inputs to hash for cache key, relative to the root of the monorepo.

note: must start with leading /

---

##### `options`<sup>Optional</sup> <a name="options" id="@aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget.property.options"></a>

```typescript
public readonly options: any;
```

- *Type:* any

Contains whatever configuration properties the executor needs to run.

---

##### `outputs`<sup>Optional</sup> <a name="outputs" id="@aws-prototyping-sdk/nx-monorepo.Nx.IProjectTarget.property.outputs"></a>

```typescript
public readonly outputs: string[];
```

- *Type:* string[]

List of outputs to cache, relative to the root of the monorepo.

note: must start with leading /

---

### ITargetDependency <a name="ITargetDependency" id="@aws-prototyping-sdk/nx-monorepo.Nx.ITargetDependency"></a>

- *Implemented By:* @aws-prototyping-sdk/nx-monorepo.Nx.ITargetDependency

Represents an NX Target Dependency.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.ITargetDependency.property.projects">projects</a></code> | <code>@aws-prototyping-sdk/nx-monorepo.Nx.TargetDependencyProject</code> | Target dependencies. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.ITargetDependency.property.target">target</a></code> | <code>string</code> | Projen target i.e: build, test, etc. |

---

##### `projects`<sup>Required</sup> <a name="projects" id="@aws-prototyping-sdk/nx-monorepo.Nx.ITargetDependency.property.projects"></a>

```typescript
public readonly projects: TargetDependencyProject;
```

- *Type:* @aws-prototyping-sdk/nx-monorepo.Nx.TargetDependencyProject

Target dependencies.

---

##### `target`<sup>Required</sup> <a name="target" id="@aws-prototyping-sdk/nx-monorepo.Nx.ITargetDependency.property.target"></a>

```typescript
public readonly target: string;
```

- *Type:* string

Projen target i.e: build, test, etc.

---

### IWorkspaceLayout <a name="IWorkspaceLayout" id="@aws-prototyping-sdk/nx-monorepo.Nx.IWorkspaceLayout"></a>

- *Implemented By:* @aws-prototyping-sdk/nx-monorepo.Nx.IWorkspaceLayout

Where new apps + libs should be placed.


#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.IWorkspaceLayout.property.appsDir">appsDir</a></code> | <code>string</code> | *No description.* |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.IWorkspaceLayout.property.libsDir">libsDir</a></code> | <code>string</code> | *No description.* |

---

##### `appsDir`<sup>Required</sup> <a name="appsDir" id="@aws-prototyping-sdk/nx-monorepo.Nx.IWorkspaceLayout.property.appsDir"></a>

```typescript
public readonly appsDir: string;
```

- *Type:* string

---

##### `libsDir`<sup>Required</sup> <a name="libsDir" id="@aws-prototyping-sdk/nx-monorepo.Nx.IWorkspaceLayout.property.libsDir"></a>

```typescript
public readonly libsDir: string;
```

- *Type:* string

---

## Enums <a name="Enums" id="Enums"></a>

### TargetDependencyProject <a name="TargetDependencyProject" id="@aws-prototyping-sdk/nx-monorepo.Nx.TargetDependencyProject"></a>

Supported enums for a TargetDependency.

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.TargetDependencyProject.SELF">SELF</a></code> | Only rely on the package where the target is called. |
| <code><a href="#@aws-prototyping-sdk/nx-monorepo.Nx.TargetDependencyProject.DEPENDENCIES">DEPENDENCIES</a></code> | Target relies on executing the target against all dependencies first. |

---

##### `SELF` <a name="SELF" id="@aws-prototyping-sdk/nx-monorepo.Nx.TargetDependencyProject.SELF"></a>

Only rely on the package where the target is called.

This is usually done for test like targets where you only want to run unit
tests on the target packages without testing all dependent packages.

---


##### `DEPENDENCIES` <a name="DEPENDENCIES" id="@aws-prototyping-sdk/nx-monorepo.Nx.TargetDependencyProject.DEPENDENCIES"></a>

Target relies on executing the target against all dependencies first.

This is usually done for build like targets where you want to build all
dependant projects first.

---

